== Changelog ==

= 6.60 17.07.2025 =
* New. BlockServerRequirements. Added a block with the Server Requirements output
* Mod. BlockServerRequirements. Changed in layout, title, link to the article
* Fix. Code. URLs collecting. Probably fatal error fixed due JSON decoding.
* Fix. Code. EmailEncoder.php. Probably fatal fixed on JSON decoding due null passed as decoded emails array on logging.
* New. Integration. Integration with the SureForms plugin
* Fix. BlockServerRequirements. Style edits
* Fix. BlockServerRequirements. Adding information about requirements to a class, changing access to the Requirements variable
* New. Integration. Integration with SureForms, a new approach to rest integrations
* Fix. Integration. AjaxLogin integration fixed.
* New. FluentCommunity. Skipping a request from the login form
* Fix. Integrations. Newsletter. Fixed warning on acces array offset.
* Fix. FirewallModule. Added a hook to set special cookie "apbct_firewall_die" to skip page caching.
* Fix. Integration. Ninja Forms. Fields collection fixed.
* Fix. Integration. WP Forms. Fields collection fixed.
* Mod. SureForms. Separate implementation of rest route interception, editing of block message output
* Fix. SFW. Skip check on probably missed tables due update process.
* Fix. Code. Code direct call preventing.
* Fix. Alt sessions. Incoming data validation.
* Fix. API. Restored missed first param $url on callback action checkResponse to avoid secound param $method_name missing.
* Fix. SureForms. Edits based on the review
* Fix. Integrations. JS. Do not handle onSubmit middleware for the Events Calendar search form.
* Fix. DB. Table "cleantalk_sessions". If table index is incorrect then recreate the table via updater due update to v6.60.

= 6.59 03.07.2025 =
* Upd. Tests. Reorganizing the file structure of the tests folder
* New. PhpUnit. A separate script for calculating coverage
* Mod. Git. Added a file coverage.txt to gitignore
* Fix. Coverage. Removed the coverage calculation
* Mod. ShortCodeSkipEncode. Removing the shortcut functionality for skipping from encoding
* Fix. ShortCodeSkipEncode. Editing text insertion
* Fix. ShortCodeSkipEncode. Removing the skip test from coding
* Fix. Integrations. Update woocommerce nickname gathering.
* Fix. Integration. Cover-style protection adapted for Zoho iframes.
* Fix. Clear $_POST service fields after basecall.
* Fix. Integration. Fluent form steps ignore.
* Fix. Honeypot. Hidden input for search form fixed.
* Fix. Helper. ToUTF8. Fix nullable case of pregmatch.
* New. Integration. Mailchimp embed forms. Form values replacement adapted.
* New. Hook. Filter user roles who can see the dashboard widget.
* Mod. RequirementsChecker. Nested check allow_url_fopen dependent on cURL
* Ref. Integrations. Updated wp-json handler.
* Fix. Skip check. Added entry point for breakdance forms.
* New. Integration. QuickCal integration protection implemented.
* New. Integrations. RegistrationMagic plugin - prtotect registration.
* Fix. LoginIPKeeper. Handled fatal error case when user meta returns non- array values.
* Fix. JS. Removed AJAX call "apbct_set_important_parameters" handlers.
* Code. EmailEncoder. Encoder. Errors layout refactored.
* Fix. Integrations. Fixed CSCF nickname gathering.
* Fix. EmailEncoder. Encoder. Do not use SSL for logged in user on any page, even if encoded via hook.
* Fix. AntiCrawler. Fixed setCookie statement.
* New. Cloud service. Ability to change regional cloud servers implemented.
* Code. Constants handler implemented.
* Code. Constants "skip_anticrawler_on_rss_feed" and "set_ajax_route_type" are adapted to ServiceConstants class.
* New. Common. Do not exclude no-email requests if constant "APBCT_SERVICE__DISABLE_EMPTY_EMAIL_EXCEPTION".
* Fix. Integration. AjaxLogin integration fixed.
* Fix. CheckServerRequirements. Style css edit
* Fix. WPForms. Editing the username receipt

= 6.58.1 20.06.2025 =
* Fix. Honeypot. Hidden input for search form fixed.

= 6.58 18.06.2025 =
* Upd. Settings. Updated hosting license flow.
* Upd. Remote Calls. Debug call improved - show alt. sessions status.
* Mod. AJAXService. Separating hack connections into a separate class, editing no_priv, renaming the function to AJAXService.
* Fix. Encoder. Encoding content by hooks fixed.
* Fix. Honeypot. Remove label for the Wave validator compatibility.
* Fix. Honeypot. Aria attribute added for label tag.
* Fix. Integration. WP Forms integration protection fixed.
* Fix. Integration. Forminator protection improved.

= 6.57.2 09.06.2025 =
* Fix. Integration. WP Forms integration protection fixed.

= 6.57.1 06.06.2025 =
* Fix. Encoder. Encoding content by hooks fixed.

= 6.57 05.06.2025 =
New. Integration. Chatway Live Chat. Protected via iframe coverage.
New. Integration. Login Signup/Popup registration protection implemented.
New. Integrations. All-in-one chat.
New. EmailEncoder. Shortcode to exclude data from encoding. Lot of refactoring.
New. User/Comment checker. New class LoginIPKeeper implemented to keep spammer IP address even if spammer session is expired.
New. Code. Added links to support and an article in help.
Upd. Integrations. Move wpforms integration to separate class.
Mod. EmailEncoder. Long description updated.
Fix. Alt sessions. Missed data last_update fixed.
Fix. External forms. Outside iframe check. Validate result before final actions.
Fix. Integrations. Fixed forminator nickname gathering.

= 6.56 22.05.2025 =
* Upd. PublicScripts. Update bot detector script enqueueing to use wp_enqueue_script with proper parameters for improved performance and compatibility.
* Ref. WPSearch. Class integration for WP Search
* Upd. Cron. Update flow to prevent object cache.
* New. Options. Gravity Forms spam entries saving option implemented.
* New. Integration. Newsletter plugin integration implemented.
* Fix. Encoder. Dropping attributes contains emails fixed.
* New. Integration. BuddyBoss app REST api protection implemented.
* Upd. Search forms. Integration by class. Meta and cpam check method moved to the class.
* New. Integration. Chaty. Contact form.
* New. Integration. Chaty. Whatsapp form now works via external forms.
* Fix. External forms. Force protection. AJAX action cleantalk_force_ajax_check added to skip signs to make the integration class work.
* Fix. Encoder. Encoding via buffer fixed.
* Upd. Footer. Everest Forms cross-link added.
* Fix. Integration. Easy Digital Downloads. Skip check on built-in email verification.
* New. Integration. WPZOOM forms.
* Fix. Email encoder. Exclude attribute data-et-multi-view from encoding.
* Fix. Integration. Avada Fusion Builder. Reformated JSON response.
* Fix. Honeypot. Search form handling fixed.
* Fix. Encoder. Integration for excluding some service data encoding on SureCart plugin implemented.
* Fix. Encoder. Setting description fixed.
* New. ServeChecker. A class for checking server variables and implementing a non-compliance banner during installation
* Fix. Activator. Deleting an unnecessary call, making code edits
* Fix. AdminNotices. Deleting an extra paragraph
* Fix. Force protection. Condition logic fixed.
* Fix. Force protection. Encoding-decoding stability improved.
* Fix. Force protection. Checking option into constructor implemented.
* Upd. Sessions. Update storage.
* Upd. Settings. Using level for banners from cloud.
* Fix. AdminSettings. Removing unnecessary js code
* Fix. Settings. Editing the display of the About block in Whitelabel mode

= 6.55 24.04.2025 =
* New. Contact data encoder. New encoder state form in settings.
* New. Contact data encoder. Phone number encoding implemented.
* New. Integration. Appointment Booking Calendar.
* New. Settings. Added the footer.
* Mod. Email Encoder. Added underline for replaced text in replace mode.
* Mod. Email Encoder. Statuses of features are disabled if the encoder is fully turned off.
* Mod. Settings. Updates for text the "Set cookies" option.
* Mod. Settings: Changed API key field description and behavior.
* Fix. SFW. The check now runs on `init` hook to fix "load_text_domain" error.
* Fix. Enqueue. Added `allow_url_fopen` check before processing script paths.
* Fix. Integrations. Improved email validation in Ninja Forms
* Fix. Integrations. Enhanced Zoho spam check flow
* Fix. Integrations. Added 'activehosted.com' support in form handling
* Fix. Code. Enqueue. External bot detector script turned back to standard WP enqueuing way.
* Upd. Anti-Crawler. Excluded feed requests.

= 6.54 10.04.2025 =
* New. Code. Enqueue scripts via specialized handler.
* New. Settings. Email Encoder. Now the obfuscation way can be selected (blur/obf/replace).
* Fix. ExternalForms. Excluding the creation of a textarea with the value of the submit attribute.
* Fix. Integrations. Fixed gravity form flow.
* Fix. Integrations. Fixed vikrentcar and vikbooking.
* Fix. Integrations. Fixed wspsc add cart.
* Fix. Integrations. Fixed zoho form flow.
* Fix. Integrations. Rollback preventDefault action.
* Fix. UsersScan. Added check for ct_role existence in user data before processing.
* Ref. Email Encoder. Obfuscation refactored.
* Upd. Integrations. Added spam check for buddyboss edit.
* Upd. Integrations. Ninja forms. Now integration can provide additional email addresses array via GetFieldsAnyDto.

= 6.53 27.03.2025 =
* New. Integration. Event Manager - booking form
* New. Integration. Smart Quiz Builder integration
* New. Integration. Brave PopUp Pro integration implemented.
* Code. Psalm. Fixed all taint issues.
* Fix. Cookies. Page hits and site referrer pararms gain fixed.
* Fix. Cookies. Count in forced alt cookies state on page_hits gain.
* Fix. Cookies. Site referer fixed.
* Fix. Code. UTM marks for payment link fixed.
* Fix. User checker. Non-checkable tab fixed.
* Fix. Integrations. WSForm update flow to handle request in direct function.
* Fix. AjaxHook. Initializing a global variable
* Fix. AvadaIntegration. Skipping hooks, username definition, GFA edit, removed no_cookie_data excision
* Fix. AvadaIntegration. Removed post filtering
* Fix. Integration. Added the definition of 'message' for integration with Jet Form Builder

= 6.52 13.03.2025 =
* New. Integration. Integration with plugin/theme Listeo.
* Mod. Pixel. Disabling a pixel if its mode is 'auto' and the bot detector is enabled
* Mod. Decoration. Changing cursor data collection, renaming functionality
* Mod. Decoration. Removing decorations and changing the logic of data collection from the frontend
* Ref. Integrations. Woocommerce gather to one class.
* Fix. Email encoder. Texts modified by hooks.
* Fix. Email Encoder. Using buffer fixed.
* Fix. CollectingUserActivity. Rename script, changing the selection definition
* Fix. GetKeyAuto. Removed localization
* Fix. External forms. Bitrix24 forms protection implemented.

= 6.51 03.03.2025 =
* New. Integration Awesome Support. Checking registration and creating new tickets.
* New. Integrations. Added Site reviews handler.
* New. Integration. Paid Member Subscription plugin.
* Upd. EmailEncoder. Made JS message translate-ready.
* Upd. ProtectByShortcode. Expanded the array of options.
* Upd. EmailEncoder. Unified localization.
* Mod. GetKeyAuto. Checking the query result code.
* Mod. EmailEncoder. Unification of Email Encoder functionality.
* Fix. Code. JS error during external forms protection fixed.
* Fix. Integrations. False detecting request type registration fixed.
* Fix. Honeypot. Honeypot layout simplified.
* Fix. Get fields any. Collecting message fixed.
* Fix. Common. POST clearance updated.
* Fix. Code. SFW class. PHP 8.2+ compatibility.
* Fix. TRP. Editing the rendering of badges in the admin area.
* Fix. Search form. Skip hero booking forms.
* Fix. Admin page. Admin bar. Spam counters reset fixed.

= 6.50.1 21.02.2025 =
* Fix. Integrations. Registration flag condition updated.

= 6.50 12.02.2025 =
* New. AJAX Wrapper.
* New. Integration. Hubspot embed forms (non-iframe).
* New. Integration. Added LeakyPaywall register handler.
* Fix. Code. Psalm lvl3 completed.
* Fix. Code. Contact Form 7. Run gathering NoCookie Data before apbct_js_test() run.
* Fix. Real Person. Editing the badge output for existing users.
* Fix. Global variables. Cookies getting logic fixed.
* Fix. Settings. Fixed wpms work mode select.
* Fix. Email Encoder. Attribute drop sign upgraded.
* Fix. Email Encoder. Regexp for exclusions updated.
* Fix. EmailEncoder. Exclude ICS calendar.
* Fix. JS. Removed AJAX call "apbct_set_important_parameters".
* Fix. Integration. External forms for publisher.copernica.com custom code.
* Fix. Honeypot field. CSS selector for labels fixed.

= 6.49 30.01.2025 =
* Fix. Email Existence check. The icon and popup now adaptive on window resizing.
* Fix. EmailEncoder. Improved flow to skip encoding inside inline js.
* Fix. Force Protection. Correcting the error of using the class before initialization, adding an option check.
* Fix. Force Protection. Preventing notice occurs from js.
* Fix. Integrations. Added nasa login exclusion.
* Fix. Integrations. Improved ConvertKit forms integrations.
* Fix. Integrations. Improved flow to prevent error occurs.
* Fix. Integrations. Improved nasa registration params.
* Fix. Integrations. Prevent broking elementor swiper gallery.
* Fix. SFW. Fixed update flow, to prevent warning occur on download stage.
* Fix. Settings. Improved refresh nonce flow.
* Fix. Users checker. Selecting users for the checking was fixed.
* New. Bot detector frontend data log. Save logs to alt sessions only if records has new event types.
* New. FormDecoration. The plugin's signature has been added to all the decorations. Added click counting for signatures.
* New. JS-Bundles. Branching the js bundle into external and internal and depending on their options.
* New. UsersChecker. Sorting users implemented.
* Upd. Dashboard widget. Countries flags convert to the svg sprite.
* Upd. DeactivationPopup. Deleted the plugin deactivation pop-up.
* Upd. Integrations. Skip Leaky Paywall validation request.
* Upd. JS-Bundles. Changes to the assembly of bundles and their use.
* Upd. ProtectByShortcode. Renaming the hook.

= 6.48.2 23.01.2025 =
* Fix. SFW. Fixed update flow, to prevent warning occur on download stage.
* Fix. Force Protection. Preventing notice occurs from js.

= 6.48.1 21.01.2025 =
* Fix. Settings. Improved refresh nonce flow.

= 6.48 16.01.2025 =
* New. Cookies type. Auto-detect cookies type on list of specified plugins active.
* New. Integration. Dubsado external iframes protection implemented.
* New. Integration. Tevolution plugin integration implemented.
* New. ForceProtection. Added new module.
* New. SpamProtection. Added shortcode for easily third party integration.
* Fix. AltCookies. Trailing spaces removed.
* Fix. Comment checker. Hints descriptions updated.
* Fix. Comments checker. Fixed count of comments during ajax check process. Docs and descritpions updated.
* Fix. Common. JS keys getting. Fixed case when inline script fired before public bundle loaded.
* Fix. Common. `Helper::dnsResolve()` method fixed.
* Fix. Common. Prevent cookies set on WP Rocket preloader requests.
* Fix. Cron. Added cast for value from database.
* Fix. External Forms. Use 'load' event of window object to add external forms protection instead of rewriting 'window.onload' function.
* Fix. External forms. Clear service fields fixed.
* Fix. Email encoder. Adaptive. Magic on the way popup layout fixed.
* Fix. Forms decoration. Fatal error getting decoration fixed.
* Fix. Integrations. Improved compatible with tandem of wp-rocket and wp-engine.
* Fix. Integrations. 3rd party Moosend form behaviour (spinner) fixed.
* Fix. Integrations. Skip CartFlows login.
* Fix. Integrations. Ninja forms integration fixed.
* Fix. ForceProtection. The condition for adding a listener to enable the option.
* Fix. Search form. Error handling alt cookies set fixed.
* Fix. SetCookies. Removed data encoding for writing cookies off.
* Fix. Settings. Adaptive. Long description popup layout and handling fixed.
* Fix. Settings. Long description behavior fixed.
* Fix. SFW. Download update files by batches.
* Fix. SFW Error Text. Checking whether the init or plugins_loaded hook was executed (#529).
* Fix. WooCommerce. Deleted draft order after forbidden solution.
* Upd. AntiCrawler. Fix condition.
* Upd. AntoCrawler. Changing the logic of the conditions, receiving cookies.
* Upd. AntiCrawler. Added a new cookie for AntiCrawler, checking the loading of the bot detector.
* Upd. BuddyPress. Send negative feedback for deleted Buddypress users.
* Upd. Code. ServerVariables::get is deprecated now.
* Upd. Code. Refactoring to compatible with psalm L3.
* Upd. ForceProtection. Added a verification cookie, added a description and confirmation before enabling the option.
* Upd. Settings. Enabling the default 'email check exist' setting.
* Upd. Settings. Rename get-access-key button.
* Upd. WP CLI. Improvements.

= 6.47 18 Dec 2024 =
* New. Form decoration. Holiday form decoration option added.
* New. JSLibrary. Bot detector log collecting.
* New. Integrations. Sendpulse 3rd party service integration implemented.
* New. Integrations. Added SeedConfirmationPro.
* Upd. EmailEncoder. Remember hook decoding.
* Upd. Settings. Updated logic to clear old sessions data.
* Upd. Integrations. Updated EmailEncoder to integrate Business Directory.
* Upd. EmailEncoder. Fixed warning occurs on plugin delete action.
* Upd. EmailEncoder. Improved work to handle seldom cases.
* Upd. Integrations. Refactoring BuddyPress handler.
* Upd. Code. Improved clean old session data handler.
* Mod. Bot Detector. Library JS script load strategy set to "defer".
* Fix. Integrations. WooCommerce checkout during REST protection fixed.
* Fix. External forms. External forms catching fixed.
* Fix. External forms. ConvertKit integration fixed.
* Fix. UniBanner. Edit access to a variable.

= 6.46 27 Nov 2024 =
* New. Integrations. CoBlocks integration implemented.
* New. EmailEncoder. A new hook for encoding mail
* Upd. TheRealPerson. Update layout.
* Upd. Code. Psalm L3. Updated codebase
* Upd. Integrations. Breeze cache plugin integration implemented.
* Upd. Code. Refactoring honeypot logic.
* Upd. TRP. Improved adaptive.
* Upd. Integrations. Added fibosearch support.
* Fix. Integrations. Ninja forms getting form fields fixed.
* Fix. TRP. Popup text color fixed.
* Fix. Email encoder. Decoding blur-magic rebuilt.
* Fix. Integrations. Exclusion of the Elementor search form
* Fix. Integrations. Regex to exclude search forms
* Fix. EmailEncoder. Handling exceptions and logged-in users
* Fix. EmailEncoder. Exclusion of maps from leaflet

= 6.45.2 19 Nov 2024 =
* Fix. Settings. Fixed banners close handler.

= 6.45.1 15 Nov 2024 =
* Fix. Email Encoder. Exclusions condition fixed.
* Fix. Collecting JS errors. Substring fail case fixed.

= 6.45 14 Nov 2024 =
* Code. Psalm level 3. New progress.
* Fix. Anti-Flood. Blocking page loop fixed.
* Fix. Code. GetFieldsAny(). Added protection for unknown Gravity forms attack that ignores integration hooks.
* Fix. Common check. Prevent spam on Formintator forms direct call attacks.
* Fix. EmailEncoder. Editing the change of double quotes to single quotes.
* Fix. EmailEncoder. Issue with missing tables fixed.
* Fix. EmailEncoder. Revived lost modifyAriaLabelContent() call used to replace back the origin aria attr.
* Fix. Remote Calls. RC calling for the services without the api key fixed.
* Fix. Request Parameters. `apbct_site_landing_ts` parameter handling fixed.
* Fix. Skip request. Skipping an ajax request to edit a profile.
* Mod. EmailEncoder. Popup. Copy button removed. Email made selectable by click. Styles unified.
* Mod. EmailEncoder. Descriptions updated.
* Mod. Sanitize::sanitizeCleantalkServerUrl implemented.
* Upd. Settings. Checking email existence option will be enabled by default for the new users.

= 6.44 31 Oct 2024 =
* New. Integrations. Added honeypot for elementor form.
* New. Email encoder. Hook and shortcode apbct_encode_data handler implemented.
* Upd. EmailCheck. Improved js.
* Upd. Universal banner. Refactored to universal.
* Upd. Code. jQuery's dependency removed form apbct scripts localization.
* Fix. Request parameters. Param apbct_headless gain fixed.
* Fix. Integrations. Flying Press cache plugin integration implemented.
* Fix. EncodeEmail. Editing the change of double quotes to single quotes.
* Fix. Common check. Prevent spam on Formintator forms direct call attacks.

= 6.43.2 23 Oct 2024 =
* Fix. Integrations. Elementor Pro. Remove post-check for email field.
* Fix. Get fields any. Revert last changes.

= 6.43.1 20 Oct 2024 =
* Fix. Integration. Fluent Forms. Field data concatenating fixed.

= 6.43 17 Oct 2024 =
* New. Integrations. Added TourMaster handler.
* New. CheckEmailExist. Visualization of email address verification when filling in the field.
* Upd. CheckingComments. Description of the number of all and verified comments.
* Upd. Integrations. CF7. Ignore wpcf7_skip_spam_check third-side rules if CleanTalk Anti-Spam runs.
* Fix. TRP. Fixed trp layout occurs on the page.
* Fix. Integrations. Ninja forms getting form fields fixed.
* Fix. Integrations. Added exclusion for Broken Link Notifier service action.
* Fix. Integrations. Gravity Forms. Prevent skipping aside attacks to form handler.
* Fix. Integrations. WP Rocket image dimensions requests excluded.
* Fix. Code. JS minifying. Use return instead break on filling email decoder loop.
* Fix. Code. Github action fixed.
* Fix. CheckingComments. Editing the text.
* Fix. EmailEncoder. Fixed a case with skipped encoding an aria-label attribute.
* Fix. EmailEncoder. Improved "wpautop" exclusion.

= 6.42.1 03 Oct 2024 =
* Fix. Adjust. LiteSpeedCache adjusting fixed.

= 6.42 03 Oct 2024 =
* Fix. Integrations. Uni-Cpo pruducts actions - service fields skipping improved.
* Fix. EmailEncoder. CSS. Hide wpautopt breaks between magic blur elements.
* Fix. Integration. Add to cart by get bot detector fixed.
* Mod. Settings. Adaptive version of the settings
* Mod. Settings. Burger menu
* New. Admin bar. Promotion link Manuals and FAQ added.
* Fix. Contact form validate. Emails array urlencoding fixed.
* Fix. External Forms. Skip PayPal redirection form.
* Mod. ReferralLink. Changing the referral link
* Fix. Integrations. TVE plugin affliction to gravity forms fixed.
* Upd. Integrations. Updated adjust module for litespeed.
* Fix. Settings. Removing excess
* Fix. Integrations. Masteriyo LMS plugin. Ignore login events.
* Fix. Integrations. Masteriyo LMS plugin. Registration POST check improved.
* Fix. Code. GetFieldsAny. PHP 8.0 compatibility.
* Fix. Integrations. BuddyPres private messages. Nouveau AJAX messages handled.
* Fix. Settings. TRP and SFW settings minor fixes.

= 6.38 Jul 12 2024
* Code. Compatibility. Unnecessary WP Rocket text removed.
* Fix. Integrations. Updated gathering email on Divi.
* Upd. Internationalization. Added Dutch language support.
* Fix. Email encoder. Translation fixed.
* Fix. Requests parameters. Store URLs fixed.
* Fix. Integrations. Fixed compatibility with varnish.
* Fix. JS. Updated compatibility with old browsers.
* Fix. Common. Revert readme text.
* Ref. Search forms protection. Refactored to use storage data instead of hidden fields.
* Mod. Integration. External Forms. Divi Form redirect handling via external forms.
* Upd. Common. Updated readme description.

= 6.34 Jun 13 2024
* Fix. Pixel. Added nofollow attribute.
* Upd. Admin Bar structure. Renewal links conditions fixed. Code refactored.
* Upd. Settings. Email encoder A/B testing.
* Upd. Public JS localization. Now can be selected.

= 6.33.2 Jun 01 2024
* Fix. Admin notices. Purchasing the product page link fixed.

= 6.33.1 May 31 2024
* Fix. Admin panel. Banners. Renewal payment links getting fixed and refactored.

= 6.33 May 30 2024
* New. Integrations. Flamingo integration implemented.
* New. Integrations. Added handler for learnpress signup.
* New. Intergations. Porto theme login popup protected.
* Upd. Woocommerce. Uni CPO plugin. Clear service fields improved for premium version.
* Fix. Woocommerce. Exclude hubspot integration as external form on WooCommerce checkout.
* Fix. Woocommerce. Uni CPO plugin. Clear service fields from post.
* Fix. GetFieldsAny. Get the very first email to the process. Provide additional email addresses on the form to the request message.
* Fix. CleanTalk Public. Protect LearPress registration process on plugins_loaded hook.
* Fix. JS. External Forms. Exclude elementor search form from external forms pre-handling.

= 6.32.1 May 20 2024
* Fix. JS. Function apbctCatchXmlHttpRequest(). Condition to catch fixed.

= 6.32 May 15 2024
* Fix. Integration. External forms integration refactored.
* Fix. Settings. Updated statement for import/export settings on wpms.
* Fix. Cron. Fixed updateTask function to save the last_call param.
* Fix. Common. Important requests parameters fixed.
* Fix. Settings. Added unique check for urls.
* Fix. Integrations. Added statement for compatibility with the7 theme.
* Fix. Integrations. Forbidden message appear was updated.
* Fix. EmailEncoder. Added statement to skip.
* Fix. EmailEncoder. Added exclusion for compatibility with StylishCostCalculator.
* Fix. Integrations. Added statement to exclusion for BuddyPress.
* Fix. Integrations. Added excluded statement for MemberPress.
* Fix. Integrations. Skip fluentcrm unsubscribe request.
* Fix. Integrations. Updated base integration flow.
* Fix. Pixel. Added statement to draw logic.
* Fix. Common. Getting ct_no_cookie_hidden_field data. Error handled on case of recursion level 5.

= 6.31 Apr 18 2024
* New. Integrations. Added ContactFormPlugin handler.
* Upd. Integrations. Skip new action for Wordpress File Uploader.
* Upd. Settings. Advanced setting info added.
* Fix. Comments moderation. Do not auto-approve comments if license is expired.
* Fix. Code. ES Lint github action fixed.
* Fix. Code. General. Compatibility with php 8.2.
* Fix. Integration. WooCommerce. Event token added and JS status fixed.
* Fix. Integrations. Added statement for handling space in attribute name.
* Fix. Integrations. Added handler for KadenceBlocks.
* Fix. Integrations. Skip WP Fusion Abandoned Cart Addon service requests.
* Fix. Integrations. Prevented multi request after send.
* Fix. SFW update. Get only common lists on expired key.
* Fix. SFW update. Fixed case when DirectUpdate type always calls if has been called once.
* Ref. Code. Function ct_preprocess_comment refactored to integration class.
* Ref. Code. External forms. Deleted unnecessary conditions.

= 6.30 Apr 4 2024
* New. Integration. Jobstack theme register form protection implemented.
* Fix. Integration. Skip Pixelyoursite service action.
* Fix. Settings. Fixed switcher for email encode.
* Fix. Integration. Search form protection fixed.
* Fix. Integration. Adding to cart protection fixed.
* Fix. Integration. Elementor Pro. Event token gathering fixed.
* Fix. Integration. External forms protection fixed.
* Fix. Integration. Happy Forms integration fixed.
* Fix. Integration. Prevented error on Ninja forms.
* Fix. Integration. EasyDigitalDownload fixed.
* Fix. Integration. Salesforce external form fixed.
* Fix. Integrations. Catching js params on BuddyPress.
* Fix. Integrations. Fluent booking. Fix localize script.
* Fix. Code. Removed redundant parameter `source` from `private_list_add` handler method.
* Fix. Code. Add default key to debug call.
* Fix. Code. JS. Core.attr fixed.
* Fix. Code. Added eslint-windows npm script to run eslint on windows systems.
* Ref. ApbctSFW. Switch to direct update logic.

= 6.29.1 Mar 26 2024
Fix. Cookies. Alternative cookies set fixed.

= 6.29 Mar 14 2024
New. Integration. BookingPress integration.
New. Integration. OptimizePress integration.
Upd. Anti-Crawler. UA updating fixed.
Fix. Code. JS bundle fixed.
Fix. Bot detector JS lib. Event token field removed from GET params.
Fix. Pixel. Pixel URL getting fixed.
Fix. Email encoder. Skip Divi Builder generated content from encoding.
Fix. Integration. Goodlayers LMS plugin registration exclude from skipping.
Fix. Integration. EasyDigitalDownloads integration fixed.
Fix. Bot detector. Including bot detector wrapper script fixed.

= 6.28 Feb 28 2024
* New. Integrations. Avada Fusion form builder new implementation added.
* New. Integrations. Newsletter Tribulant eraly ajax check.
* New. Integrations. Divi Builder email opt-in subscription form.
* New. Integrations. Hubspot forms protected via div-click.
* New. Integration. Fluent Booking PRO calendar.
* Upd. Integrations. Elementor Pro. Refactored to integration class.
* Upd. Comments and user checker. Now use local datetime in the checker logs.
* Fix. Integrations. Protected request anonymous add to cart.
* Fix. Integrations. Mailpoet. Bot detector handled, message cleared.
* Fix. Integrations. Fluent forms. Bot detector handled, message cleared, visible fields array fixed, hook deprecation handled.
* Fix. Integrations. Updated ws-forms handler.
* Fix. Integrations. Submit time calculating fixed.
* Fix. WooCommerce. Added new sign of wp-ajax to skip Paystation service requests.
* Fix. WooCommerce. Skip "woo-stripe-payment" service request.
* Fix. SFW. SFW updating process fixed.
* Fix. SFW update. Do not warn user if we cannot remove index.php.
* Fix. AJAX. Skip "Paid Membership" plugin service actions.
* Fix. State. WP options. Broken serialized data handling.
* Fix. GetFieldsAny. Handle warning.
* Fix. Integration. Easy Digital Downloads. Registry during checkout handled. Service actions for discount recount skipped.
* Fix. GetFiledsAny. Try to parse URL only for single lined message.
* Fix. Div-click protection. Skipped already protected div on further call of window.load.
* Fix. Integration. WPFomrs excluded form external forms check.

= 6.27 Feb 14 2024
* New. Integrations. Added protect for outside iframe.
* New. Integrations. Classifield theme users registering protection implemented.
* Upd. General. Removed deprecated ips.
* Fix. Integrations. WpDiscuz. Duplicated request fixed. Bot detector field handling added.
* Fix. Integrations. Happy forms. NoCookie hidden field added via ajaxSetup.
* Fix. Integrations. Undefined: key \'lable\' fixed.
* Fix. Integrations. HivePress. Service requests skipped.
* Fix. SFW. Check array key exist before use it.
* Fix. apbctPrepareBlockForAjaxForms. The method ajaxComplete() is deprecated, used on() instead.
* Fix. WooCommerce. Skip Apple Pay service request if WooCommerce check is disabled.
* Fix. WooCommerce. Added new sign of wp-ajax to skip WC order check.
* Fix. Integrations. Ninja Forms - added an exception for external forms.

= 6.26 Feb 01 2024
* New. Integration. WP GeoDirectory. Skip service actions and get necessary data directly on the hook 'geodir_validate_ajax_save_post_data'.
* New. Integration. Kali Forms and Kali Forms pro direct integration.
* Fix. Comments. Added description.
* Fix. jQuery ajaxSetup interception. Logic refactored to fix unexpected interceptions during NoCookie data attachment.
* Fix. CleanTalk response. Fix UTF-8 decode/encode for non-mbstring instances.
* Fix. Integrations. Refactoring the definition of amp request.
* Fix. Integrations. Prevent undefined warnings occurring on WpForms.
* Fix. Integrations. Skip mailpoet service requests.
* Fix. SFW update. Direct update fixed. Queue stage status fixed.

= 6.25.1 Jan 23 2024 =
* Fix. Integrations. Prevent undefined warning occur on WpForms.

= 6.25 Jan 17 2024 =
* New. Integration. 'Nextend Social Login and Register' integration implemented.
* New. Integration. WooCommerce Product Enquiry Premium integration implemented.
* New. Integration. Hivepress theme listing check with no email form.
* New. Code. Base call. Cache plugins list added to the CT request via sender_info.
* Add. WPCLI. Possibility to create service.
* Add. WPCLI. Possibility to set template and toggle settings.
* Fix. Email encoder. Getting visitors IP fixed.
* Fix. Common. Request validating fixed.
* Fix. Integration. Search form service parameters removing fixed.
* Fix. Exclusion. CleanTalk service requests excluded.
* Fix. Mec forms calendar multipage form event_token reattach.
* Fix. Integration. Enfold theme contact form. Service data excluded from email encoder. Response layout fixed.
* Fix. Integration. Elementor get email, nickname fix.

= 6.24 Dec 21 2023 =
* New. Integrations. WP Delicious integration implemented.
* Fix. Search. Clear service field in MegaMenu search form.
* Fix. Integration. Added direct mailpoet.
* Fix. Integrations. UserRegistration extension compatible with cookie off mode.
* Fix. Integration. User Registration Pro integration fixed.

= 6.23 Dec 07 2023 =
* New. Integrations. Added handler for DHVC Form.
* New. Integrations. Added handler for jetformbuilder.
* Fix. Settings. Getting Access Key message fixed.
* Fix. Integrations. Skip Flux Checkout service requests.
* Fix. Integrations. Skip FunnelKit Automations cron worker.
* Fix. Integrations. Handle Hubspot integration in Elementor Form.
* Fix. Integrations. Forminator integration fixed.
* Fix. Integrations. Skip handle in registration_error hook for wp-members.

= 6.22 Nov 23 2023 =
* New. Integration. BackInStockNotifier - event token to alt cookies forced.
* New. Plugin now use register_uninstall_hook() on uninstalling process. Some additional checks added during uninstalling.
* Fix. WP Rocket compatibility improved.
* Fix. CT AJAX check. FacetWP service actions ignore.
* Fix. GravityForms huge memory usage fixed.
* Mod. Email encoder. Pass key has been stronger.

= 6.21 Nov 09 2023 =
* Fix. Readme. Plugin name fixed.
* Mod. Integrations. Now can handle several required APBCT settings conditions to run the integration class.
* Fix. Integrations. WPdiscuz logged-in users now handles correctly.
* Mod. FW update. Use inner APBCT folder for uploads if common WP folder is not reachable.
* Fix. Brief widget. Now shows not more than 8 bars in spam count.
* Fix. SFW update. Additional fixes for uploads inner folder.
* Fix. Use get_file_data instead of get_plugin_data on activate.
* Fix. Fields signs exlusion form array conditions fixed.
* Fix. SFW. SFW updating process fixed.
* New. Integration. User Registration Pro.
* Fix. Admin bar. Resetting counters fixed.
* Fix. Settings. Changing email for getting access key fixed.
* Mod. Integrations. Clear APBCT service fields for advanced-cf7-db plugin work.
* New. Integration. Piotnet Addons For Elementor Pro integration implemented.
* Fix. CT AJAX check. Convertkit service actions ignore.
* Fix. Statistic. Collecting blocked_ips.
* Fix. Email encoder. Mailto links decoding fixed.
* Update. Settings. Show message if auto get key not allow.

= 6.20 Oct 12 2023 =
* Fix. Integrations. Gravity multi-page, removed duplicates of apbct_visible_fields.
* Fix. Integrations. Simple Membership, deleted the user instead of set inactive status.
* New. Integration. Delivra external forms integration implemented.
* fix: doubles of hidden fields is fixed
* Ref. All visible fields collection logic is moved to GetFieldsAny.php.
* Fix: Integration with AjaxSearchLite
* Mod: Event token to DB.
* WP forms POST fields parser chunk added.
* Fix. Cookie. Improved getting pixel url in alt mechanism.
* Upd. Settings templates. A tip about templates deleting added.
* Fix. Settings. The `check links` setting description fixed.
* Mod: Added title to pixel tag
* Fix: Fixed SFW class on php 8.2
* fix: fixed localizer

= 6.19.1 Oct 02 2023 =
* Upd. Plugin author name updated.

= 6.19 Sep 28 2023 =
* Fix: SFW. Added is-writable check for sfw dir.
* Fix: Integration. Updated handler for elementor.
* Fix: Typo. Updated description for search protect.
* Mod: Previous referrer now stores correctly in cases of refresh and backward/forward.
* Fix: Integrations. Added trusted and affiliate sign for Elementor forms and Ninja forms.
* Fix: Integration. Updated rule for show trusted text.
* Mod: Integration. LeadFormBuilder now collects usernames and works fine with event_token provided.
* Fix: Integration. Jetpack comments event_token gathering fixed.
* Fix: Dashboard widget. Vew all button link fixed.
* Mod: Now apbct_prev_referrer param contains the page URL that was visited before the page with the submitted form.
* Fix: Widget. Added sort for date.
* Mod: Save GET params on block screens
* Fix: Integrations. Added exclusion for bot detector.
* Fix: JsData. Update timestamp gathering for wp-rocket.
* Fix: JS. Added exclude list for submit prev call.
* Fix: Integrations. Added ReviewX.
* Fix: User scanner.
* Mod: Improved AMP integration.

= 6.18 Sep 14 2023 =
* Fix: Exclusions. VBOUT Woocommerce Plugin service request excluded.
* Fix: Developing. GitHub action midified.
* New: JS. Add frontend params for typo.
* New: Integration. Elementor UltimateAddons Register integration.
* New: Integration. BuddyPress feedback collected on users management page.
* Fix: Tests. SFW private lists test fixed.
* Fix: Common. Check js hidden field drawing fixed.
* Fix: Alt cookies. Clearing old data fixed.
* New: AMP Plugin integration.

= 6.17 Aug 31 2023 =
* Fix: SFW_update. Create temp table for personal data.
* Fix: Email encoder. Prevent encoding emails into attributes `aria-label`.
* New: Modal before deactivation is ready.
* Fix: NoCookie. PreloadLocalstorage fixed. Previous value gain fixed.
* Fix: Fixed apbct_timestamp.
* Mod: Cookie. Cookie type is "Auto" (3) by defaults.
* Fix: Anti-Crawler. Exclude W3 Total Cache minified files request from AC check.
* New: Integration. MailPoet2 integration implemented.
* Mod: Ninja forms bot-detector token gain via AltSessions.
* Fix: AC. JSON parse to array instead of object.
* Fix. Do not send event token to XHR if it is already sent and equal to the newly gained from moderate.
* New: SFW. Separate 2s blacklists.

= 6.16 Aug 17 2023 =
* Fix: External MailerLite fixed
* Fix: Jetpack. Send apbct_timestamp to alt_cookies on alt-cookies forced forms.
* Fix: Integration. LatePoint. Event token now can be added to dynamically rendered form.
* Ref: Review notice
* Fix: White Label
* New: Integration. Zoho 3rd party service integration implemented.

= 6.15 Aug 3 2023 =
* New. Integration. LatePoint booking integration implemented.
* New. Integration. Cleantalk Register Widget integration implemented.
* New. External forms. Protection via fake submit button implemented.
* WordPress 6.3 compatibility. NinjaForms. Fixed negative response logic.
* WordPress 6.3 compatibility. WPForms. Disable form protect on form editing for logged-in users.
* Fix: excluded trp_get_translations_regular action Artem
* Fix. Pixel. Added validation for pixel url.
* Fix: Fixed apbctPrepareBlockForAjaxForms().
* Mod. Bot-detector field clearance. Now use the name attribute instead of ID.

= 6.14.2 Jul 26 2023 =
* Fix. Additional frontend scripts fixes.

= 6.14.1 Jul 26 2023 =
* Fix. Public frontend scripts fixed.

= 6.14 Jul 20 2023 =
* New. Integration. Flux Checkout for WooCommerce service requests skipped.
* New. Integration. Some external form protection implemented.
* Fix. Alt cookies. Parameters input_focused and key_up storing fixed.
* Fix. apbct_cookie() call. Do not skip requests if GET contains 'q'.
* Fix. Exclusions. Logic modified, legacy support improved.
* Fix. Jetpack integration. Params gathering fixed.
* Fix. Integration. WPForms blocking message fixed.
* Fix. Common. Checking REST availability fixed.
* Fix. Common. DNS - using global variable DNS_TXT refactored.
* Fix. Common. CookiesBot integration added.
* Fix. Common. Blocking message for custom ajax forms fixed.
* Fix. Common. Enable event token for all requests.
* Fix. Cookies. Do not skip native cookie set if localStorage object persist.
* Fix. Integration. Avada fusion builder. Collect the inner form data correctly.
* Fix. Public scripts. Interception of ajax response logic fixed.
* Fix. SFW. Force direct updating flag implemented.

= 6.13 Jul 06 2023 =
* Fix. PHP 8.1 compat. Email encoder.
* Fix. PHP 8.1 compat. Check users/comments. Title is not null forced.
* Fix. Ultimate Form Builder. Message clearance.
* Fix. NoCookie data clearance. New function apbct_clear_query_from_service_fields() clear the value of form service fields instead of unset it if the value is get-query-like.
* Update. SFW. Check sfw temp table exists before insert data.
* Fix. Integration. Ultimate Form Builder Lite. Glue same key values.
* Fix. Integration. OptimizePress checkout exclusions.
* Update. SFW. Use isTableExists instead of direct query.
* Fix. cleantalk-public-integrations.php. ct_s2member_registration_test(). Integration fixed.
* Fix. Settings. Use DELETE SQL-command instead TRUNCATE option deleted.
* Fix. Settings. Checking REST availability fixed.

= 6.12 Jun 22 2023 =
* New. Restoring WC blocked orders implemented.
* Fix. Exclude. Excluded request from ProfilePress login form.
* Fix. JS. External form not copied value for checkbox or radio button, fixed.
* Fix. Exclude login. Excluded UserPro login form request.
* Fix. Cleantalk AJAX check. Avada form builder fields collection fixed.
* Fix. Do not load public scripts for logged-in users if "protect logged-in" option is disabled.
* Fix. Mouse pointer data set. Alt cookie skipping condition fixed.
* Fix. Force ajax type with constant APBCT_SET_AJAX_ROUTE_TYPE.
* Fix. Hidden fileds exclusions refactored. Woocommerce login form sign added to exclude hidden fields attach.
* Fixed text while encoding
* Fix. Email encoder. Return HTML escap for privacy policy links.
* Fix. Fetch XHR. TWT email signup form catch impemented with jQuery.
* Fix. Comments and users checker. Whitelable mode brands shown correct.
* Fix. Woocommerce integration. Route "\?wc-ajax=cfw_validate_email_domain" is skipped from APBCT check.
* Fix. WC blocked orders. Hyperlinks on the admin bar fixed.
* Fix. Common. Get fields any - message detecting fixed.

= 6.11.2 Jun 14 2023 =
* Fix. Mouse pointer data set. Alt cookie skipping condition fixed.

= 6.11.1 Jun 13 2023 =
* Fix. Honeypot for searchforms. Reverted changes normalized.
* Fix. Custom forms. AJAX search pro exclusions updated.

= 6.11 Jun 08 2023 =
* New. Bot detector added for several forms.
* Fix. Honeypot field for search forms now contains a value.
* Fixed error with DOMDocument
* Added libxml_clear_errors()
* Fix. Js. Fixed logic for case when form is excluded.
* Add. Integration. Added integration for SendyWidgetPro.
* Fix. Remove searchform sign from POST data check.
* Fix. Comment checker. Comment type "review" support added.
* Fix. White label. Brand replacement fixed.
* Fix. Integrations. Handle case when Gravity Form rebuild document if form validation failed.
* Fix. JS. Add check that jquery exists.
* Fix. Javascript. Catching XHR fixed.
* Fix. Form Signs Exclusions. Update handle for case if apbct_skip_this_form in POST[data]
* Fix. Pixel. Special GET snippet added to skip Nitorpack CDN and caching.
* Moved apbct_cookie to init
* Correct apbct_page_hits cookie
* Fix. Admin. Checking ajax requests improved.
* Fix. apbct-public--2--public.js -> ctMouseReadInterval is declared early.
* Fix. SFW. Triggered IP hyperlink fixed.
* Fix. Common. Unset event_token service field from requests.
* Fix. Integrations. Excluded wpform email validate request.

= 6.10 May 24 2023 =
* Fix. Integrations. Ultimate Addons for Beaver Builder: Exclude login form request.
* Fix: Integration. Digits - extra request fixed
* New: Integration. Indeed Ultimate Membership Pro integration implemented.
* Fix: Integration. Indeed Ultimate Membership Pro - exclude request from general forms catching.
* Fix. Pixel. Pixel gathering fixed.
* Fix: Fixed MetForm Integration
* fix: fixed block message
* fix: fixed block message - eform
* fix: fixed unknown block response
* Fix. WC_Invoice4U exclusion.
* Fix. NoCookie. Remove noise from base64 string.
* Added exlutions for Localize
* New. Store WC spam orders.
* Fix. Integration. Skip OptimizeCheckouts fields checks
* New. White label. Replace brands data to apbct->data[wl_*].
* Fix. Cookies. Native cookies mode fixed.

= 6.9.2 May 5 2023 =
* Fix: local_storage_pixel_url fixed

= 6.9.1 May 2 2023 =
* Fix. Fixed javascript
* Fix: no_cookie_data_taken fixed

= 6.9 Apr 27 2023 =
* Ref: Exclusion roles refactored, exclusion signs group added, groups names layout changed.
* Mod: Improved code style.
* Ref: GDPR. Removed logic.
* Mod: Update. Cookie auto. Set setting to cookie - off, in case if data processing in auto and cache plugin detected.
* Fix: SFW. Made the priority list a priority.
* New: Digits integration implemented.
* New: Modern Events Calendar integration implemented.
* Fix: Common. Page url parameter fixed.
* Fix: Integration. Skip Billige-teste theme 1st step checkout request.
* Fix: Integrations. Skip WS Forms Pro request - have the direct integration.
* Fix: Integrations. Gravity Forms block message layout fixed.

= 6.8 Apr 13 2023 =
* Add. New tags <div> <font> in custom response message.
* Update. WPMS. Update counters for spam users.
* Update. SFW. Update message on sfw die page.
* Fix. Manage Spam Comments. Fixed approve comment logic.
* Fix. External forms.
* Fix. Block message for BricksExtras.
* Fix. Excluded resize-image().
* Fix. FluentForm integration.
* Fix. Excluded requests from Profile Builder.

= 6.7 Mar 30 2023 =
* Added rotateModerateAndUseIP() if attempt is failed
* Mod. Force use CleanTalk http request instead of WP HTTP API.
* Add. Js. Gathering errors.
* Mod. Skip third retry if rotateModerateAndUseIP() does not help.
* Mod: Added another MemberPress Integration Signup Form
* Add. Js. Gather errors in db.
* FluentForms fixed
* Fix: fixed sendAjaxCheckingDinamicFormData()
* Fix. HTTP lib. WP 6.2+ supporting implemented.
* Fix. Settings. Default value for data__email_decoder_buffer added.
* Mod: Another integration with GiveWP
* Mod. Remove redundant option "Use SSL".
* Mod. Remove redundant code in API.
* Fix: Excluded request with wcf_check_email_exists - CartFlows
* Update. Notice review. Refactoring notice.
* Update. Internal forms. Removed jquery dependencies.
* Add. Js. Added mail view, cron task, and improve js execute.
* Update. Mail view. Removed Manage notifications settings link from mail footer.
* Fix: Fixed apbct_wp_validate_auth_cookie()
* Fix. Integration. bbPress: replies protection fixed.
* Fix. Common. Connection reports and Update sentinel objects fixed.

= 6.6 Mar 16 2023 =
* Excluded qsm_save_resume_auto_save_data action
* Exclude request from QSM - Save & Resume Addon
* Added correct block message
* removed jquery from scripts
* Fix. Integrations. Added exclusion for Optima Express search.
* Fix. Integrations. Added no_cookie_data for popup dynamic form.
* Fix. Settings. Ajax JS setting description fixed.
* Fixed ct_get_checkjs_value()
* Fix: excluded the form from javascript processing
* Fix. Users scanner. Delete action added for the non-checkable users found.
* fix: fixed apbct_is_plugin_active function name
* Fix. Comments managing. Public side managing comments fixed
* Fix: Fixed apbctProcessIframes()
* fix: fixed fusion block message
* Fix. Admin notices. Layout styles fixed.
* Fix. Admin notices. Dismissing notices logic fixed.
* Fix. Admin notices. "Review" notices logic fixed.
* Fix. Admin notices. JS errors during notice dismissing fixed.
* Update. JS. Rewrote logic without jquery in external file.
* New. SFW update sentinel (reporting about failing updates).
* Fix. Readme. Old changelogs moved to 'changelog.php'.
* Fix. Integration. BuddyPress integration - register protection fixed.
* Fix. Integration. JetPack contact form - js checking fixed.
* Fix. Integration. bbPress integration - topic creation protection fixed.
* Fix. Common. JS - added delayed listeners for delayed forms.
* Update. JS. Handle external forms in frames.

= 6.5 Mar 02 2023 =
* New. State autoupdating. Set new settings values during plugin update.
* New. Integrations. Integration with LeadFormBuilder.
* New. Integrations. Added Ultimate Membership Pro.
* Fix. Integrations. Exclude checkbox and radio inputs from message data.
* Fix: Fixed z-index overlay
* Fix: Added stopping script for easylogin
* Fix. Code. Ajax request initialization fixed.
* Fix. JS localizing. JS object defining fixed.
* Fix. Code. WP-Rocket JS minification preventing.
* Fix. Code. No cookie fields ID attribute removed.
* Fix. Remote calls. Getting template RC fixed.

= 6.4.1 Feb 20 2023 =
* Fix. Search fields. Add unreachable option.

= 6.4 Feb 16 2023 =
#### New integrations added ⚙, Email Encoder functionality improved 😎, CDN support improved 🐸, many integrations fixed 🐞 and some minor issues fixed 💪🏼
* New. Added mail encoding via buffer.
* New. Localize data with wp_head (support Ezoic, CF, LS cache etc).
* New. Integration. WP Booking System plugin integration implemented.
* Fix. Skip Ajax Search Pro forms from hidden field adding.
* Fix. Cookie apbct_timestamp is set as HttpOnly.
* Add. Integrations. Add HubSpot integration, extend logic for external forms handler.
* Fix. Common. CAPD catching fixed.
* Update. Integrations. Add handler for run previous onsubmit action in dinamic rendered external forms.
* Fix. Integration. RegistrationMagic service requests excluded.
* Fix. Common. Collecting JS on custom forms fixed.
* Fix. Integrations. Fix onload event handler overwrited.
* Fix. JS. Gathering visible fields fixed.
* Fix. Integrations. Check each external forms on page, instead of return with first exclusion.
* Fix. Integrations. Skip woocommerce add to cart trigger.
* Fix. Integrations. Woocommerce add excluded condition for password recovery form.
* Fix. Integrations. Skip WooCommerce addon - Wati - action for customers who came from Whatsapp.
* Fix. EmailEncoder. Add style color setting to popup text element.
* Fix. Integrations. User meta through is_ajax param.

= 6.3.1 Feb 02 2023 =
* Fix. Integrations. Add rules for catching metform fetch.

= 6.3 Feb 02 2023 =
#### Several form builders integrated 🎯, many integrations fixed 🐞 and some minor issues fixed 💪🏼
* Add. Integrations. Added Mailoptin.
* Add. Integrations. Added Metform.
* Fix. Integration. Ultimate Form Builder collecting parameters fixed.
* New. Common. Added new filter to preprocessed data for the visible fields comparing.
* Fix. Integration. UFB visible fields processing filter implemented.
* Fix. Common. No cookie data gathering fixed.
* Fix. Integration. Skip ActiveCampaign for WooCommerce service request.
* Fix. Integration. Skip AutomateWoo service request
* Mod. RemoteCalls. RC run_service_template_get cooldown changed from 3600 to 60 seconds.
* Fix. Hosting license. Checking license status fixed.
* Fix. Hosting license. Settings saving fixed.
* Fix. Clear no_cookie_data_taken stat on State init.
* Fix. Kali forms precheck skipped.
* Fix. Clear no_cookie_data_taken stat on State init.
* Fix. Common. Akismet compatibility in comments management part.
* Fix. Translations. Now plugin can use local .mo files.
* Fix. Dashboard chartjs. Added options for support an outdated chartjs version 2.9.
* Fix. Integrations. Nobletitlecalc custom plugin exclusion.
* Fix. SFW. Queue is in progress logic fixed.
* Fix. Integration. AutomateWoo services requests excluded.
* Fix. Integration. WooCommerce checking JS fixed.

= 6.2.1 Jan 24 2023 =
* Fix. Integration. Convert Pro form integration fixed.
* Fix. Integration. AJAX forms JS detection fix.
* Fix. NoCookie. Message field clearance from service data.
* Fix. Updater. PHP 8.0 compatibility.
* Fix. Search forms. New sign of search forms to handle via NoCookie mode.
* Fix. Search forms. Fix JS error while parsing NoCookie data.

= 6.2 Jan 19 2023 =
#### New remote call handled added, common parameters implemented, some integrations fixed and some minor issues fixed 💪🏼
* New. RC. Remote call service_template_get implemented.
* New. Common. New params from JS has_focused and has_keyup.
* Fix: If cookies_type===none - unset cookies_enabled
* Mod. Integrations. Force AltCookies usage for Ninja Forms on NoCookies mode.
* Mod. Integrations. Force AltCookies usage for Smart Forms on NoCookies mode.
* Mod. Integrations. Force NoCookie data setting via direct integration for UltimateFormBuilder.
* Mod. Chart source changed to opensource ChartJS.
* Fix. Admin widget. Do not enqueue scripts if the widget is disabled.
* Fix. Helper. Php notice fixed.
* Fix. New AJAX integrations skip rules moved AJAX part.
* Fix. ErrorToggle logic.
* Fix. SFW. SFW outdated notice fixed.
* Fix. Email encoder. Do not send encoded email to the cloud.
* Fix: Fixed counter of checked comments when press pause
* Fix. SFW. New statuses 99 implemented.
* Fix. Added notice_email_decoder_changed banner
* Fix. Fixed notice_email_decoder_changed()
* Fix. SFW. Blocking pages for the testing purpose fixed.
* Fix: Fixed counter of checked comments when press pause
* Fix. Common. page_hits, prev_referer, site_referer parameters collecting fixed.
* Fix. Common. Parameters collecting fixed.
* Fix. Settings. Cookies option description fixed.
* Fix. Admin. Dashboard widget fixed.
* Fix. Integration. Formidable integration fixed.
* Fix. Integration. Ultimate Form Builder integration fixed.
* Fix. Ajax. Skipping direct integrations requests fixed.

= 6.1 Dec 15 2022 =
#### Some integrations fixed 🐞, Search forms 🎯 protection improved and some minor issues fixed 💪🏼
* New. Integrations. Add NewUserApprove plugin.
* Update. EmailEncoder. Add hook for encode email in default wp widget.
* Fix. Settings. Affiliate shortcode disabled state.
* Fix. Elementor forms. Elementor login form skipping.
* Mod: Optima Express Integration for Login Form
* Fix. Integrations. Optima Express - Update form fixed.
* Fix. Modified Header. Undefined post_type.
* Fix. Integrations. Probably spam notification updated.
* Fix. Integration. Ninja refactoring.
* Fix. Cookies. No-cookies parameters gathering on search forms improved.
* Fix. Integrations. Do not draw hidden fields on excluded pages.
* Fix. Integration. WP Forms integration fixed.
* Fix. Integration. Ninja Forms integration fixed.

= 6.0.1 Dec 4 2022 =
* Fix. Updater. Updating checking fixed.
* Fix. Updater. Updating function renamed.
* Fix. Updater. Clean cron errors while updating.

= 6.0 Dec 1 2022 =
#### No cookie mode by default🔥, EmailEncoder user-friendly enhancements 💣, trusted text and affiliate settings 🎈, prepare SpamFireWall for incremental updating, and some minor issues fixed 💪🏼
* New. Major version updated.
* New. Cookies. The plugin does not use browser cookies by default.
* New. Settings. Trusted text and affiliate links management added.
* New. SpamFireWall. Now can handle incremental update.
* New. WooCommerce integration. Spam\no spam feedback now sends to CleanTalk cloud.
* New. Settings. Some URLs became active links.
* Mod. Ninja forms integration. Improvements.
* Mod. Email encoder. Decode all the emails on the page if cloud allowed and remember the state for session.
* Mod. Connection reports. Totally refactored.
* Mod. SpamFireWall, Anti-Crawler, Anti-Flood die pages. Settings cookie data via single AJAX.
* Fix. Comments scanner. Comments counting fixed.
* Fix. MailChimp for WordPress integration. Fixed.
* Fix. MC4WP integration. Request catching without JS fixed.

= 5.189.1 Nov 23 2022 =
* Fix. Woocommerce. Marking orders as spam fixed.
* Fix. Settings. Some text has been localized-ready.

= 5.189 Nov 17 2022 =
#### Cookies enhancements 🔥, StrongTestimonials plugin integration 💣, let Woocommerce orders interface to report spam, checking existing users and comments improvements🎈 and some minor issues fixed 💪🏼
* New. Cookies. Do not run cookies setting process if no access key provided.
* New. Cookies. NoCookie mode now support SFW, Anti-Crawler and AntiFlood modes.
* New. Integrations. StrongTestimonials for POST and AJAX requests.
* New. Woocommerce. Orders interface now can manage spam.
* New. UserChecker. User can be approved and unapproved from spam list
* Mod. Checking comments. Lot of improvements.
* Mod. Synchronization process frontend improvements.
* Mod. httpPing. Ping now uses curl if fsockopen is disabled.
* Mod. Removed Google Fonts from die pages
* Mod. Public JS. Iframes check refactoring.
* Fix. Common. Rotating m-servers fixed.
* Fix. AltCookies enhancements. Now can place zero values correct.
* Fix. Registration check. Fix request type and submittime graylisting on Avada Fusion register forms.
* Fix. Public JS. Skip GiveWP iframe generated forms because of direct integration.
* Fix. Integration. GiveWP protection improved.
* Fix. Skip ninja form PRO service requests with nonce.
* Fix. Integration. Abandoned Cart Recovery for WooCommerce requests excluded.
* Fix. Code style enhancements.

= 5.188 Nov 2 2022 =
#### Lot of improvements of the EmailEncoder 🔥, wpForo topics and posts protection 💣, a honeypot for Gravity forms, parameters without cookies improved 🎈 and some minor issues fixed 💪🏼
* New. wpForo - add topic and post under protection
* New. GravityForms - added honeypot
* New. Readme. Compatibility tested up to WP 6.1
* New. EmailEncoder. Exclude content from encoding by tag attributes (at least placeholders and values).
* Mod. Cloud. Remove all_cookies header before send requests to the cloud.
* Fix. NoCookie mod. Data collection improvements.
* Fix. bbPress registration now redirect back to the form on bad submissions.
* Fix. EmailEncoder. Minor improvements.
* Fix. EmailEncoder. Decoding process logic fixed.
* Fix. EmailEncoder. Do not show the comment for the allowed requests.
* Fix. EmailEncoder. Comment about decoding process fixed.
* Fix. Common. GDPR checkbox fixed.
* Fix. WPMS. Custom column on sites list page fixed.
* Fix. Common. Deleting visible fields hidden input after its processed.
* Fix. Readme. Requires WP 4.7+.
* Fix. Integration. Skip some Smart Quiz Builder requests.
* Fix. Common. Visible fields hidden input value is on base64 now.
* Fix. JS. ApbctJsLib updated.
* Fix. Comments. Calling hook 'comment_post' priority fixed.
* Fix. Mautic integration fixes.
* Fix. Honeypot flag fixes.

= 5.187 Oct 20 2022 =
#### New integrations added 🔥, CleanTalk status on the sites list implemented 💣, parameters without cookies improved 🎈 and some minor issues fixed 💪🏼
* New. Integration. Site Reviews Integration.
* New. Integration. Sendinblue Integration
* Mod: Cleantalk Status in list of sites
* Fix. JS. CF async loading scripts fixed.
* Fix. JS. Listening events on document object instead of window object.
* Fix. Fixed spam protection if JS disabled.
* Fix. Mautic integration. Force third-side validation pre-intreception.
* Fix. WooCommerce. CartBounty plugin requests skipped.
* Fix. Code. Deprecated hooks wpmu_new_blog, delete_blog fixed.
* Fix. WPMS. Getting setting fixed for apply this on the new added blog.
* Fix. Code. JS events listening on the document object.
* Fix. Code. JS parameter without cookies fixed.
* Fix. EmailEncoder. Exclude placeholders from encoding to prevent field breach.
* Fix. No cookie. Collecting data moved to the more early stage.
* Fix. Common. Custom ajax forms block message fixed.
* Fix. EmailDecoder. Email decoding block message fixed

= 5.186 Oct 06 2022 =
#### Several integrations added 🔥, custom logo for SFW blocking pages added 🎯, external forms into iframe protected 🎉 and some minor issues fixed 💪🏼
* New. MemberPress direct integration.
* New. SFW. Added custom logo on sfw die page.
* New. Integrations. Handle EasyDigitalDownloads plugin registration hook.
* New. External forms. External forms into an iframe has been protected.
* Fix. ct_ajax_hook. Latepoint serice AJAX requests ignored.
* Fix. apbct_settings__prepare_errors() Mismatching types fix.
* Fix. Integrations. Ignore service requests in GiveWP integration.
* Fix: Removed duplication of the hidden field in the search form
* Fix. EmailEncoding. Styles fix.
* Mod. EmailEncoding. Add a tooltip while decoding mailto: links.
* Fix. External forms. Mautic external forms integration.
* Fix. Internal forms. Modify regexp for exclusion urls of wordpress native internal forms.
* Fix. Intergrations. Correct registration flag translation to basecall due EasyDigitalDownloads handling.
* Fix. Common. Rotating m-servers fixed.
* Fix. JS. Custom ajax forms blocking answer fixed.
* Fix. JS. Headless parameter cast to boolean type.
* Fix. NoCookie.php. Remove namespace redundant declaration to keep compat with <php5.6
* Fix. Internal forms. Internal forms protection fixed.

= 5.185.1 Sep 28 2022 =
#### Fixed a security issues.
* Fix. Fixed a security issues.

= 5.185 Sep 22 2022 =
#### NoCookie data collection, new admin notices style, external forms logic improved and many minor issues fixed.
* New. NoCookie data collection.
* New style admin notices
* Upd. Settings. Email encoder setting duplicated on the top level place.
* Fix: Fixed SFW looping with alternative cookies
* Fix: Changed hook for EventsManager
* Fix: Changed option description
* Fix. External forms. JS logic fixed.
* Fix. Cookies. Skip cookies setup on favicon loading.
* Fix. HttpRequest. Error string offset fix due request error handling.
* Fix: Fixed AdminNotices->is_cleantalk_page
* Fix. Common. Rotating moderate-server via cron job fixed.
* Fix. Common. Moderate servers details updated.
* Fix. Email encoder. An ability to decode again implemented if an error was occurred.
* Fix. GDPR. Contact form 7 integration fixed and upgraded.
* Fix. ct_ajax_hook(). ProfileGrid AJAX actions skipped.
* Fix. Connection report. Option implemented.
* Fix. Integrations. Formidable forms item_meta handling.
* Mod: Added clearing AC table from AC logs once a day
* Fix. Debugging logic. Now drops debug data correct.
* Mod. AltSessions. Now sends and parse cookies data as JSON.
* Fix. AltCookies. Getting some parameters fixed.
* New. MemberPress integration.
* Fix. Cookie. Mouse/scrolling cookie storing fixed.
* Fix. AltCookies. Correct handle types before save to DB when value is false.
* Mod. Ajax/Rest selection. Now check if REST route provide a JSON string.
* Fix. AltCookies. AltSession JSON handling fix.
* Fix. Common. 'no_cookie_data_taken' notice fixed.

= 5.184 Sep 08 2022 =
#### Settings interface fixed, Email Encoder improved, jQuery dependency removed and some minor issues fixed.
* New. cleantalk-admin-settings-page.js. Higlight access key field on key typos and do warn user.
* New. Class for inline notices.
* New. cleantalk-admin-settings-page.js. Notice user if key is bad to force retry synchronization.
* New. cleantalk-admin.php. Localize key_is_ok to js script.
* New. cleantalk-settings.php. Remove 'save settings' button disabling.
* New. SFW. Adding custom logo to the block page ability implemented.
* New: Email Decode. 'check_bot' method sending implemented
* Fix. Email encoder. Handle mailto: links.
* Fix: Added exception checking when adding a hidden field to WC Checkout
* Fix: Fixed sending the email when the order was received
* Imp. cleantalk-admin-settings-page.css. Notices CSS changed.
* Imp. cleantalk-admin-settings-page.js. New notice view.
* Fix: Fixed JS emailencoder
* Fix: Fixed Upay integration
* Fix. HTML5. Remove "text/javascript" in tag script.
* Fix: Excluded email encoding on UltimateMember validation request
* Fix. Code. JS refactored to be free of jquery
* Fix. Internal forms. Some logic fixed.
* Fix. External forms. Some logic fixed.
* Fix. Admin. FeedBack sending timeout increased up to 15 sec.

= 5.183 Aug 18 2022 =
##### Checking for bot while email encoder decode, negative reports improved, some integrations fixed and some minor issues fixed.
* New: Email Encoder. Check bot before decode.
* New. Storing big connection reports.
* Fix. Kses <a> tag fixed.
* Fix: Skipped login form for Wishlist Member
* Mod: Added headers_sent in Cookie::set
* Mod: Added aweber external form integration
* Fix. Server variables. Getting Request variable fixed.
* Fix. Connection reports. Getting data from options fixed.
* Fix. Connection reports. Saving data fixed.
* Fix. Connection reports. Displaying data fixed.
* Fix. Cookies. Getting cookies from alternative way fixed.
* Fix. Cookies. ApbctWP\Variables\Cookie getting fixed.
* Fix. Cookies. Cookie check parameter fixed.
* Fix: Fixed error with response from custom ajax requests

= 5.182.2 Aug 08 2022 =
#### Server variables sanitizing fixed, js key getting fixed, internal forms catching fixed.
* Fix: removed & in getAndSanitize()
* Fix: ct_add_hidden_fields() - the data in the locale storage is added in json format
* Fix: Excluded wp-comments-post.php form from internal scripts
* Fix. Server variables. ServerVariables::sanitizeDefault() method is abstract now.
* Fix. Server variables. Common\Variables\* classes are abstract now.
* Fix. Server variables. Default sanitizing method implementation added to ApbctWP\Variables\* classes.
* Fix. Server variables. Client code fixed.
* Fix: FluentForm integration fixed
* Fix. Server variables. Url decoding removed.

= 5.182.1 Aug 04 2022 =
#### Server variables getting fixed.
* New. Server variables. Sanitizing logic added.
* Upd. Server variables. Getting variables logic updated.
* Upd. Server variables. Default sanitize added for ApbctWP\Variables\* classes.
* Upd. Server variables. Client code updated - using ApbctWP\Variables\* classes.
* Upd. Server variables. Sanitizing array nesting increased.
* Fix. External forms. Form draw fixed.
* Fix. Common. Set check JS value fixed.
* Fix. Common. Custom ajax forms catching logic fixed.
* Fix: added styles to hide the honeypot field in the plugin Ultimate Member

= 5.182 Jul 28 2022 =
#### Email encoder improved, internal and external forms protection fixed, code quality improved and some minor issues fixed.
* New. Email encoder. Encoding exclusions implemented.
* New. Alternative cookies AJAX calls reduce. Use browser localStorage to keep check_js value instead of CTSetCookie()
* Upd. External forms. Sendfox.com integration added.
* Upd. Internal forms. Internal forms protection logic updated.
* Fix. GetFieldsAny.php Take visible fields from POST if apbct_visible_fields cookie is not detected.
* Fix. Integrations. WPUserMeta. Added case of user-meta-pro
* Fix. Email encoder. Divi contact forms exclusions added.
* Fix. public.js. Handle exception if backend returns invalid JSON.
* Fix: External Forms. Match action with action, method with method.
* Fix: Restore JS for internal form protection.
* Fix: JS localize. Add blog_home to ctPublic object.
* Fix: Honeypot. Delete redundant style.
* Code: Internal forms. Fix action detection.
* Code: Internal forms. Added exclusion for native WordPress action scripts.
* Fix: SpamFirewall. Ignore warning from gzdecode() in ApbctWP/Firewall/SFW::updateWriteToDb().
* Fix: Internal forms protection. Now is controlled by settings.
* Fix: External forms protection. Now is controlled by settings.
* Fix. Common. Prevent JS async loaded by CF.
* Fix: Protect external. Sort callback params.
* Fix. Code. Code quality improved.
* Fix. Variables. Filter variables contains arrays fixed.
* Fix: Honeypot field. Make filed invisible.
* Fix: GiveWP integration.
* Fix: ApbctWP/Variables/Cookie::setNativeCookie(). Adjust the detection of the default 'secure' flag logic.
* Fix. Variables. Getting empty variables fixed.
* Fix. External/Internal. General contact form option dependence fixed.

= 5.181 Jul 14 2022 =
#### One integration added, SFW testing page updated, code quality improved and some minor issues fixed.
* New. Integrations. WP User Meta integration.
* Upd. SFW. Testing page updated.
* Fix. WP discuzz integration. Check for spam if comment is edited.
* Fix. WP discuzz integration. Remove unnecessary data when check on comment edition.
* Fix. Admin banner. Security attention mark fixed.
* Fix. Code. Sanitizing incoming data.
* Fix. CSS. Fix stylesheet source name and minifed name.
* Fix. apcbt-public-bundle. New detection method for mailerlite classes to prevent default submit clicks.
* Fix. HTTP lib. Multi request error handling fixed.
* Fix: setting page JS key validating.
* Fix: Replace array_* function implemented on State properties.
* Mod: ApbctWP/State to use the direct equation on properties.
* Fix. Integrations. WPUserMeta. Added case of user-meta-pro

= 5.180.2 Jul 04 2022 =
#### SpamFireWall working fixed.
* Fix. Updater. Updater actions moved from the hook "upgrader_process_complete"
* Fix. SFW. JS errors on the block pages fixed.
* Fix. SFW. Skiping block hyperlink fixed.
* Fix. SFW. Additional redundant blocking by AC fixed.

= 5.180.1 Jul 01 2022 =
* Fix. Common. Undefined class fixed.

= 5.180 Jun 30 2022 =
#### Getting api key from the CleanTalk Dashboard implemented, SFW updating improved, code quality improved and some minor issues fixed.
* New. API key length extended to 30 symbols.
* New. Remote call. RC post_api_key implemented.
* New: Option 'cleantalk_debug' now outputs in 'debug' remote call.
* Upd. SFW. Direct update during fallback.
* Fix. Honeypot fields for search. Search forms with GET method now handles correct.
* Fix. Ajax. Prevent JS errors on ajax general contact forms.
* Fix. apbct_need_to_process_unknown_post_request() Add Divi themes exclusion to proceed them to contact_form_validate().
* Fix. General contact form catching fixed.
* Fix. cleantalk-pluggable.php. Skip service requests of enable-jquery-migrate-helper
* Added notice_review banner
* Fix. cleantalk_external.js. Exclude mewtwo flight forms.
* Fix. Code. Compressing JS gulp task updated.
* Fix. Request.php. Extend CURL timeout and low-speed detection limit.
* Fix. Cleantalk.php. Exclude timestamp refreshing via template_rediret hook for alternative cookies mode.
* Fix. External forms JS error fixed.
* Fix. cleantalk-public-integrations.php-> apbct_form_search__add_fields(). Force to run pregmatch search if DOM content is broken.
* Fix. Honeypot. Styles moved to the separated file.

= 5.179.1 Jun 21 2022 =
#### General contact form catching fixed
* Revert "Integration before common aa (#129)"

= 5.179 Jun 16 2022 =
#### Email Encoder functionality improved, SFW updating process improved and some minor issues fixed.
* New. EmailEncoder.php->modifyContent. Admins and logged in exclusions.
* Fix. Email encoder. Prevent encoding data for logged in users.
* Fix. Queue. Return statement from executeStage() method added.
* Fix. SFW. Updating process fixed.
* Fix. SFW. SFW update worker fixed.
* Mod: Using the shutdown hook to call a function ct_contact_form_validate().
* Fix. apbct_sfw_update__worker. Clear errors if stage is finished.
* Fix. HTTP lib. Useragent for WP HTTP API requests fixed.
* Fix. cleantalk_external. Exclusion for tp.media booking forms.
* Fix. cleantalk_external. Exclusion for flodesk forms.
* Mod: Replace apbct_update_actions() to upgrader_process_complete hook
* Fix. cleantalk_external.js->ct_protect_external(). Exclusion for tp.media booking forms.
* Fix. RemoteCalls. No cache parameter added.
* Fix. apbct_remove_upd_folder(). Force unknown file deletion ('.last.jpegoptim')
* Fix. apbct_remove_upd_folder(). Add chek if a strange file is a file and exists.
* Fix. GetFieldsAny.php. Decode email if it is urlencoded.
* Fix. cleantalk-public-validate.php. Add JS check to public forms.
* Mod: Refactoring User Scanner
* Fixed apbct_cookies_test cookie
* Upd. JS. Cookies has_scrolling and mouse_moved optimized.
* Upd. Email encoder. Links mailto: processed.

= 5.178 Jun 02 2022 =
#### Comment moderation option added, cookies prefix added, RemoteCalls stability improved and some minor issues fixed.
* New. Options. Comment moderation option added on discussion page.
* New. Settings. Encode contact data long description added.
* New. Cookies. Getting prefix function implemented.
* New. Cookies. Get and set cookies with prefix.
* New. Cookies. Using cookie prefix on client code.
* Mod: Created RemoteCallsCounter::class to limit remote calls
* Mod: Created RemoteCallsLogger::class for logging last remote calls
* Upd. Comments. Comment moderation logic modified.
* Fix: webto.salesforce.com extended form
* Fix. SFW. Statistics fixed.
* Fix: secure2.convio.net external
* Fix: hookb.in external
* Fix: fixed test for wpforms
* Fix. Pluggable. Getting REST url fixed.
* Fix: Formidable Pro Multistep Fixed
* Fix: Formidable Form Pro ajax response - fixed
* Fix. Settings. Alternative cookies option renamed.
* Fix. Common. Cookies test function fixed.
* Fix. External forms. JS logic fixed.
* Fix. External forms. Force ajax check action handler added.
* Fix. cleantalk.php. VisualFormBuilder hook change.
* Delete RC update plugin
* Fix. cleantalk.php. Visual Form Builder integration: add legacy support.
* Fix. Helper. Fatal error (Call to private method) fixed.
* Fix. WooCommerce. WC checking order hook changed.
* Fix. Settings. Validate URL exclusions.
* Fix. cleantalk-public-integrations.php->apbct_form__gravityForms__testSpam. Gravity forms multiple email fields fix.
* Fix. SFW updating. Writing update errors fixed.
* Fix. cleantalk.php-> apbct_sfw_update__worker() Convert errors array to a string if set in a stage.

= 5.177.2 May 27 2022 =
* Fix. EmailEncoder.php. Fix accident encoding.

= 5.177.1 May 19 2022 =
* Fix. Pluggable. Getting REST url fixed.

= 5.177 May 12 2022 =
#### WP 6.0 compatibility, Email Encoder added, Common HTTP API implemented, Honeypot fields improved and some minor issues fixed.
* New. Email Encode functionality added.
* New. cleantalk-common.php. Honeypot field value and source now sends in sender_info.
* New. ct_preprocess_comment(). Honeypot field source now sends in sender_info.
* New. HTTP API. Common CleanTalk http library added.
* New. Public integrations. Honeypot field for search form.
* New. WP 6.0 compatibility.
* Fix: EZ Form Calculator - clearing the message
* Fix. Common. Checking all post data fixed.
* Imp. Settings. "Hide website" field moved to "different" section.
* Imp. Settings. "Hide website" type changed to checkbox from radio.
* Imp. Settings. "Honeypot field" state changed to enabled by defaults.
* Mod: Integration for Advanced Classifieds & Directory Pro - registration form
* Fix. Custom ajax. Custom ajax handler usage removed completely.
* Fix: Excluded the addition of visible fields in filter of The Events Calendar
* Fix. cleantalk-common.php. Added search honeypot field signature to potential honeypot fields post values
* Fix: MultiStep Checkout for WooCommerce - skipped step validation
* Ref. cleantalk-public-integrations.php. Empty string converts to false - comparison removed.
* fix: apbct_get_rest_url - returns the result of a get_rest_url() function if it exists
* Mod: modified getting pixel_url.
* Fix. apbct_init. Reduce multiple direct calls of apbct_get_pixel_url__ajax.
* Fix: Cleantalk\Common\HTTP\Request. Timeout error while async request.
* Fix. HTTP API. Process exception passed from WordPress \Requests class.
* Fix. Cleantalk. Antispam class fixed.
* Fix. API. Common API class fixed.
* Fix. Comments checker. Pagination fixed.
* Fix. Common. CleanTalk service request excluded.

= 5.176 Apr 28 2022 =
#### New integration added, honeypot fields added and some minor issues fixed.
* New. Integration. NextendSocialLogin integration implemented.
* New: Exclusions validation in apbct_settings__sanitize__exclusions().
* New. WPDiscuz integration. Now sends sender_url. Integrations.php now ready to process sender_url.
* New. Common. Headless parameter added.
* Upd. Integration. A honeypot field was added for the CF7 integration.
* Upd. Integration. A honeypot field was added for the WPForms integration.
* Fix. Common. Prevent double json encoding for source_url.
* Fix. SFW. SFW results priority depends by network mask.
* Fix: Excluded visible fields for AvadaFormBuilder
* Fix: honeypot fixed
* Fix. Forms. Prevent generating a honeypot field if such option is disabled.
* Fix: Fixed external forms
* Exclusion fields descritpions update.
* Fields exclusion input changed to textarea to keep visual identity with URL exclusion.
* Fix. After review. Removed condition on exclusions array slicing. Functions order changed.
* Fix. WPDiscuz integration. Now tries to get email, nick and message directly from POST. If unsuccessful then runs get_fields_any.
* Fix: Optimize and fixed user scanner
* Fix. JS. Using ajax for getting JS key is disabled by default.
* Fix. Common. Custom ajax logic removed.
* Fix. Settings. Now templated settings applies to sub-sites on the first save.
* Fix: FixTeam integration - removed visible fields
* Fix. apbct_settings__sanitize__exclusions(). Checking input params types.
* Fix. Settings. Url/fields exclusion validating fixed.
* Fix: Fusion Avada Form Builder Fixed
* Fix: External form fix for infusionsoft

= 5.175 Apr 14 2022 =
#### Integration added, typos fixed, user scanner improved and minor issues fixed.
* New. Integration. Events Manager plugin integration implemented.
* New. Code. New validate classes.
* New. Code. New validate sub-classes in ApbctWP.
* Upd. Readme. One more AntiSpam feature added.
* Mod: PlansoFormBuilder integration
* Fix. External forms. Capturing buffer fixed.
* Fix. Integration. Simple Ajax Chat sending fixed.
* Fix. Exclusions. Special flag to prevent exclusions implemented.
* Fix. Getting key errors handle.
* Fix. Getting key error output fixed.
* Fix: Added VFB_Pro integration
* Fix. Settings api. Long description for text fields implemented.
* Fix. Settings. Long description for hoster api key removed.
* Fix. Settings. Long descriptions UTM marks fixed.
* Fix. Comments checker. Dates ranges fixed.
* Fix. Code. Core based JqueryUI use on users/comments checking page.
* Fix. Code. Moderate API answer fixed.
* Fix. Code. Including assets fixed.
* Fix. Text. Typos on company brand terms fixed.
* Fix: Glitched redirect after plugin activation.
* Fix. Settings. Hoster Access Key long description mark removed.
* Fix: Filter visible fields for AvadaFormBuilder
* Fix. Code. Using wrappers for calling global variables.
* Fix. Code. Cookie secure attribute fixed.
* Fix. Code. Refactoring the user scanning engine.
* Fix. Cookie. Getting cookies fixed.
* Upd. Settings. SFW long description added.
* Upd. Localization. SFW, AC, AF titles is not localized now.
* Fix. Common. Collecting visited urls fixed.
* Fix. Integration. JP contact form checking JS fixed.
* Fix. Integration. CF7 form checking JS fixed.

= 5.174.1 Mar 25 2022 =
* Fix: Comments/Users scanner fixed.

= 5.174 Mar 25 2022 =
#### Minor issues fixed.
* Fix. URLs storing fixed.
* Fix. Visible fields. Do not add hidden field for logged-in users if the protection was deactivated.
* Fix. Integration. CF7 native spam protection fixed.
* Fix. Integration. Formidable integration fixed.
* Fix. Integration. Skipping elementor pro action fixed.
* Fix. Scanners. Users and comments scanners fixed.

= 5.173 Mar 03 2022 =
#### Honeypot field implemented for improving antispam protection, new integrations added, performance improved and minor issues fixed.
* New. Honeypot field for the registration form.
* New. Integration. Added Visual Form Builder Integration without Ajax.
* New. Integration. GiveWP integration implemented.
* Upd. Code. Helper::ipGet() improved.
* Upd. Settings. Honeypot setting modified.
* Fix: Formidable Integration Refactoring.
* Fix. Integration. Fusion Avada Form Builder output fixed.
* Fix. Settings. Honeypot setting descriptions fixed.
* Fix: Skipped WP Booking System Premius service requests
* Fix. Exclusion. Checkout For WC - service requests skip.
* Fix. Comments checker. Found comments displaying optimized.
* Fix: visible fields was excluded form custom form.

= 5.172 Feb 17 2022 =
#### Updating system modified, settings long descriptions added and minor issues fixed.
* Fix: Fixed Fusion Builder Avada Form integration
* Fix: Fixed CF7 visible fields
* New. Updating system modified.
* Fix: Fixed apbct_store__urls()
* Fix. Updating system. Source url template fixed.
* Fix. Updating system. Redundant errors handling removed.
* New. Integration. WS-Forms integration implemented.
* Fix. Settings. Long description mark fixed.
* Upd. Settings. Set cookies setting long description added.
* Upd. Settings. Hide website field setting long description added.
* Upd. Settings. Anti-Crawler setting long description added.
* Fix. Settings. Long description mark for checkboxes fixed.
* Upd. Settings. Anti-Flood setting long description added.
* Upd. Settings. CleanTalk Pixel setting long description added.
* Mod: Replaced the is_super_admin() function with its own apbct_is_super_admin(
* Fix. Settings. Settings hints fixed.
* Upd. Ajax. Nonce lifetime constant added.
* Fix. Integration. Elementor pro forms integration fixed #2.
* Fix: Formidable Forms - fixed spam protection without JS
* Fix. Settings. Hints links contain UTM marks.

= 5.171.2 Feb 09 2022 =
#### Minor issue fixed.
* Fix. Comments/Users checker. Date ranges validation fixed.

= 5.171.1 Feb 09 2022 =
#### XML-RPC requests excluded and minor issues fixed.
* Fix: Excluded standard WordPress search form from apbct-public.min.js
* Fix. Common. ct_contact_form_validate moved to the init hook.
* Fix. Exclusions. XML-RPC request removed from the filtering.
* Fix. Comments/users checker. Values for dates range validating.
* Fix. Comments/users checker. Values of dates range for resuming scanner validating.

= 5.171 Feb 03 2022 =
#### Visible fields processing modified, many excepted requests are skipped, SFW compatibility with a cache fixed and minor issues fixed.
* New. Exclusions. Excluded some service requests from checking but log them with exception flag.
* Upd. Visible fields. Storing visible fields into an input.
* Upd. Visible fields. Visible fields processing modified.
* Upd. Visible fields. Replacing redundant service field.
* Fix: SFW. Caching block page prevented.
* Fix: Skip. Entry Views plugin service requests.
* Fix: Antispam. Ajax checking moved to the plugins_loaded hook.
* Fix: Skip. APBCT plugin service requests.
* Fix: Skip. Vault Press (JetPack) plugin service requests.
* Fix: Skip. GridBuilder plugin service requests.
* Fix: Skip. Woo Gift Wrapper plugin service requests.
* Fix: Skip. iThemes Security plugin service requests.
* Fix: Settings. Using new API key when sending local settings to the cloud.
* Fix. Integration. Registration form of eMember plugin.
* Fix. Exception action. Xmlrpc requests skipped.
* Fix. Integration. Elementor pro forms integration fixed.
* Fix: Excluded from the test the standard check for Formidable Form Plugin in some situations
* Fix: Skip. Microsoft Azure Storage plugin service requests.
* Fix: Skip. AdRotate plugin service requests.
* Fix: Skip. Super admin requests.
* Fix: Fixed the block message for HappyForms
* Fix: Excluded the form of WP Time Slots Booking Form from apbct_ready()

= 5.170 Jan 13 2022 =
#### One integration added, CleanTalk pixel functionality fixed and minor issues fixed.
* Mod: Added Ova Login Integration. Registrations under protection
* Fix. Common. is_trackback() notice fixed.
* Fix: Removed the exeption for Quick Contact Form from ct_contact_form_validate()
* Fix: Moved the function apbct_settings__get_ajax_type() to cleantalk-pluggable.php to fix the plugin activation error via the CLI
* Fix: Fixed errors in apbct-public.js
* Fix: Cleared notice_incompatibility if SFW disabled
* Fix. AC. Antibot cookie fixed.
* Fix. Pixel. Auto mode fixed.
* Fix. JS. Checking JS via ajax fixed.
* Fix. Pixel. Getting pixel url from backend fixed.

= 5.169.1 Dec 29 2021 =
#### Comments protection fixed.
* Fix. Comments. Comments form without email field protection fixed.
* Fix. Pluggable. Is trackback checking function added.
* Fix. Exception arg. Not set the flag to the comments and trackbacks.
* Fix. Forms protection. Prevent handle the trackback request by contact_form_validate.

= 5.169 Dec 28 2021 =
#### Improved compatibility with Varnish cache, visible_fields cookies fixed and some minor issues fixed.
* New. Options. Set cookie option "Auto" mode added.
* New. State. New property data[cookies_type] added.
* Fix. State. Set cookie option set on "Auto" by default.
* Fix. Activation. Select ajax handler during the plugin activation.
* Fix. API. Async logic added.
* Fix. State. Varnish cache detection fixed.
* Fix. API. Method calling service_update_local_settings is async now.
* Fix. Visible fields. Prevent generating more than 10 visible fields cookies.
* Fix: Disabling the cache when activating the plugin
* Fix: Setting the parameter of ipMaskLongToNumber to an integer
* Fix: fixed error in js script

= 5.168.1 Dec 22 2021 =
#### Direct integrations protection fixed.
* Fix: Prevent logging excluded requests on the direct integrations.
* Fix: Integration. Comment type The7 integration fixed.
* Fix. Log excluded. Skip logging PopUp Builder service action.
* Fix. Log excluded. Skip logging Cleantalk Security service action.

= 5.168 Dec 16 2021 =
#### One integrations added, some skipped requests will be logged, cookies optimized and minor issues fixed.
* New. Get key. A filter to changing an email to get the key implemented.
* New. Log exclusions. Option for logging excluded request implemented.
* New. Integration. Formidable Pro integration added.
* New. Integration. Smart forms integration added.
* Upd. Get key. email_filtered parameter added.
* Upd: Antispam. Prevent skip requests without emails.
* Upd: Antispam. Prevent skip requests trusted users.
* Mod: Implementation of sending plugin settings to service_update_local_settings
* Fix. Antispam. Exception action argument fixed.
* Fix. Antispam. Preventing catch RC requests.
* Fix. Antispam. Preventing catch website search requests.
* Fix. Setting templates. Get templates only after manual getting key.
* Fix. Admin notices. Notice about getting key removed.
* Fix. Getting key. Get the right email for gathering the key.
* Fix. Exception action. Send ajax requests without email to the cloud.
* Fix. Exception action. Prevent catching admin-side requests.
* Fix. Exception action. Send ajax requests without email to the cloud.
* Fix. Exception action. Prevent catching admin-side requests.
* Fix. Log exclusions. Skip checking excepted requests if the "Log excluded requests" option is disabled.
* Fix. Antispam. Remove unnecessary cookie from requests.
* Fix. Visible fields. Collecting visible fields only for unique forms on the page.
* Fix: excluded some action for Ninja Form from spamtest.

= 5.167 Dec 06 2021 =
 * Fix. Comment scanner. Scanning loop fixed.
 * Fix. Comment scanner. Scan only not spam comments.
 * Mod: Launching a suitable ajax handler for checking email before POST
 * Upd. RC. Remote calls checking moved to the root of the main file.
 * New. Activation. Hook for getting key auto added.
 * Fix. Admin notices. Errors about getting key fixed.
 * Fix. Visible fields. Getting visible fields collection method moved to the Cookie class
 * Fix. Visible fields. Getting visible fields collection method moved
 * Fix. Settings. Getting key button fixed.
 * Fix: Removed ajax_type from apbct_email_check_before_post
 * Fixed Ajax.php errors with apbct_email_check_before_post
 * Fix: Add integration for CalculatedFieldsForm and fixed scripts

= 5.166 Nov 18 2021 =
 * Fix: skip ult-forgot-password action.
 * Fix: Uncanny toolkit skip.
 * Fix: SFW. Clearing FW stats fixed.
 * Fix: SFW. Updating fallback fixed.
 * Fix: SFW. Updating FW stats fixed.
 * Mod: Changed the type of verification on check_message during registration in BuddyPress
 * Fix: register_settings for wp < 4.7.
 * Fix: Comment scanners. Getting cookie fixed.
 * Fix: check if errors exists in state.
 * Fix: update sfw after enabled.
 * Fix: WPMS. Settings validating fixed.
 * Fix: wpforms skip remove token validation.
 * Fix. Text. Feedback description fixed.
 * Fix: WPMS. Delete api key from settings template used.
 * Fix. Updater. Notice fixed.
 * Fix: WPMS. Setting transferring to the sub sites fixed.

= 5.165.1 Nov 09 2021 =
 * Fix. Settings. Saving settings fixed.

= 5.165 Nov 08 2021 =
 * New: Public. Mouse moved flag implemented.
 * Upd: State. Errors adding method updated.
 * Upd: Settings. Errors show function updated.
 * Upd: Updater. Clean errors options for new errors structure.
 * Upd: Public. Cookies aggregation.
 * Mod: Improving the functionality of checking comments for spam.
 * Mod: CommentsChecker - updated functionality and refactoring
 * Mod: merged inc/cleantalk-updater.php
 * Mod: merged UpdatePlugin dir
 * Mod: merged Schema.php
 * Mod: merged SchemaTest.php
 * Mod: merged cleantalk.php
 * Mod: merged State.php, Activator.php
 * Fix: SFW. Directory for FW files moved to wordpress uploads directory.
 * Fix: Settings. GDPR link fixed.
 * Fix: testrequesttohost error handle.
 * Fix: check ctsetcookie before call.
 * Fix: Settings. Save button padding fixed.
 * Fix: add console.log if ctSetcookie is not defined.
 * Fix: SFW. Skip if sfw not updated yet.
 * Fix: change console output if apbct-public-functions.js is not loaded.
 * Fix: Added secure and samesite in cookie
 * Fix: Renamed field apbct_wc_honeypot to wc_apbct_email_id
 * Fix.Users.Feedback about deleting user implemented.
 * Fix. SFW. Deleting table fixed.
 * Fix: set buffer type to string if epico theme is active.
 * Fix: Integration. Jetpack contact forms hooks fixed.
 * Fix: SFW. Separating the end of update stage into several stages.
 * Fix: SFW. Fallback function on SFW updating errors implemented.
 * Fix. Integration. WP Forms hooks fixed.
 * Fix. SFW. Auto updating for new users fixed.
 * Fix. Comment. Set meta fixed.
 * Fix: WPMS. Settings saving fixed.

= 5.164.1 Oct 21 2021 =
 * Fix. SFW. Incompatibility WP-Rocket notice removed.

= 5.164 Oct 21 2021 =
 * New: Integration. UsersWP plugin integration implemented.
 * New. SFW. Incompatibility WP-Rocket notice added.
 * New: Settings. Advanced settings navigation implemented.
 * New: Server variables. isSSL method added.
 * Mod: Added the functionality of changing the mail when receiving the key during the initial installation.
 * Mod: Custom admin email. Added minified js and css files
 * Mod: validate api key before save settings for new accounts
 * Mod: Antispam. Comments check. Send feedback with hash:01:url data only if post_info->post_url is empty.
 * Fix: State. Option prefix field is public now.
 * Fix: Using get_option('home') for getting the blog url instead get_option('siteurl').
 * Fix: State. Magic __get notice fixed.
 * Fix. State. Exclamation mark fixed.
 * Fix. Common. Getting REST url fixed.
 * Fix: SFW. Update percents fixed.
 * Fix: DB. isTableExists method fixed.
 * Fix. State. $errors field added.
 * Fix: Server::getDomain(). Fixed regexp.
 * Fix: skip log-in request wpstg.
 * Fix: SFW. Work on hosting licenses fixed.
 * Fix: set prefix_name for cleantalk-icons css.
 * Fix: Helper. Hard use https for the curl requests.
 * Fix: Helper. Home url slash added.
 * Fix: SFW. Using direct updating if remote calls not working.
 * Fix: Settings. Save button z-index added.
 * Fix: Admin bar. Exclamation mark style fixed.
 * Fix: Settings. Api key description on active IP license added.
 * Fix: Sender info. Getting page_url on ajax/rest requests fixed.

= 5.163.1 Oct 12 2021 =
 * Fix: Queue. Errors of each try fixed.
 * Fix: SFW. Sleep before deleting tables was reduced.
 * Fix: Queue. Accepted tries argument implemented.

= 5.163 Oct 07 2021 =
 * New: State. errorExists method implemented.
 * New: SFW. Disabling SFW when the database was outdated.
 * New: Settings templates. Saving template to the several blogs implemented.
 * New: Settings. WPMS settings always show now.
 * New: WPMS. No show any sub-sites errors on wpms mode 2.
 * New: WPMS. Plugin settings are disabled on sub-sites on wpms mode 2.
 * Mod: Remote Calls using POST instead of GET request type.
 * Mod: Helper. No cache GET parameter renamed.
 * Mod: Cron. Transactions implemented #2.
 * Mod: Settings. "URL Exclusions" description updated.
 * Upd: Getting JS. AJAX handler type selecting updated.
 * Fix: Added lost info about total comments in CommentChecker::ctAjaxInfo
 * Fix: add subscriber to skip list.
 * Fix: Changed the plugin name in the list of plugins when enabling White Label
 * Fix: Changed the plugin name in the admin bar when enabling White Label
 * Fix: Feedback. Comments feedback description fixed.
 * Fix: Hide information about Security in admin bar if it is not main site.
 * Fix: SFW. Error toggle used instead of error add/delete.
 * Fix: Alt cookies. Selecting type of alt cookies bug fixed.
 * Fix: protect logged users in gravity.
 * Fix: Updated the condition for showing a link to the security installation in the admin bar.
 * Fix: reverse condition for WL security link.
 * Fix: WPMS. Addition WL info link fixed.
 * Changed plugin name in plugin settings multisite__white_label__plugin_name.
 * Fix: rename plugin name after search plugins if WL is on.
 * Fix: Renamed Antispam by Cleantalk to Anti-spam by Cleantalk
 * Fix: add elementor-pro to skip save action.
 * Fix: WPMS. Sanitize api key during getting key fixed.
 * Fix: Cron. Cron results errors handling fixed.
 * Fix: WPMS. Migrate old WPMS to the new wpms mode.
 * Fix: WPMS. Using main site data on wpms_mode=2.
 * Fix: Helper. Hard use https for the curl requests.
 * Fix: WPMS. Sanitize network settings fixed.
 * Fix: WPMS. Applying settings for selected blogs fixed.
 * Fix: Getting key. Sync after getting key fixed.

= 5.162 Sep 23 2021 =
 * New. SFW. Fall back updating system implemented.
 * New: Integration. Added honeypot wc.
 * New: SFW. Added new status PASS_SFW__BY_STATUS for showing die_page.
 * Upd: Cookies. Alternative cookies types was updated.
 * Upd: Ajax. Finding the right WP directory implemented.
 * Fix: Updater fixed.
 * Fix: Firewall update. Not existing FW table.
 * Fix: State. DB prefix fixed.
 * Fix: WPForms. Excluding from the custom contact forms check.
 * Fix. State. DB prefix definition fixed.
 * Fix: SpamFirewall update. Increasing delay in queue transactions, adding time of the queue task start
 * Fix: State. Show notices fixed.
 * Fix: State. Some logic moved from a loop.
 * Fix: Adding a error if Common/Helper::http_request() couldn't get HTTP code via get_headers().
 * Fix: SFW. Do not AC checking, if cookies were disabled.
 * Fix: http_request() with preset 'get_code' using GET HTTP method instead of HEAD now.
 * Fix: SFW. Direct update DB errors handled.
 * Fix: SFW. Direct update creating temp table errors handled.
 * Fix: SpamFirewall update. SFW_IS_DISABLED is not a error. apbct_sfw_update__init() returns false in this case.
 * Fix: Extended header. Cache-Control: max-age=0 in the /Common/Helper::httpRequest()
 * Fix: Updater. Fixed data__use_static_js_key settings name.
 * Fix: Updater. start ct_account_status_check() if main site in 5.127+ versions
 * Fix: Adding error handling to DB::execute() in ApbctWP\SFW.
 * Fix: Cron. Cron last start flag improved.
 * Fix: Cron. Cron execution cooldown decreased to 2 min.
 * Fix: Adding more info in 'Unknown' type error.
 * Fix: Exclude Forminator double requests on multipage form.
 * Fix: Settings. Alt cookies types validating fixed.
 * Fix: Ajax. WP core dir parsing fixed.
 * Fix: Settings. Ajax handler title fixed.

= 5.161.1 Sep 14 2021 =
 * Fix. State. Checking empty errors fixed.

= 5.161 Sep 09 2021 =
 * Fix: Cleantalk.php. dns_get_record() error handling.
 * Fix: Search form integration. PHP Notice.
 * Fix: Default value for "Alternative Cookie Type" setting.
 * Fix: SpamFirewall. Updating percent output.
 * Fix: SpamFirewall. Omit SFW_IS_DISABLED error.
 * Mod: Admin-bar.
 * Fix: SpamFirewall update.
 * Fix: apbct_log(). Log time.
 * Mod: Debug RC. Servers_connection item added.
 * Mod: apbct_test_connection() moved to cleantalk.php.
 * Fix: skip elementor save template.
 * Fix: skip formidable base check.
 * Fix: remove limit for request in delete all spam users.
 * Mod: apbct_test_connection() improvements.
 * Fix: Helper::http__request() timeout is 15 seconds.
 * New: Helper::http__request() low speed time is 10 seconds.
 * Fix: decbin int type in helper.
 * Fix: add apbct_get_rest_url func.
 * Fix: Error report form Cleantalk.php.
 * Fix: skip sfw check if sfw not updated.
 * Fix. Integration. Enfold theme saving options skip protection.
 * Fix. Integration. Cartflows saving cart skip protection.
 * Fix: getOption return variable.
 * Fix: skip sfw if last_update_time is zero.
 * Fix: skip last_update_time sfw check.
 * Fix: add priority to comment_form_default_fields hook.
 * New. Helper. IP detecting improved.
 * Fix. Helper. Multi-curl timeout added.
 * Upd. SFW. SFW block page updated.
 * Upd. SFW. AC block page updated.
 * Upd. Settings. SFW features settings moved to the separated block.
 * Fix. SFW. Random get parameter for redirecting block page updated.
 * Fix. Settings. SFW features settings description fixed.
 * New: Queue. Transaction system.
 * Fix: skip siteorigin pagebuilder save widget.
 * New: Readme. Hide «Website» field for comments added.
 * Fix. Helper. Async curl timeout increased.
 * Fix. Integration. Blogvault requests skipped.
 * Fix: skip classfields check_email action.
 * Mod: Show real HTTP code in a error during downloading GZ file.
 * Mod: Debug call extended.
 * Mod: Admin notices. Added the ability to hide a banner with notifications for each individual administrator for two weeks.
 * Fix. Settings. Long description output fixed.
 * Fix. Settings. JS debug data removed.
 * Fix. SFW. Deleting fw files folder.
 * Fix: api error handle.
 * Fix: SFW. Added update mode if sfw-updater works with tables.
 * New. WPMS. New multisite logic implemented.
 * Fix: Setting. Select field type fixed.
 * Fix: Сhanged the function delete_all_options() of removing plugin options when fully uninstalled.
 * Fix. WPMS. Hoster API key description fixed.
 * Fix: Admin notices. get_option expression is checking more strictly.
 * New: Helper. Added method for validate date format as 'Y-m-d'.
 * Fix: SFW. Default FW folder fixed.
 * Fix: SFW. FW folder on the first sync fixed.
 * Fix: SFW. Remove wrong FW folders.
 * Fix: SFW. Refactoring apbct_sfw_update__end_of_update().
 * Mod: apbct_test_connection().
 * Fix: /ApbctWP/API::send_request() with empty result.

= 5.160.3 Aug 31 2021 =
 * New: Queue. Transaction system.
 * Fix. SFW. Updating for the new clients fixed.
 * Fix. SFW. Deleting UA file fixed.
 * Fix. SFW. Updating via cron fixed.
 * Fix. SFW. Updating process for multisite fixed.

= 5.160.2 Aug 26 2021 =
 * Fix. Pixel. Auto mode fixed.

= 5.160.1 Aug 6 2021 =
 * Fix: SpamFirewall update.

= 5.160 Jul 29 2021 =
 * New: SFW. SFW alternative cookie implemented.
 * New: SFW. AC alternative cookie implemented.
 * New: SFW. AF alternative cookie implemented.
 * New: Helper. Curl multi wrapper added.
 * New: Queue class implemented.
 * Mod: Changed the processing of the honeypot_field for standard comment.
 * Mod: Added integration for Wishlist Members registration form.
 * Mod: Store visited URLs amount reduces to 5 with 128 symbols by URL.
 * Upd: Public js scripts separated.
 * Upd: SFW. Updating process modified.
 * Fix: Moderate rotating fixed.
 * Fix: SFW. Process file errors handling fixed.
 * Fix: Pluggable. Expression fixed.
 * Fix: Ajax. User detection fixed..
 * Fix: Ajax. Ajax handlers fixed.
 * Fix: IP-detection for Cloudflare CDN.
 * Fix: Skip test for ajax alt_session request.
 * Fix: Set cookies on dashboard pages even if the setting is off.
 * Fix: Ajax. Ajax class fixed.
 * Fix: Users scanner. Remove redundant menu.
 * Fix: Added an exception for the action edd_process_checkout Easy Didgital Downloads plugi
 * Fix: SFW. Changed method for getting addr ip.
 * Fix: Integration. WPForms names gathering fixed.
 * Fix: SFW. Min update interval decreased to 14400 seconds.
 * Fix: Integration. WPForms names gathering fixed.
 * Fix: Cleantalk.php. dns_get_record() error handling.
 * Fix: Search form integration. PHP Notice.
 * Fix: Default value for "Alternative Cookie Type" setting.
 * Fix: SpamFirewall. Omit SFW_IS_DISABLED error.
 * Fix: SpamFirewall. Updating percent output.
 * Fix. Settings templates. Sync after template loading.
 * Fix. SFW. Updating process percents fixed.
 * Fix. Antispam. All headers parameter fixed.

= 5.159.9 Jul 15 2021 =
 * Fix. SFW. Updating cooldown increased up to 15 min.
 * Fix. Cron. Next call time set by task updating fixed.
 * Fix. SFW. Reset blacklist array before processing.
 * Fix. SFW. Some errors handling fixed.
 * Fix. SFW. Getting update period from dns fixed.
 * Fix. Ajax. Checking nonce for logged in users fixed.

= 5.159.8 Jul 07 2021 =
 * Fix: Fixed the connection error Ajax.php when the site files are in a subfolder.
 * Fix. SFW. Anticrawler redirect detection fixed.
 * Fix. Checking sql before the tables creating.
 * Fix. Updater fixed.
 * Fix: Set alt cookies if sg optimizer is enabled.
 * Fix: Exclusion for GiveWP plugin in apbct-public.js. #2

= 5.159.7 Jul 01 2021 =
 * Fix. Updater fixed.

= 5.159.6 Jun 30 2021 =
 * New. Rest API request detecting implemented.
 * Upd. SFW. AntiCrawler was disabled for the new installations.
 * Upd. SFW. AntiCrawler option moved to the advanced settings section.
 * Mod: email is taken only from visible fields
 * Mod: remove error message about firewall updating
 * Mod: excluded for test WC_Gateway_Tpay_Basic
 * Fix: Added exclude for happyforms.php in apbct_is_skip_request.
 * Fix: Added an error message in the form response
 * Fix: Skip wpforms general requests because of direct integration.
 * Fix. Integration. Autonami Marketing Automations service request kipped.
 * Fix. Cron. Update task method fixed.
 * Fix. SFW. Prevent updating while SFW is disabled.
 * Fix. Cron. Restoring cron tasks during plugin updating.
 * Fix. SFW. Logs sending used limit.
 * Fix: set correct api_key value for ajax calls.
 * Fix. Frontend widget. The widget layout fixed.
 * Fix. Integration. Formidable preparing data for checking.

= 5.159.5 Jun 24 2021 =
 * New: Admin bar. Attention mark added.
 * Upd: Admin notices have been rebuilt.
 * Upd: Integrations with HappyForms updated.
 * Fix: Skip fluentform multistep request.
 * Fix: Correct fluent_form skip name.
 * Fix: Admin notices. Trial and renew notices ID attributes renamed.
 * Fix: Admin bar. Trial notice font color changed.
 * Fix: Admin bar. Show admin bar without api key.
 * Fix: Admin bar. Show attention badge if the api key is empty.
 * Fix: AC. Skip checking on 302 redirects.
 * Fix: Added IF NOT EXISTS after ADD COLUMN in cleantalk-updater.php
 * Fix: Removed ADD PRIMARY KEY from apbct_update_to_5_146_4
 * Fix: Removed apbct_update_to_5_146_4
 * Fix: Checking output parameters of API-method get_2s_blacklists_db.
 * Fix: SFW. Writing exclusions fixed.
 * Fix: Integration. GF names detection fixed.
 * Fix: Integration. WPForms nicknames detecting fixed.
 * Fix. SFW. Updating fixed.
 * Fix: Excluding REST API requests from check.
 * Fix. Admin notices. Incompatibility notice fixed.
 * Fix. Compatibility. Notice saving fixed.
 * Fix. Compatibility. Prevent disabling SFW on incompatibility detected.
 * Fix. Compatibility. SFW option is no longer disabled on incompatibility detected.
 * Fix. Admin bar. Reset counters fixed.

= 5.159.4 Jun 17 2021 =
 * Fix: Admin bar. PHP error.

= 5.159.3 Jun 15 2021 =
 * Fix: Admin bar. Conflict with previous version of Security by Cleantalk.

= 5.159.2 Jun 15 2021 =
 * Fix. Renew notice banner shows only on cleantalk pages.
 * Fix. SFW updating. Getting remote data error handling fixed.
 * Upd. Readme updated.
 * Fix. SFW. Auto-updating fixed.
 * Fix: Admin bar style. Install link is no longer highlighted.
 * Fix: Admin bar style. Style for security icon.
 * Fix: Admin bar. Reset buttons counters leads to the same page.
 * Fix. Manual register link fixed.
 * Fix: do not display errors on subsites when wl is enabled.
 * Fix: Admin bar. Rapid fix.
 * Fix. Skipping. WPForms check restricted email request skipped.
 * Fix. Helper. CURL request timeout increased.
 * Fix. Comments/users checker. Description fixed.
 * Fix. Get fields any. Preset nickname parameter fixed.
 * Fix: wpms settings.

= 5.159.1 Jun 10 2021 =
 * Fix: Cron. Cron calling in cleantalk-updater.php fixed.

= 5.159 Jun 10 2021 =
 * New. Admin Bar. Common admin bar implemented.
 * New: email check before post.
 * New: New admin bar style.
 * New. SFW. Updating integrity control implemented.
 * New. Custom Ajax. Email checking before post.
 * New. Custom Ajax. Getting JS key.
 * New. Custom Ajax. Alternative cookies.
 * Upd. Integrations. Support multiple non-ajax hooks.
 * Upd. Cron. Cron class and cron usage updated.
 * Upd. Pixel. Pixel setting is "auto" for the new installations.
 * Upd. Users checker. Users with completed WC orders no checked.
 * Upd. WPMS settings.
 * Mod. limiting the size of an array top5_spam_ip to five elements in widget.
 * Mod. update data__pixel title.
 * Mod. Update data__use_static_js_key title.
 * Mod. add 'relative' parameter in admin_url() for getting ajaxurl.
 * Mod. update field name honeypot_field, reverse logic
 * Mod. changed website field from comments form: type text, display none.
 * Fix. resolve conflict with wiloke theme and unknown plugin, that removes standard authorization cookies.
 * Fix. moved the wiloke_theme options_ajax_save_skip check to apbct_is_skip_request function.
 * Fix. added a theme check along with a hook wiloke_themeoptions_ajax_save_skip.
 * Fix. Integration. Essentials addons for elementor integration fixed.
 * Fix. AC/AF. Clearing AC table via cron fixed.
 * Fix. SFW. Obtaining the count of the networks was fixed.
 * Fix. Cron. Last cron start fixed.
 * Fix. cookies for login page.
 * Fix. Firewall. Update. Filtering bad data.
 * Fix. Custom Ajax. Localized login scripts.
 * Fix. API. Cleantalk\ApbctWP\API fixed to work on SHORTINIT mode.
 * Fix. Custom Ajax. Getting JS key - removed WP ajax hooks.
 * Fix. GetFieldsAny. Bypassing collecting email and names logic fixed.
 * Fix. New admin bar style. Sorting plugins by Alphabet.
 * Fix. ct_get_admin_email return network email if set.
 * Fix. Fixed the name of the key containing the file address to check the number of records.
 * Fix. Comments checker. Non-checkable users tab removed.
 * Fix. Visible fields. Formidable visible fields collecting fixed.
 * Fix. Get fields any fixed.
 * Fix. empty key error for hosting.
 * Fix. WPMS. Api key saving fixed.
 * Fix. WPMS. Network settings saving fixed.
 * Fix. WPMS. Plugin name setting field is not required now.
 * Fix. Alt sessions js fixed.

= 5.158 May 27 2021 =
 * Fix: Firewall. SQL-request error.

= 5.158 May 26 2021 =
 * New. Integration. WP Foro register system integration.
 * New. Integration. Elementor essentials LoginRegister integration implemented.
 * New: SQL-schema and updater for extended SpamFirewall logs.
 * New: Extended SpamFirewall logs.
 * New: Pixel.
 * Mod: Few improvements to SFW update.
 * Mod: add settings for hidding website field from comment form.
 * Mod: Few improvements to SFW update #2.
 * Mod: Possibility to send empty JSON object in API.
 * Mod: Extended SpamFirewall logs for AntiCrawler module.
 * Upd: SFW. Direct updating method implemented.
 * Upd. Settings. Network settings templates updated.
 * Upd: Firewall. Improvements to update system.
 * Upd: Firewall. Improvements to update system.
 * Fix: replace wp_die to die in ct_die(), refactoring ct_die()
 * Fix. Forms. Exclude field wp-editor-area from collecting visible fields.
 * Fix. Widget. Widget content logic fixed.
 * Fix: Forms. Nicknames detecting fixed #2.
 * Fix: Forms. Getting check_js key fixed.
 * Fix: update ct_die_extended() as ct_die().
 * Fix. Code. Getting delay before js code get if async option enabled.
 * Fix. WPMU. Blog id added in settings templates list.
 * Fix. Integration. Elementor essentials LoginRegister login form protection skipped.
 * Fix. WPMU. Blog id added in settings templates list.
 * Fix. Readme. Required PHP version increased to 5.6.
 * Fix. Updater. 5_157_10 updating fixed #2.
 * Fix. JS. DOMContentLoaded used instead jQuery(document).ready().
 * Fix: SpamFirewall. Update. "FW UPDATE INIT: KEY_EMPTY", "SFW UPDATE INIT: KEY_IS_NOT_VALID" errors.
 * Fix. Users checker. Export to the csv fixed.
 * Fix: SpamFirewall. Update. Error "WRONG_UPDATE_ID".
 * Fix: SpamFirewall. Update. "FW UPDATE INIT: KEY_EMPTY", "SFW UPDATE INIT: KEY_IS_NOT_VALID" errors.
 * Fix: SpamFirewall. Update. Error "WRONG_UPDATE_ID".
 * Fix: \Cleantalk\Common\Helper::http__request() consider only boolean false (empty string '' considering as good) as bad response.
 * Fix: SpamFirewall. Update.
 * Fix: SpamFirewall. Update #2.
 * Fix: WPMS empty apikey in options
 * Fix: "Mod: add settings for hidding website field from comment form".
 * Fix: Common/Helper::http__get_headers() fixed.
 * Fix: SpamFirewall admin bar counter.
 * Fix: "Fix: Common/Helper::http__get_headers() fixed."
 * Fix: Pixel.
 * Fix: "Pixel" setting description.
 * Fix: Extended SpamFirewall logs for AntiCrawler module.
 * Fix: Extended SpamFirewall logs for AntiCrawler module #2.
 * Fix: WPFroms. PHP notice.
 * Fix: Gravity Forms. PHP notice.
 * Revert: Fix: Code. get_fields_any() notice fixed.

= 5.157.2 May 05 2021 =
 * Fix: Code. get_fields_any() notice fixed.
 * Fix: Integration. Gravity Forms integration fixed.
 * Fix: Forms. Nicknames detecting fixed.

= 5.157.1 Apr 29 2021 =
 * Mod: \Cleantalk\ApbctWP\Variables\Cookie::get() now has 'cast_to' param. If defined trying to cast to a given type.
 * Fix: \Cleantalk\ApbctWP\Variables\Cookie::get() calls using 'cast_to' param if needed.

= 5.157 Apr 28 2021 =
 * New: Invisible fields collecting implemented.
 * New: A dev and a fix version suffix support.
 * New: Variables. Cookie::set() method added.
 * New: Split Cleantalk\Common\DB::method__private_list_add__sfw_wl() in two Cleantalk\Common\DB::method__private_list_add() and Cleantalk\ApbctWP\DB::method__private_list_add__sfw_wl().
 * New: Split Cleantalk\ApbctWP\Helper::http__request__rc_to_host() in two Cleantalk\ApbctWP\Helper::http__request__rc_to_host() and Cleantalk\ApbctWP\Helper::http__request__rc_to_host__test().
 * New: Updater script for 5.157.
 * New: Update/delete SpamFireWall database when it enable/disable. Improvements.
 * New: \Cleantalk\ApbctWP\Variables::AltSessions class.
 * New: "Set cookies" setting now has 3 options "On", "Off" and "Use alternative mechanism for cookies".
 * New: REST API route '/alt_sessions' and callbacks.
 * Mod: Compatibility with Thrive Leads - remove deleted the modal window about successful sending when blocking the user.
 * Mod: changed the handling of gravityform fields, added a check for the visibility of the field when processing the name.
 * Mod: Added a setting for Woocommerce, which includes checking the un-logged user when adding an item to the cart. If the user does not pass the verification, the product is not added to the cart.
 * Mod: Added a settings for Woocommerce - correction.
 * Mod: WC add to cart - change settings description.
 * Mod: Cleantalk\ApbctWP\RemoteCalls::debug() improved.
 * Mod: SpaFirewall update.
 * Mod: add buddypress integration for user account personal data.
 * Mod: Moving \Cleantalk\Common\Helper::apbct_cookie__set() to \Cleantalk\ApbctWP\Variables::set() function.
 * Mod: Using \Cleantalk\ApbctWP\Variables::set() instead of \Cleantalk\Common\Helper::apbct_cookie__set().
 * Mod: Extend \Cleantalk\ApbctWP\Variables to use alternative sessions.
 * Mod: Using \Cleantalk\ApbctWP\Variables\AltSessions class instead of set of "apbct_alt_sessions__" functions.
 * Mod: added loading of country flags from the plugin.
 * Mod: added styles for the widget with anti-spam statistics.
 * Mod: Improving ct_enqueue_scripts_public().
 * Mod: Update for JS ctSetCookie().
 * Mod: AltSessions and Cookie using 'data__set_cookies' and 'data__set_cookies' settings.
 * Mod: Minified JS updated.
 * Upd: Setting cookies updating.
 * Upd: Setting cookies by JS updating.
 * Fix: SFW. DB result handling.
 * Fix: Integration. Avada theme settings saving fixed.
 * Fix: Cleantalk modal. Layout fixed.
 * Fix: Possible use an html on ajax forms blocking message.
 * Fix: Include JS logic fixed.
 * Fix: Refactoring. Collecting details about browser refactored.
 * Fix: Refactoring. Alert replacing by console log on REST request handling.
 * Fix: Integration. Gravity Forms integration fixed.
 * Fix: ignoring the hidden fields with name if visible fields exists.
 * Fix: Integration. Formidable multi-step form protection fixed.
 * Fix: add max z-index for #cleantalk-modal-overlay.
 * Fix: Cannot read property 'response_type' of undefined - xhr.responseJSON - undefined where action wc_add_to_cart_block.
 * Fix: Helper. Set cookies method is deprecated now.
 * Fix: Adding admin IP to whitelist during the login in and plugin activation.
 * Fix: SpamFirewall. Don't set cookies if option is disabled.
 * Fix: Sorting methods modifiers in \Cleantalk\Common\Helper and \Cleantalk\ApbctWP\Helper classes.
 * Fix: Using \Cleantalk\ApbctWP\Variables\Cookies.
 * Fix: A dev and a fix version suffix support.
 * Fix: Adding admin IP to whitelist during the login in and plugin activation.
 * Fix: New setting 'Alternative cookies handler type'.
 * Fix: sender_info params.
 * Fix: SpamFirewall deleting 127.0.0.1 from local base during update on local website.
 * Fix: apbct_js_test() considering "Alternative cookie" setting.
 * Fix: Cleantalk\ApbctWP\VariablesCookie::set() automatically set secure flag if null passed.
 * Fix: Check JS via Cookie with the Alternative Cookie on.
 * Fix: Automatically set "secure" param when setcookie() called.
 * Fix: 'Alternative cookies handler type' setting layout.
 * Fix: For legacy apbct__hook__wp_logout__delete_trial_notice_cookie().
 * Fix: Cleantalk\ApbctWP\Variables::set_fromRemote(), Cleantalk\ApbctWP\Variables::get_fromRemote() fix parameter type.
 * Fix: SpamFirewall add admin IP when login in or activate plugin.
 * Fix: Dashboard widget. Showing default Cleantalk's flag if country not found.
 * Fix: Dashboard widget. Showing 'Unknown' country name if country not found.
 * Del: Unused apbct_cookie__set() function.
 * Del: "Use alternative mechanism for cookies" setting.
 * Del: "Use cookies less sessions" setting.

= 5.156 Apr 15 2021 =
 * New: ApbctWP\RemoteCalls::action__debug().
 * New: ApbctWP\Helper::http__get_data_from_remote_gz__and_parse_csv();
 * New: ApbctWP\Helper::http__get_data_from_remote_gz();
 * New: Update/delete SpamFireWall database when it enable/disable.
 * New: \Cleantalk\Common\DNS class. Allows to get with DNS records and theirs different parameters.
 * New: No cookies if disabled from frontend. Alternative cookies if enabled from frontend.
 * New: \Cleantalk\ApbctWP\Variables\Cookie extends Cleantalk\Common\Variables\Cookie and automatically supports alternative cookies.
 * Mod: Don't use alternative cookies for JS cookies for now.
 * Mod: ApbctWP\State default data.
 * Mod: Small code improvements.
 * Mod: Minor code improvements.
 * Mod: Using apbct_sfw_update__init instead() of ct_sfw_update().
 * Mod: Updater script to 5.156.
 * Upd: \Cleantalk\ApbctWP\RemoteCalls.
 * Upd: *.min. files update.
 * Upd: Current moderate*.cleantalk.org IP servers update.
 * Refactor: SpamFireWall update.
 * Fix: ApbctWP\RemoteCalls::action__sfw_update().
 * Fix: \Cleantalk\Common\DNS could request specific DNS type record.
 * Fix: Anti Spam. External forms protection capturing buffer fixed.
 * Fix: SFW. Notices disabled on blocking pages.
 * Fix: Admin ajax handler fixed - alert removed.
 * Fix: No alert when error fires.
 * Fix: Notice. change 'wpms__allow_custom_settings' to 'multisite__allow_custom_settings' in cleantalk-admin.php.
 * Fix: Getting JS key by ajax fixed.
 * Fix: No alert when AJAX fails.
 * Fix: Send plugin version as parameter when apbct-public.min.js script attaching.
 * Fix: The AJAX REST API error text unique.
 * Fix: No alert message when AJAX (REST) error happens.
 * Fix: Skip. MyListing theme service requests skip.
 * Fix: \Cleantalk\ApbctWP\Helper::http__request__rc_to_host(). Considering empty response as error.
 * Fix: \Cleantalk\Common\Helper::http__request(). Empty error while SFW update.
 * Fix: REST API. Required parameter added.
 * Fix: PHP Notices and Warnings.
 * Fix: AntiCrawler UA update.
 * Fix: JS and CSS minified.
 * Fix: ApbctWP\State __get using &. *

= 5.155.2 Apr 6 2021 =
 * Fix: Renaming setting to their original names in old update scripts.
 * Fix: Ajax forms protection response fixed.
 * Fix: No alert message when AJAX error happens.

= 5.155.1 Apr 2 2021 =
  * Fix: Using WP Rest API.
  * Rollback: Show response for all AJAX forms.

= 5.155 Mar 31 2021 =
 * New: Debug. Check connection to API servers.
 * New: Integration. Avada Form Builder.
 * New: Integration. Forminator integration implemented.
 * New: Users checker. Non-checked users tab added.
 * New: SFW. Admin IP will be whitelisted automatically.
 * Mod: Replace "bad" users/comments to "non-checkable".
 * Mod: DisableComments. Disable all comments means disable all comments for any post type.
 * Udp: Setting templates. Product ID support implemented.
 * Udp: Settings. Reorder links actions buttons.
 * Upd: Common. Getting check_js updated.
 * Upd: SFW. Description updated.
 * Fix: Reversed URL exclusions.
 * Fix: Settings. Sync button success ico fixed.
 * Fix: Show response for all AJAX forms #3.
 * Fix: GDPR. Warning text output.
 * Fix: Integration class consider settings.
 * Fix: Exclusions. URL exclusions fixed.
 * Fix: Services Templates. Getting templates optimized.
 * Fix: Services Templates. Possible XSS fixed.
 * Fix: Services Templates. Design layout fixed.
 * Fix: Family of settings comments__disable_comments__* dependencies.
 * Fix: DisableComments class. Media post type includes 'attachment' type.
 * Fix: Exclusion for Thrive Ultimatum.
 * Fix: Common/Helper::http__get_headers() ignores empty header name parts.
 * Fix: Exclusion for GiveWP plugin in apbct-public.js.
 * Fix: Do not consider 501 as correct HTTP response code when getting FW data files.
 * Fix: AntiCrawler::update(). Correct error codes.
 * Fix: ApbctWP\Firewall\SFW::update(). Correct URLs for FILE with protocol.
 * Fix: PHP 8 deprecated notices.
 * Fix: Settings. Reversed dependencies. Applies to WooCommerce and Disable Comments settings.
 * Fix: DisableComments::template__check() returns the correct number of comments for enabled types of posts.
 * Fix: DisableComments class. Visibility of some methods.
 * Exception: Paid Memberships Pro - Login Form.
 * Fix: Exception the SFW check for queries with '/favicon.ico' string.

= 5.154 Mar 17 2021 =
 * New: Settings Templates functionality implemented.
 * New: SFW. Anti-flood protection uses UA lists for filtration.
 * Fix: Forms. Getting check_js delay removed.
 * Fix: Forms. Rotation check_js fixed.
 * Fix: Integration. Newspaper-theme login form protection skipped.
 * Fix: Integration. Newspaper-theme reset password form protection skipped.
 * Fix: Forms. Gravity Forms paypal addon processing skipped.
 * Fix: Exclusion for wpDiscuz - Online Users Addon.
 * Fix: Remote Calls. Wrapper http__request__rc_to_host() don't get an array
 * Fix: JS. Modal window fixed.
 * Fix: JS. Show AJAX result fixed.
 * Fix: Skip. Save abandoned cart checking skip.
 * Fix: Skip. SUMODISCOUNT discout request skip.
 * Fix: Skip. WP eMember login form skip.
 * Fix: SFW. Do not cache constants added.
 * Fix: SFW. AC/AF logging fixed.

= 5.153.7 Mar 15 2021 =
 * Fix: SFW. Updating fixed.

= 5.153.6 Mar 12 2021 =
 * Fix: Show response for all AJAX forms #2.

= 5.153.5 Mar 10 2021 =
 * Fix: Show response for all AJAX forms.

= 5.153.4 Mar 10 2021 =
 * New: SFW. Log could be sent not more often than 3 minutes.
 * New: SFW. Possibility to use DELETE instead of TRUNCATE to delete SFW log.
 * New: Show response for all AJAX forms.
 * Fix: SFW. Sending log. Committing transaction after TRUNCATE log table.
 * Fix: Integration. CF7 different versions compatibility fixed.
 * Fix: Exclusion for WooCommerce.
 * Fix: Possible SQL-injections fixed.

= 5.153.3 Feb 25 2021 =
 * Fix: Security. Preparing UA string for writing to the DB.

= 5.153.2 Feb 25 2021 =
 * Fix: Integration. Registration on WICITY theme.
 * Fix: Integration. Registration on Paid Memberships Pro
 * Fix: IP detection.
 * Fix: Error: SFW_DISABLED.
 * Fix: Formidable form. Error with sophisticated field types.
 * Fix: Remote Calls. Cooldown checking for the SFW update fixed.
 * Fix: easy-login-woocommerce requests exclusion fixed.
 * Fix: Jackmail plugin. Skip all admin-side actions.
 * Fix: Remote Calls. Unused deactivation option removed.
 * Fix: Users checker. Last check date fixed.
 * Fix: Users checker. Total users count description fixed.

= 5.153.1 Feb 20 2021 =
 * Fix: CF7. Modified spam hook #2

= 5.153 Feb 17 2021 =
 * New: Integrations. WPDiscuz integration implemented.
 * New: Using custom modal message instead allert.
 * New: JS cleantalk-modal added.
 * New: Cleantalk\ApbctWP\RemoteCalls class.
 * New: Remote calls using Cleantalk\ApbctWP\RemoteCalls class.
 * New: Cleantalk\ApbctWP\Helper::http__request__rc_to_host(). Wrapper to using RC to the website itself. Makes testing RC before make main.
 * New: Cleantalk\ApbctWP\State::error_toggle().
 * New: SFW update. Make test RC before main.
 * Udp: Integrations. Support several hooks for one integration.
 * Fix: Users. Feedback sending via deleting user fixed.
 * Fix: Users checker. Feedback sending via deleting user fixed.
 * Fix: IP detection.
 * Fix: Users scan. Confirmation message fixed.
 * Fix: SFW. The anti-flood option moved to the advanced settings.
 * Fix: SFW. Show the right url on block page for WPMS.
 * Fix: SFW. The anti-crawler option description fixed.
 * Fix: SFW. The anti-flood option description fixed.
 * Fix: SFW. AC checking on login page fixed.
 * Fix: CF7. Modified spam hook.
 * Fix: SFW. send_logs returning error.
 * Fix: Cleantalk class fixed.
 * Fix: Clearing errors storage before sync.
 * Fix: Clearing SFW errors on updating to 5.151.6.
 * Fix: Updater. Support updating for versions without fix number implemented.
 * Fix: "Email Before Download" plugin request will be skipped.
 * Fix: SFW. Auto-updating option fixed for multisite activation.
 * Fix: Exception for Xoo login form.
 * Fix: Users deleting feedback fixed.

= 5.152.5 Feb 04 2021 =
 * Fix: SFW. Auto-updating interval decreased to 5 mins.
 * Fix: Divi. Skip saving epanel.
 * New: Find users/comments table. Add footer description.
 * Fix: SFW. UA option removed.
 * Fix: SFW. AC checking by UA enabled by default.
 * Fix: SFW. AF disabled by default for the new installations.

= 5.152.4 Feb 01 2021 =
 * Fix: Cron tasks compare fixed.

= 5.152.3 Jan 31 2021 =
 * Fix: Error: SFW_DISABLED.
 * Fix: Moderate connection timeout increased to 6sec.
 * Fix: SFW uses the right API class.

= 5.152.2 Jan 30 2021 =
 * Fix: API-requests.

= 5.152.1 Jan 29 2021 =
 * Fix: Errors in IP detection.

= 5.152 Jan 29 2021 =
 * Fix: Using server protocol for AC checking.
 * Fix: Prevent caching db queries for SFW.
 * Fix: mgm registration temp fix.
 * Upd: Checking skipped request replaced.
 * Fix: Bookly plugin service requests checking skipped.
 * Fix: Youzier login form skipped.
 * Fix: InJob theme lost password skipped.
 * Upd: Showing plugin version on SFW block page.
 * Fix: fix request id rotation.
 * Mod: Show "Insert users" button only for local web servers.
 * Upd: Checking skipped request replaced for non-ajax requests.
 * Fix: BuddyPress edit profile checking skippped.
 * Fix: Unused code removed.
 * Upd: Helper::ip__get() method updated.
 * Fix: UltimateMember password reset skipped.
 * Del: Unused code removed.
 * New: Server::get() now can accept 'URI' as an parameter. Returns full URI like 'http://domain.net/request/path?parameter=value#fragment
 * Mod: apbct_exclusions_check__url__reversed() simplifed and PHPDoc'ed.
 * Mod: apbct_base_call exclusions revised.
 * Mod: $cleantalk_executed chaos simplified.
 * Upd: Shedule sfw update once again if it failed.
 * Fix: Delete cleantalk options via uninstalling.
 * Fix: Deleting table for network sites fixed.
 * Fix: Using host header for AC checking.
 * Fix: Expression formatting fixed.
 * Mod: Cron. Do not runs when it already runs.
 * Mod: Cron class updated.

= 5.151.4 Jan 18 2021 =
 * Fix: Users checking performance fix.
 * Fix: AC disabled if SFW contains less than 50 entries.

= 5.151.3 Jan 15 2021 =
 * Fix: Prevent logging false blocking for whitelisted networks.
 * Integration: Rafflepress integration implemented.
 * Fix: AF limit increased to 20 by default.
 * Fix: skip Sumo waitlist internal request.
 * Fix: skip raq internal request.
 * Fix: check comments number if comment email exists.
 * New: Schema class added.
 * Fix: SFW - Creation sfw table if not exist.
 * Fix: Updater - Creation sfw table if not exist.
 * New: Schema class used.
 * New: AC disabled if networks count is 0.
 * Fix: SFW updating id getting fixed.
 * Fix: SFW networks counter fixed.
 * Fix: Deleting options fixed.

= 5.151.2 Dec 30 2020 =
 * Fix: Prevent skip checking UltimateMember register.
 * Upd: SFW die pages updated - networks count added.
 * Fix: AF auto cleaning table fixed.
 * Fix: Removing spam flag on gravity forms checking.
 * Fix: Remote call's request checking moved to separated func.
 * Fix: Prevent CRON action from remote call request.

= 5.151.1 Dec 22 2020 =
 * Upd: Firewall now has it's own options, independent from the other.
 * Upd: New API server added.
 * Fix: Wrong count of blocked entries fixed
 * Fix: Skip logging for non-blocked requests.
 * Fix: SFW sending logs fixed.
 * Fix: SFW skip Customizer preview requests.
 * Fix: FW do logging an one passed request.
 * Fix: Logging exclusion moved to firewall class.
 * Fix: FW stats option fixed.
 * Upd: New API server added.
 * Fix: SFW logging logic fixed.
 * Fix: SFW sent logs structure fixed.

= 5.151 Dec 17 2020 =
 * Mod: Cleantalk Alternative Sessions. Store time reduces to 1 day.
 * Fix: Unusable alternative cookies table clearing.
 * Fix: AC UA case insensitive checking fixed.
 * Fix: AC UA enabled by default.
 * Fix: AC UA spelling fixed.
 * Fix: skip ajax mailpoet import users.
 * Fix: Helper::get_mime_type().
 * Fix: Users - spam/not spam icons removed.
 * Fix: Users/Comments - additional button removed.
 * Integration: WP Members integration implemented.
 * Fix: Prevent mod_security protection blocking.
 * Fix: WLM sub site key getting fixed.
 * New: SFW updating through a temporary table.
 * New: UA logging for all FW modules.
 * Fix: Replace clearing table from SFW updating process.
 * Fix: SFW - Unused method removed.
 * Fix: IP detection.
 * Fix: Helper - Clean input of null bytes.
 * Fix: SFW updating - https protocol returned.
 * Fix: SFW updating - truncating temporary table.
 * Fix: SFW updating process percents added.

= 5.150.1 Dec 8 2020 =
 * Fix: Jetpack logic fixed.
 * Fix: AC UA table structure fixed.

= 5.150 Dec 3 2020 =
 * Fix: Prevent skip checking woocommerce registration during checkout.
 * Fix: skip gravity multipage checking.
 * New: AC UA checking implemented.
 * Fix: skip buffer replace for rss feeds.
 * Fix: Easy Registration Forms login form skip.
 * Fix: Quotas in hidden fields.
 * Fix: skip tinkoff payment form fields collection.
 * New: Helper prepare_param added.
 * Fix: erforms internal request skip.
 * Integration: Landing Page Builder integration implemented.
 * Upd: Easy Registration Form block message implemented.
 * Integration: Profile Builder.
 * Fix: Skip connector mysql request.
 * New: AC UA - new option implemented.

= 5.149 Nov 19 2020 =
 * Fix: External forms protection fixed.
 * Fix: check for array in spam_stat collect.
 * Fix: Spam Firewall. Operating with IPs on 32 bit systems.
 * Fix: Skip WFU ask_server request.
 * Fix: AC user agents support fixed.
 * New: Hook 'apbct_pre_block_page' added.
 * Fix: Woocommerce ajax internal.
 * Fix: skip redirect ajax login.
 * Fix: SFW updating return statement added.
 * Fix: Skip reset pass checking.
 * Fix: replace current_action() to current_filter().
 * Upd: AMP support description updated.
 * Fix: SQL injection fixed.

= 5.148 Oct 28 2020 =
 * Fix: Visible fields collecting on external forms fixed.
 * Fix: Skip pre-filled form data for specific form.
 * Fix: Security key usage.
 * Upd: External forms protection updated.
 * Upd: External forms protection updated - Convertbox support.
 * Fix: SimpleFiles skip checking job edit.
 * New: JS event apbctAjaxBockAlert added.
 * Fix: Account banner check description.
 * Fix: AC logs table clearing time fixed.

= 5.147.1 Oct 08 2020 =
 * Fix: Visible fields JS error fixed.

= 5.147 Oct 08 2020 =
 * Fix: WPForms. Auto submitting.
 * Fix: Synchronization timeout increased to 25 seconds.
 * Fix: Cookiebot compatibility.
 * Fix: Visible fields logic fixed.
 * New: Duplicated requests prevention.
 * Fix: SpamFireWall auto incremental uses primary key.
 * Fix: Skip woocommerce internal request.
 * Upd: Url exclusions option updated.
 * Fix: Checking comments/users - redirecting after deleting all items fixed.
 * New: Comments scanner - marking as spam action implemented.
 * Fix: SFW table fixed.
 * Upd: Comments scanner - moving to trash instead deleting.
 * Upd: Visible fields collecting functionality updated.

= 5.146.1 Sep 23 2020 =
 * Fix: URL exclusions setting.
 * Fix: Login scripts output fixed.
 * Fix: Updater function name fixed.
 * New: Debug mode for Anti-Crawler.
 * Fix: Pass AC check if 301 HTTP response code received.
 * Fix: Antibot cookie value fixed.

= 5.146 Sep 17 2020 =
 * Fix: Deprecated function wp_blacklist_check() fixed.
 * Fix: Roles exclusion fixed.
 * Mod: Namespace import in \Cleantalk\ApbctWP\Firewall\SFW.
 * Fix: Comments checking fixed.
 * Fix: Spam scan tabs layout fixed.
 * New: Countdown timer implemented for the AntiCrawler page.
 * Mod: User-agent signature added to the AC checking.
 * Mod: Find-spam classes for comments and users refactored
 * Upd: Spam scan - scanning users/comments updated.
 * Fix: Double requests for Ninja Forms.
 * New: 'wpms' flag in sender_info.
 * Fix: Visible params gathering.
 * Fix: WooCommerce AJAX order call 2.
 * Fix: Block page grammar fixed.
 * Fix: Users/comments list - unnecessary button removed.
 * Upd: Skiping AC blocking after 3 sec for real users.
 * New: Countdown timer for AF block page implemented.
 * New: Countdown timer for SFW block page implemented.

= 5.145.2 Sep 03 2020 =
 * Fix: WooCommerce AJAX order call.
 * Fix: AJAX error while getting JS key.
 * Fix: Using the version parameter when attaching cleantalk-public.js on wp-login page.
 * Fix: Showing support link in console when AJAX error occurs.
 * Fix: apbct_public_sendAJAX. Silent mode doesn't write errors to console.

= 5.145.1 Aug 31 2020 =
 * New: Silent mode for AJAX requests.
 * Fix: No nonce check for AJAX JS check.
 * Fix: AJAX JS check using "DOMContentLoaded" event instead of "load".
 * New: Extended error text for failed AJAX requests.
 * Fix: Exclusion for the Frontend Reset Password plugin.
 * Fix: Accept 501 response code for SFW datafiles.
 * Fix: SFW update. The internal array pointer handling.
 * Fix: Exception for the WooCommerce edit profile form.
 * Fix: SFW updating via plugin activation fixed.

= 5.145 Aug 27 2020 =
 * Fix: Blocking pages names fixed.
 * Fix: Logs id modified to prevent the overwriting.
 * Fix: FireWall checking flow fixed.
 * Mod: New SpamFirewall, Anti-Crawler, Anti-Flood modules priority.
 * Upd: Block message updated.
 * Fix: "The sender has been blacklisted" message removed.
 * Fix: "The sender has been whitelisted" message removed.
 * Fix: Integration DW Question & Answer plugin.
 * Fix: Dashboard widget layout fixed.
 * Fix: AC & AD skipping checking by roles.
 * Integration: Estimation Form integration implemented.
 * Fix: External contact forms check.
 * Fix: URL, IP and Role exclusions for all requests.
 * Fix: Exception for WooCommerce adding to cart.
 * Fix: Exception for PPOM for WooCommerce plugin.

= 5.144 Aug 13 2020 =
 * Fix: WPMS setting updating fixed.
 * Fix: Text domain added for some options name.
 * Fix: AntiCrowler die page fixed.
 * Fix: Pause button for comments check fixed.
 * Fix: Delete Anti-Flood table when subsite is deleted.
 * New: Clear Anti-Flood table each 10 minutes.
 * Fix: FW checking for whitelisted skipped.
 * Fix: WP 5.5 JS errors fixed.
 * New: Debug message for auto updating error.
 * Fix: Array declaration fixed.
 * Fix: Skip anti-flood checking for authorized users.
 * Fix: Is whitelisted checking fixed.

= 5.143.1 Aug 06 2020 =
 * Fix: Recursion fixed.
 * Fix: Rebuild url for SFW updating process.

= 5.143 Aug 05 2020 =
 * New: Synchronize button. New way of synchronize with the Cleantalk Cloud.
 * Fix: SpamFireWall (firewall against spam) update, storing system.
 * Fix: Skip Woocomerce metorik send cart.
 * Spam protection improved.
 * Minor fixes.

= 5.142.2 Jul 29 2020 =
 * Fix: Issue with SpamFireWall logs.

= 5.142.1 Jul 28 2020 =
 * Fix: Blocking good bots.

= 5.142 Jul 27 2020 =
 * New: Bot Protection module for Firewall.
 * New: Anti-Crawler module for Firewall.
 * Mod: Improved spam Protection.
 * Fix: Caching plugins auto detection.
 * Fix: Skip Divi system fields.
 * Fix: Ultimate Form Builder exception.
 * Plenty of fixes and upgrades.

= 5.141.3 Jul 17 2020 =
 * Fix: 403 error issues with cache plugins.
 * Fix: remove apbct-common.js.
 * Fix: exclude caspio form.
 * Fix: Recompile nocache map.
 * Fix: indexof is not a function.
 * Fix: SFW updating fix for hosting.
 * Upd: Temporary remove spinner for SFW check.

= 5.141.2 Jul 08 2020 =
 * Fix: SFW issues.
 * Upd: Temporary remove spinner for SFW check.

= 5.141.1 Jul 06 2020 =
 * Fix: Add timeout for first SFW activation.

= 5.141 Jul 06 2020 =
 * Fix: WP Fusion web hooks skipped.
 * Upd: Readme old changelogs replaced.
 * Fix: SFW typo fixed.
 * Upd: Set update banner timer to 15 minutes.
 * Fix: sfw updating after disabling.
 * Fix: sendAjax 403 issues.
 * New: Add wpmu settings template.
 * Fix: SameSite attribute removed for php version <7.3.
 * Fix: Nocache parameter added.
 * Upd: Add description support for convertkit/active campaign.
 * Integration: Enfold Theme contact form.
 * Upd: Add update/add hooks for settings to avoid sfw update issues.

= 5.140.1 Jun 25 2020 =
 * Upd: .POT updated.
 * Upd: RU .po updated.

= 5.140 Jun 18 2020 =
  * New: Add SFW status in plugin settings.
  * Fix: Remove sleep for sfw update.
  * Fix: Check account status only once in 86400 seconds.
  * Fix: Postmark avocet theme.
  * Fix: Find spam users - from-till implemented.
  * Upd: Add common.js.
  * Fix: Bookly admin action excluded.
  * Fix: sfw_pass_key cookie domain attribute removed.
  * Fix: SFW no cache meta tags added.
  * Fix: MEC Pro plugin compatibility fixed.
  * Mod: Catching SpamFireWall update errors.
  * Fix: UltimateBuilder skip fields.
  * Fix: Strip tags on comment.

= 5.139 Jun 02 2020 =
  * Fix: Profile link fixed.
  * Fix: WPMS plugin name fixed.
  * Fix: WPMS plugin settings link fixed.
  * Fix: Integration with Easy Forms for Mailchimp.
  * Fix: JS check on the registration form.
  * Fix: Double JS attaching on the login page.
  * Fix: Clear SpamFireWall table. Throw error if failed.
  * Upd: Cookies attr "samesite" added.
  * New: Users checking result icons added.
  * Upd: Whitelists support added for SFW.
  * Fix: Clear users meta everywhere by complete deactivation.
  * New: Comment notification updated - blacklist links added.
  * Fix: PHP Warning in cleantalk-pluggable.php.
  * Fix: White Label mode is not accessible if CLEANTALK_ACCESS_KEY is defined.
  * Fix: Deprecated condition.
  * Fix: Setting layout for the right to left direction languages.

= 5.138.1 May 20 2020 =
  * Fix: Ninja Forms. Spam submissions.

= 5.138 May 14 2020 =
  * Fix: Scan users fixed.
  * Fix: Notice fixed (Creating default object from empty value).
  * Fix: Creating table for SFW data for child blogs on WPMS.
  * Upd: SFW query optimized.
  * Fix: Adding cleantalk_spamscan_logs table for each blog when updating from 5.137.2.
  * New: White Lists for SFW implemented.
  * Fix: correct comments checking status text.
  * Fix: Users scan. Reducing memory load.
  * Fix: "Capture Buffer" settings. The issue with YoastSEO.
  * Fix: SFW query fixed.
  * Fix: SFW die page fixed.
  * Fix: Membermouse API false positives.
  * Fix: gz*() functions calling from global namespace for now.

= 5.137.1 April 29 2020 =
  * Fix: Call to undefined function wp_get_current_user().
  * Fix: "Capture buffer" setting, YOAST sitemap.
  * Integration: Simple Membership plugin integration implemented.
  * Fix: Integrations system fixed.
  * Fix: Query for SFW fixed.
  * Fix: SFW error handling.

= 5.137 April 23 2020 =
  * Fix: WPMU and WhiteLabel mode fixed.
  * Fix: 403 Response code for blocked entries.
  * Upd: SFW die page updated (spinner and delay).
  * New: SFW query updated.
  * Fix: SFW truncate instead of delete.
  * Fix: AJAX exception for WordPress Membership Plugin – Restrict Content.
  * Fix: Check spam users.
  * Fix: Debug functionality for users check.
  * Fix: Gravity Forms. Modifying message.
  * Fix: Sanitizing settings.
  * Fix: "Delete all spam users" button.

= 5.136.4 April 8 2020 =
  * Security: Possible XSS vulnerability.

= 5.136.3 April 7 2020 =
  * Security: Possible XSS vulnerability.

= 5.136.2 April 7 2020 =
  * Mod: bbPress is using role exclusions now.
  * Mod: Show info on SpamFirewall block page.
  * Mod: Log SpamFirewall tests.
  * Fix: get_fields_any() fixed.
  * Fix: Multiple requests on WooCommerce checkout.
  * Fix: The SpamFirewall block page.

= 5.136.1 April 2 2020 =
  * Mod: Setting "Show links to check Emails, IPs for spam" splitted in two.
  * Mod: Added setting "Manage comments on public pages".
  * Fix: Feedback from public pages.
  * Fix: Output for setting "Manage comments on public pages".
  * Fix: Public widget errors.

= 5.136 April 1 2020 =
  * New: Feature allowing to track missed spam requests with the special plugin.
  * Mod: Enable WooCommerce checkout test by default.
  * Fix: Fluent forms integration fixed.
  * Fix: Logging skipped requests - actions added.
  * Fix: Comments output.
  * Fix: External forms protection.
  * Fix: PHP 7.4 compatibility.
  * Performance improved.

= 5.135 March 16 2020 =
  * New: Setting which disallow sub-sites administrators to manage plugin settings.
  * New: Add custom title for message.
  * Mod: New headers for spam scan tabs.
  * Fix: ARM form login check.
  * Fix: For GET requests in HTTP API.
  * Fix: Getting variables in Get and Server classes.
  * Fix: SFW update system.
  * Fix: Empty connection error in Cleantalk/Antispam/API.

= 5.134 February 27 2020 =
  * Fix: SpamFireWall update large data issues.
  * Fix: Auto-update for some banner notifications.
  * Fix: QuickContactForm protection.
  * Minor fixes.
  * Spam protection improved.

= 5.133.2 February 10 2020 =
  * Fix: Add no-index meta tag to search page only.
  * Fix: Namespace issues.

= 5.133.1 February 03 2020 =
  * Fix: PHP 7.4 issues.
  * Fix: Woocommerce options moved to a separate block.
  * Fix: CSS/HTML issues on settings page.
  * Minor fixes.
  * Spam protection improved.

= 5.133 January 20 2020 =
  * Upd: Rebuilding users/comments scan
  * Fix: UltimateMember - form validation checking fixed.
  * Fix: Exclusion for login form.
  * Fix: Disable scripts on excluded pages.
  * Fix: PHP 7.4 compability.
  * Minor fixes.
  * Spam protection improved.

= 5.132.3 December 19 2019 =
  * Fix: The disable comments functionality.

= 5.132.2 December 17 2019 =
  * Fix: The disable comments functionality.

= 5.132.1 December 17 2019 =
  * Fix: Fatal PHP error.

= 5.132 December 17 2019 =
  * Fix: PHP 7.4 compability
  * New: Settings and description for "disable comments" functionality.
  * Mod: WooCommerce settings moved to separate block.
  * Minor fixes.
  * Spam protection improved.

= 5.131 December 6 2019 =
  * Fix: WooCommerce registration.
  * Fix: Auto update on Wordperss Multisite.
  * Fix: URLs exceptions validation.
  * New: Secuirty improved.
  * Spam protection is improved.
  * Minor fixes ond improvments.

= 5.130.1 November 20 2019 =
  * Fix: Plugin autoupdate issues.
  * FIx: Woocommerce checking.
  * Fix: Correct IP detection.
  * Fix: CSV export not working after update.
  * Fix: QuickForms duplicates issues.

= 5.130 November 14 2019 =
  * Fix: JetPack contact form JS check.
  * FIx: Iphorm AJAX form.
  * Fix: Paid Memberships Pro fix.
  * Fix: Divi theme contact form fix.
  * Integration: Paid Memberships Pro.
  * Integration: Elementor Pro page builder forms.
  * Improved: Compatibility with different server.

= 5.129.1 November 5 2019 =
  * Fix: WooCommerce order detecting.

= 5.129 October 30 2019 =
  * Upd: Localize updated.
  * Fix: Direct $_SERVER access replaced.
  * Integration: The 7 theme contact form.
  * Fix: Minor improvements and bug fixes.
  * Mod: Putting site in maintenance mode during plugin update.

= 5.128.1 October 23 2019 =
  * Fix: Fatal error when using buffer output.
  * Fix: Translate domain for errors.
  * Code: Fix spelling in function name.
  * Fix: JS disabled error.
  * Upd: Comment edit screen updated.
  * Fix: Cleantalk\Arr::search() fixed.

= 5.128 October 17 2019 =
  * Mod: Users check - functionality updated.
  * Fix: Users check - dates format updated.
  * Mod: Comments check - functionality updated.
  * Fix: Comments check - dates format updated.
  * Fix: Fields exclusion fixed.
  * Fix: Notice fixed.
  * Fix: Cleantalk/Antispam/API.
  * Fix: Minor improvements and bug fixes.

= 5.127.4 October 13 2019 =
  * Mod: Automatically decrease amount of checked users by one request if an error occurs.
  * Fix: Security issue.
  * Fix: Static JS key.

= 5.127.3 October 8 2019 =
  * Fix: Errors during registration.

= 5.127.2 October 8 2019 =
  * Integration: SeedProd Coming Soon Page Pro.
  * Fix: WooCommerce double reuqests.
  * Fix: Static JS key.

= 5.127.1 October 7 2019 =
  * Fix: WPMS settings logic.
  * Using default database storage engine for tables.

= 5.127 September 30 2019 =
  * Fix: Delete redirect notice on external forms
  * Fix: Storing spam for 15 days.
  * Fix: correct DiVi display message.
  * Integration: Ultimate Members.
  * Mod: Setting "Use static JS key" switched to "Auto" if it was "No". Default is "Auto".
  * Mod: Moving White Label option to main site settings.
  * New: Use static JS key if cache plugin detected.
  * New: Settings for URLs, fields, roles exclusions.
  * New: Regular Expressions support in URLs, fields exclusions.
  * New: Send validation errors on standard registration form.
  * Updater: Move exclusions from global variable to settings.
  * Deprecated: IP exclusions.

= 5.126 September 9 2019 =
  * Spam protection improved!
  * Integration: Option wheel.
  * Mod: Improved Email detection.
  * Mod: Improved IP detection.
  * Fix: Too large database table with alternative sessions.
  * Fix: Exception for WooCommerce AJAX.
  * Fix: API key validation.
  * Minor fixes.

= 5.125 August 26 2019 =
  * Fix: PHP Notices.
  * Fix: Auto update.
  * Fix: Displaying protection status for IP license.
  * Fix: prevent capturing buffer for XMLRPC requests (check_external functionality).
  * Fix: API key validating.
  * New: Complete deactivation setting.

= 5.124.1 August 8 2019 =
  * Fix: Error on PHP 5.3.

= 5.124 August 8 2019 =
  * Spam protection improved.
  * Fix: SpamFireWall local database counter on Multisite.
  * Fix: Caldera Forms integration.
  * Fix: Settings "Use AJAX for JS check" description.
  * Fix: Formidable integration.
  * New: External forms check now independed from JavaScript.
  * New: Setting Protect external - capture buffer.
  * New: QuForm integration.

= 5.123 July 25 2019 =
  * Fix: Plenty of minor fixes.
  * Fix: wpDiscuz integration.
  * Fix: Integration with bbPress.
  * Fix: New comment email notification.
  * New: Follow-Up Emails integration.
  * Fix: Woocommerce integration.
  * Fix: Spelling.

= 5.122 July 10 2019 =
  * Spam Protection improved.
  * Fix: Error while checking account status.
  * Fix: Conflict with Elementor Pro.
  * Fix: Integration with Ninja Forms.
  * Fix: Integration with Formidable.
  * New: Detecting mobile devices.
  * New: Integration for Easy Forms for Mailchimp.

= 5.121 June 26 2019 =
  * Fix: Translation typos.
  * Fix: Woocommerce integration.
  * Fix: Catching admin in AJAX queries.
  * Mod: Session table (cleantalk_sessions) issue.
  * Mod: Spam protection improved.
  * Integration: Wilcity theme custom registration validation enabled
  * New: Option "Use static JS key".

= 5.120.2 June 17 2019 =
  * Fix: WPForms integration.
  * Fix: Translation and spelling.
  * Fix: Minor PHP error

= 5.120.1 June 6 2019 =
  * Mod: Description for Search form protection.
  * Fix: CSS and JS attachment.
  * Fix: Undefined index error.

= 5.120 June 5 2019 =
  * Fix: bbPress false positives.
  * Fix: SpamFireWall check condition.
  * Fix: SpamFireWall block page.
  * Fix: Catch admin action via search form test.
  * Fix: Catch admin action (AJAX).
  * Mod: Using minified version of JS and CSS.
  * Mod: Date format in statistics.

= 5.119.1 May 30 2019 =
  * Fix: Helper class error.

= 5.119 May 30 2019 =
  * Fix: No more second request after registration.
  * Fix: Activation hook.
  * Fix: Alternative sessions. Clear table.
  * Fix: Stop capchuring AJAX requests in admin area.
  * Fix: Spelling.
  * Fix: Registration cookies set.
  * Mod: SFW exdtended die page when testing.
  * Mod: User-agent modified.
  * New: Test search queries for spam.
  * New: Gathering and output statistics.

= 5.118.4 May 13 2019 =
  * Fix: SFW cookie. Set correct domain for subdomains.
  * Fix: SFW update.
  * Fix: IP detection.
  * Fix: Triggering AJAX check in backend.
  * Fix: Zero submit time on few forms.

= 5.118.3 April 29 2019 =
  * Fix: Spam statistics in dashboard widget.
  * Fix: IP detection.
  * Fix: Double check AJAX integrated forms like Ninja Forms.
  * Fix: Use url exclusions for AJAX forms.

= 5.118.2 April 25 2019 =
  * Mod: Spam filtration quality improved.
  * Mod: Store SFW cookie for 30 days.
  * Mod: Server IP added to connection report.
  * Fix: spam_stat is not defined.

= 5.118.1 April 19 2019 =
  * Fix: Fatal error.
  * Mod: Spam protection improved on registrations.

= 5.118 April 19 2019 =
  * Fix: Cookies on registration page.
  * Fix: Update fix.
  * Fix: Wordpress built-in API.
  * Fix: WooCommerce checkout form.
  * Fix: UpdraftPlus. Saving settings.
  * Fix: Convert Pro saving settings.
  * Fix: UTF-8 Converting.
  * Fix: GDPR notice.
  * Fix: cleantalk_sessions table size reduced.
  * Mod: Localization.
  * Mod: Performance improved.
  * Mod: SpamFierWall improvments.
  * Mod: IP detection improved.
  * Mod: JavaScript check rewised.
  * New: Setting "Use alternative mechanism for cookies".

= 5.117.1 April 5 2019 =
  * Fix: GDPR notice.
  * Fix: noCacheJS localization.
  * Fix: Fatal error when updating.

= 5.117 March 27 2019 =
  * New: Update logic runs on all pages.
  * New: Integration for Ajax Contact Forms plugin.
  * New: Notification for users groups about new comments.
  * New: SFW die page. Show browser and page creation time.
  * Fix: Huge bug in Cleantalk.php connected with servers changing.
  * Fix: Check AJAX requests for logged in users.
  * Fix: Deleting debug in JS.
  * Fix: Validating settings before saving.

= 5.116.3 March 14 2019 =
  * Fix: "Headers already sent" error.
  * Fix: Images paths.
  * Fix: IP detection.
  * Fix: Skip lost password form check
  * Fix: Skip mobile requests (push settings)
  * Fix: PHP notice when detecting BuddyPress template.

= 5.116.2 March 7 2019 =
  * Fix: Creating tables in MariaDB.

= 5.116.1 March 6 2019 =
  * Fix: Creating tables in DB.
  * Fix: PHP Warning in spam statistics widget.

= 5.116 March 6 2019 =
  * Spam filtration quality improved.
  * New: Storing visited URLs.
  * New: Check before validation Contact Form 7, Comments, Jetpack comments.
  * New: Get validation result for Contact Form 7, Comments, Jetpack comments.
  * Fix: ES add subscriber.
  * Fix: IP detection.

= 5.115.2 February 27 2019 =
  * Fix: False positives spam detection in WP Forms and Contact Form 7.

= 5.115.1 February 16 2019 =
  * Fix: SpamFireWall's false positives.

= 5.115 February 14 2019 =
  * Fix: Http_only flag for backend cookies.
  * Fix: Spam filtration improved.
  * New: IP detection improved.
  * Fix: SpamFirewall update speeded up.
  * New: False positives with caching solutions decreased.
  * New: Opportunity to use Wordpress HTTP API to connect with Cloud.

= 5.114 January 31 2019 =
  * New: Setting "Use Wordpress HTTP API" as alternative to CURL. Disabled by default.
  * Fix: Formidable: Adding small JS check when adding JS_key.
  * Mod: layout of settings page.
  * Mod: Banner logic altered.

= 5.113.2 January 18 2019 =
  * Fix: "Settings" link returns to plugin page.

= 5.113.1 January 17 2019 =
  * Fix: Conflict with CityTours theme.
  * Fix: Error for Wordpress lower 4.7.
  * Add: Spam protection: "Validate email for existence".

= 5.113 January 16 2019 =
  * Fix: Fast and Simple Contact Form.
  * Fix: Settings layout.
  * Fix: Error with WooCommerce Quickview.
  * Fix: Bitrix24 contact form.
  * Fix: Request time decreased.
  * Fix: Requesting account status when activating for IP licenses.
  * Add: Precise AJAX request detection.
  * Spam protection improved.

= 5.112 December 21 2018 =
  * Fix: Woocommerce AJAX checkout form.
  * Fix: Profile Builder Pro.
  * Fix: DB structure improvements for WPMS.
  * Spam filtering quality improved.
  * Minor fixes.

= 5.111 December 13 2018 =
  * Fix: Double request in JetPack contact form.
  * Fix: Email notification about spam registration.
  * Fix: Links button for feedback comments.
  * Fix: Mail notification about plugin error.
  * Fix: Key field output.
  * Minor fixes.

= 5.110 November 29 2018 =
  * Integration: BuddyPress ActivityWall spam protection.
  * Add: GDPR setting for shortcode.
  * Add: Support different BuddyPress templates on activity wall.
  * Fix: Admin/moderator checking for validate post data.

= 5.109 November 15 2018 =
  * Fix: Added URL and IP exclusions to Contact Form 7.
  * Fix: js error when responseText is not exists
  * Fix: Sitename when getting key automatically under WPMS.
  * Mod: SpamFireWall is now fully compatible with WPMS.
  * Mod: Setting 'Tell others about CleanTalk' was deleted.
  * Mod: Protection from spam improved.

= 5.108.1 November 8 2018 =
  * Fix: Errors with integration class.

= 5.108 November 7 2018 =
  * Fix: White label mode.
  * Fix: SpamFireWall now can be disabled.
  * Fix: Layout.
  * Integration: WPForms.
  * Add: Message about block for all no integrated AJAX forms.
  * Add: Displaying account name near api key.

= 5.107 October 29 2018 =
  * Fix: Ninja Forms integration.
  * Fix: Cookie usage.
  * Add: Capturing AJAX responses from non integrated forms.
  * Spam protection improved.
  * Minor fixes.

= 5.106 October 11 2018 =
  * Spam filtration improved.
  * New: White Label mode.
  * Modification: Warning message about test on SpamFireWall die page.
  * Integration: WP Maintenance Mode.
  * Fix: S2Member.
  * Fix: JavaScript attachments reconsidered.
  * Fix: Admin banners layout.
  * Fix: Minor layout fixes.

= 5.105 September 26 2018 =
  * Integration: Now bloking spam for QAEngine questions.
  * Fix: Async http__request call.
  * Fix: Unnecessary get_antispam_report_breif method call.
  * Layout: Hide "Do you like Cleantlak?" when key is not ok.
  * Layout: Minor fixes.

= 5.104 September 18 2018 =
  * Fix: Error when saving settings.
  * Fix: Trying update anti spam plugin for the first installation.
  * Fix: Update system.
  * Fix: Errors output.
  * Fix: Plugin's settings under WPMS.
  * Fix: SpamFireWall update.
  * Fix: The server change system repaired.
  * Mod: Cron saving tasks improved.

= 5.103.1 September 14 2018 =
  * Fix: Error when saving settings.
  * Fix: Error when getting key automatically.

= 5.103 September 13 2018 =
  * Fix: Gravity Forms response message.
  * Fix: SpamFireWall redirect to 404 page.
  * Major anti-spam plugin improvement.
  * Recombined setting page.
  * Added error notification.
  * Mod: S2 Members integration.
  * Mod: Improved remote calls.

= 5.102 August 29 2018 =
  * Fix: Users and comments check.
  * Fix: Update from 5.70 or previous versions.
  * Fix: GDPR public JS-script.
  * Fix: Dashboard widget JS scripts attachment.
  * Fix: WooCommerce "Place order" action.
  * Mod: Notification logic altered.
  * Mod: Users check table now has 'Signed up' column.
  * Minor fixes.

= 5.101 August 10 2018 =
  * Fix: Set cookie only for non-dashboard pages.
  * Fix: Dashboard widget JS error.
  * Fix: JavaScript error for some environment.
  * Mod: Antispam protection accelerated for some pages.

= 5.100 July 30 2018 =
  * Fix: JavaScript dependencies.

= 5.99.1 July 17 2018 =
  * IP detection fixed and improved.

= 5.99 July 10 2018 =
  * Fix: WooCommerce false positives.
  * Fix: SpamFireWall IP detection.
  * Minor fixes.

= 5.98 June 27 2018 =
  * Fix: WooCommerce: Theme exclusion.
  * Fix: Public GDPR JS code.
  * Minor fixes.

= 5.97 June 7 2018 =
  * Fix: Update system.
  * Fix: Feedback from public page (admin only).
  * Fix: Users and comment check: API error.
  * Fix: Too many negative reports. (Too big ct_data option)
  * Fix: SpamFireWall: Infinite redirection on the blocking page.
  * Minor fixes.

= 5.96 May 22 2018 =
  * Fix: Update system.
  * Mod: Reset all counters button in admin bar.
  * Mod: GDPR compliance.
  * Minor fixes.

= 5.95.1 May 3 2018 =
  * Fix: "Get key automatically" button display logic.
  * Fix: PHP notices.

= 5.95 May 2 2018 =
  * Spam filtration improved.
  * Fix: Public widget layout.
  * Fix: Connection reports output.
  * Minor fixes.

= 5.94 April 23 2018 =
  * Mod: Async load option for JS.
  * Mod: JS scripts loading is conditional.
  * Fix: IP detection.
  * Fix: IP detection.
  * Fix: Javascript error.

= 5.93.1 April 9 2018 =
  * Fix: Fatal error on PHP 5.5 or lower.

= 5.93 April 9 2018 =
  * Fix: Spam FireWall IP detection.
  * Fix: Contact Form 7. False positives.
  * Mod: Autoupdate function improved.
  * Minor fixes.

= 5.92.2 March 23 2018 =
  * Fix: Error if cURL extension is disabled.

= 5.92.1 March 23 2018 =
  * Fix: Spelling
  * Fix: Fatal error if cURL extension is disabled.

= 5.92 March 22 2018 =
  * IP detection improved.
  * Fix: SSL connection.
  * Fix: False positives spam detection in Contact Form 7.
  * Minor fixes.

= 5.91 March 15 2018 =
  * Fix: Errors for PHP compiled without XML support.
  * Fix: Spelling and translation.
  * Stability increased.
  * Minor fixes.

= 5.90 March 7 2018 =
  * Improvement: Better IP recognition in Spam FireWall.
  * Fix: Gravity Froms blocking message.
  * Security improvments.
  * Minor fixes.

= 5.89 February 21 2018 =
  * Improved spam filtration quality.
  * Improved compatibility.
  * Public widget: Styles and referral link added.
  * Dashboard widget: revised and fixed.
  * Minor fixes.

= 5.88 February 12 2018 =
  * Integration: ConvertPro.
  * Improvement: Search for visitor's names in request.
  * Fix: Contact Form 7 message recognition.
  * Preparation for the remote plugin update.
  * Minor fixes.

= 5.87 February 2 2018 =
  * Filtration quality improved.
  * Fix: WP Foto Vote downloading images.
  * Fix: Fatal error for unsupported PHP 5.2.
  * Fix: Formidable Forms improved spam filtration.

= 5.86 January 25 2018 =
  * Fix: High CPU load with wp-ajax.php.
  * Fix: Mailpoet: Newsletter.
  * Fix: Gravity: Forms standardization for input fields.
  * Fix: ajax hook checks data for contact form.
  * Fix: UTF8 character in requests.

= 5.85 January 11 2018 =
  * Fix: Fast Secure contact form spam block message.
  * Fix: IP license status.
  * Layout: Dashboard widget description altered.

= 5.84 December 26 2017 =
  * Integration: PeepSo contact form
  * Repared: Feedback from comments page.
  * Fix: mb_* functions used only if exists.
  * Fix: Gravity forms: Multi-page form logic repared.
  * Fix: Gravity forms: AJAX form logic repared.
  * Minor fixes.

= 5.83.2 December 19 2017 =
  * Fix: Error in base class.

= 5.83.1 December 19 2017 =
  * Fix: CDN IP detection.

= 5.83 December 19 2017 =
  * Improving: Stability and compatibility.
  * Improving: Spam protection.
  * Fix: Comments logic filtration.
  * Fix: Admin bar counter.
  * Minor errors fixes.

= 5.82.1 December 7 2017 =
  * Fixed minor error with attaching JS and CSS files.

= 5.82 December 4 2017 =
  * Plugin doesn't use PHP sessions anymore.
  * Bug fixes.
  * Improved update logic.

= 5.81 November 22 2017 =
  * Fixed error with "Show/Hide key" button.
  * Slightly improved spam protection for all forms.
  * Small errors fixes.

= 5.80 November 3 2017 =
  * Spam protection improved.
  * Improved filtration quality for WooCommerce checkout.
  * Minor fixes for Spam FireWall.

= 5.79 October 26 2017 =
  * Spam protection improved.
  * Fixed issue with existing spam comments check.
  * Added posibility to exclude IP from check.
  * Minor fixes.

= 5.78 October 16 2017 =
  * Improved compatibility with themes. Changed core functions prefix.
  * Fixed issue with WooCommerce checkout.
  * Spam protection improved.
  * Minor fixes.

= 5.77 October 2 2017 =
  * Connection report's system.
  * Integration for CouponXXL Theme.
  * Fixed issue with mb_* functions.
  * Banners logic updated.

= 5.76 September 20 2017 =
  * Fixed issue with Spam FireWall and caching plugins.
  * Banners logic updated.

= 5.75 September 15 2017 =
  * Pause feature for users/comments spam check.
  * Improved protection from spam.
  * Small fixes.

= 5.74.2 September 2 2017 =
  * Fix for users spam check for PHP 5.3 and lower.

= 5.74.1 September 2 2017 =
  * Fix for the update system and cloud communication.
  * Added possibility to check users and comments for spam with a specific date range.

= 5.74 August 31 2017 =
  * Users and comments spam check: Two check types (fast and accurate).
  * Fix for WooCommerce checkout test.
  * Minor fixes.

= 5.73 August 11 2017 =
  * Fix for spam check for already existed users and comments.
  * Spam FireWall updated.
  * Layout fix for BT Comments.
  * Minor fixes.

= 5.72 July 27 2017 =
  * Improved spam check for existed users and comments.
  * Minor fixes.

= 5.71 July 20 2017 =
  * Improved spam protection for external forms.
  * Optimization.
  * Minor fixes.

= 5.70.2 July 17 2017 =
  * Fix for Spam FireWall for Multisite.

= 5.70.1 July 17 2017 =
  * Fix for Spam FireWall.
  * Spam detection improved.

= 5.70 July 13 2017 =
  * New updater logic.
  * Self cron system.
  * Improved AMP compatibility.
  * Optimization.
  * Fixed users and comments spam check.
  * Fixed layout for Comment's feedback from public page.
  * Updated Spam FireWall.
  * SFW: Spam FireWall counter now work in real-time.
  * SFW: Improved compatibility with different Data Bases.

= 5.69 July 3 2017 =
  * Reviewer - integration.
  * Optimization for Users and Comments check for big databases.
  * Errors fixes.
  * Improved protection from spam.

= 5.68 June 22 2017 =
  * Contact Form for WordPress - Ultimate Form Builder Lite - integration.
  * Contact Bank - Contact Forms Builder - integration.
  * Smart Forms - integration.
  * cformsII - integration.
  * Contact Form by Web-Settler - integration.
  * Error fixes.

= 5.67.3 June 9 2017 =
  * Fixed JS attachment error.

= 5.67.2 June 5 2017 =
  * Fixed error with IP determination.

= 5.67.1 June 4 2017 =
  * Fixed JS error in 5.67 version.
  * Integrations: Enfold theme, Convertplug.
  * Links to check for Emails/IP for spam.
  * Control comments and feedback about them from public post's page.
  * Improved connection stability with cloud service.
  * Spam protection improved.
  * Other small fixes.

= 5.67 June 1 2017 =
  * Integrations: Enfold theme, Convertplug.
  * Links to check for Emails/IP for spam.
  * Control comments and feedback about them from public post's page.
  * Improved connection stability with cloud service.
  * Spam protection improved.
  * Other small fixes.

= 5.66 May 23 2017 =
  * Spam protection improved.
  * Major fixes for users and comments spam check.
  * Added feedback from Wordpress comments list.
  * Fix for "internal forms check" option.
  * Fixed issue with caching Spam FireWall die page.
  * Other small fixes.

= 5.65 May 16 2017 =
  * Fix for PayPal redirecton.
  * Fixed issue with empty query for bulk comments test.
  * Added protection for Enfold contact form.
  * Ninja forms integration.

= 5.64 April 26 2017 =
  * Integration for Facebook registrations.
  * Small fixes for WPMS.
  * Fix for Activecampaign service.
  * Fix for check spam users.
  * Fixed rare notice Notice: Undefined index: REQUEST_URI

= 5.63 April 20 2017 =
  * Fix for the dashboard spam stat widget.
  * Added translation posibility for all text.

= 5.62 April 17 2017 =
  * Fix for the dashboard spam statistics widget.
  * Fix for users spam check.
  * Small appearance changes.

= 5.61 April 6 2017 =
  * Improved filtration.
  * Additional logic for the form recognizing.
  * Integration: Divi Theme Contact Form.
  * Fix: Gravity Forms multipages forms.
  * Stat Widget: Minor fixes.
  * Added possibility to download results of the users check in CSV format.
  * Alteration for settings page (footer).

= 5.60.1 March 29 2017 =
  * Fixed error function 'locale_get_display_region' no exists.

= 5.60 March 29 2017 =
  * Added main dashboard widget with spam sctivity stats.
  * Mailster - integration.
  * Base class updated.

= 5.59 March 24 2017 =
  * Users/comments check fix.
  * Plugin's name changed to Anti-Spam by CleanTalk.
  * Trial banner is dismissable. Disapear for 24h or till logout.
  * Settings modified (Auto testing failed warning).
  * Mailing(inactive key) interval increased to 6 hours.

= 5.58.6 March 16 2017 =
  * Fix for Ninja forms (protection updated).
  * Fix for QA Theme.
  * Fix for RSVP form.
  * Setting changes (Spam FireWall).
  * Improved debug section.
  * Improved gathering data function.
  * Minor fixes.

= 5.58.5 March 6 2017 =
  * Minor backend fix.

= 5.58.4 March 6 2017 =
  * Users check fix (redirect after the check).
  * Fixed PHP Notice "HTTP_REFERER" is unset.
  * Updated Notice logic.

= 5.58.3 February 28 2017 =
  * Bitrix24 Contact form integration.
  * Users/comments check fix.
  * Spam sorting updated.
  * Banner showing logic.

= 5.58.2 February 17 2017 =
  * Cron fix for daily report.

= 5.58.1 February 16 2017 =
  * Minor fixes.

= 5.58 February 15 2017 =
  * Work without access key
  * Bitrix24 contact integration
  * Issues fixes

= 5.57.1 February 8 2017 =
  * Fix for notice logic.

= 5.57 February 8 2017 =
  * Setting page changes.
  * Bug fixes for WooCommerce.
  * Spam FireWall filters only GET requests.
  * Optimization.
  * Minor and major fixes.

= 5.56.1 January 25 2017 =
  * Minor fixes

= 5.56 January 19 2017 =
  * Integrations: MailChimp Premium, Profile Press.
  * Changes comments flow.
  * FireWall updater fix.
  * Users check optimization.

= 5.55 December 23 2016 =
  * Integrations: Caldera Forms, Visual Form Builder.
  * Fix for different 'cookies' header names.
  * Fixed user deletion.

= 5.54 December 12 2016 =
  * Integrations: AmoForms, Contact Form Clean and Simple.
  * Comments check logic refreshed.
  * Registration JS error fix.
  * Users check fix.
  * Fix for translation system.
  * Minor fixes.

= 5.53.1 December 9 2016 =
  * Minor layout fixes.

= 5.53 November 28 2016 =
  * Addition warning before deleting users.
  * Spam FireWall is enabled by default.
  * Usernoise modal feedback / contact form : integration.
  * Translations.
  * Optimization.
  * Fixes.

= 5.52.1 November 14 2016 =
  * Users and comments check: Using new API method.
  * Quick Contact From: Integration via "Custom Contact Forms" setting.
  * JavaScript filtration improved.
  * Translation changes.
  * Optimized JavaScript code.

= 5.51 November 2 2016 =
  * Added protection for internal forms
  * Immediate spam check for comments and users from WP dashboard
  * Optimized code

= 5.50.1 October 24 2016 =
  * Improved filtration in contact forms.
  * Spam FireWall: Fixed issue with SFW logs
  * Skipping service fields: Fast Secure Contact Froms, QU Forms, Custom Contact Forms

= 5.50 October 20 2016 =
  * Custom contact forms: integration.
  * Pirate Forms: integration.
  * PHP 7 compatibility: Deleted third-party JSON library and dependences.
  * PHP 7 compatibility: Fixed end of lines.
  * YOAST Seo: Fixed PHP warnings.
  * Spam FireWall: Minor fix for Spam FireWall counter.
  * Only admin could access to CleanTalk dashboard (exclude Authors an Editors).
  * Improved filtration in contact forms.

= 5.49.2 October 5 2016 =
  * Second Fix for database error. Stable version.

= 5.49.1 October 5 2016 =
  * Fixed database error.

= 5.49 October 3 2016 =
  * Spam FireWall feature: Class upgraded.
  * New feature: Delete links from approved comments.
  * Settings: Grouped.
  * Settings: Altered description fixed spelling mistakes.
  * Settings: Added indicator for Spam FireWall.
  * Admin bar: Added Spam FireWall counter
  * Clean and Simple Contact Form: Direct integration.
  * WooCommerce: Don't check password recovery form.
  * WooCommerce Wishlists: Issue with check for Google bots.
  * JetPack: contact form fix.
  * Fixed and created the defaults for all CleanTalk options.
  * Fixed spelling mistakes.

= 5.48 September 15 2016 =
  * buddyPress: Added private messages filtering. Doesn't check user if he has 3 or more messages in the "sentbox" and "inbox" folders.
  * buddyPress: Added option in settings for private messages check.
  * WooCommerce Wishlist: Added check for wishlists.
  * Fixed issue with "check all post data" option.
  * Improved filtering for Gravity Forms
  * Mobile Assistant Connector fix
  * Minor fixes.

= 5.47 September 5 2016 =
  * WooCommerce: direct integration for checkout form.
  * WooCommerce Sensei: login form fix.
  * bbPress: Added the check for topics and comments with stop_words
  * bbPress: Skip check for admin in comments and topics
  * UserPro: fixes. Request without field "shortcode"
  * Contact Form 7: Bug fix.
  * Spam FireWall: Optimized logs rotation.
  * Updated inner functions (compatibility fix for PHP 5.4+)
  * Fixed output of counters (without spamfirewall stats)
  * Fixed spelling in settings
  * Added "Delete from the list" button in comments spam check page
  * Minor fixes.

= 5.46 August 17 2016 =
  * Fixed issue with admin bar links in WP Multi Network mode.
  * Added "All time counter" and "Daily counter" into admin bar.
  * Added settings to disable counters in admin bar.
  * New style for "Get access key manually" button.

= 5.45.2 August 4 2016 =
  * Added Anti-Spam protection for Quick Event Manager.
  * Improved bulk spam test for users. Now the plugin does not mark as Spam user, if the user IP address has spam activity more than 30 days ago.
  * Fixed bulk spam test for comments. Previous version had a conflict between spam history for IP and Email.
  * Minor fix function to get the API key.

= 5.45.1 July 26 2016 =
  * Fixed issue with missed spam messages, subscriptions.
  * Improved bulk spam test for comments. Now the plugin will not mark as Spam comments, if a comment sender (IP address) has spam activity more than 30 days ago.

= 5.45 July 21 2016 =
  * Optimized bulk spam comments deletion.
  * Turned off JavaScript anti-spam cookies if the option 'Set cookies' is turned off. It helps to avoid issues with Varnish.
  * Added links to bulk spam comments&users removal tool.

= 5.44.1 July 13 2016 =
  * Optimized options getting code.
  * Added the option 'Protect Logged in users' to do anti-spam tests for submissions by logged in users.

= 5.43.2 June 30 2016 =
  * Optimized anti-spam code for AJAX based contact forms.
  * Fixed CSS layout of counters in Admin bar (issue with layout in IE11).

= 5.43.1 June 23 2016 =
  * Added agent version in requests to test a connection between the website and servers.
  * Fixed issue with PHP notices in cleantalk-admin.php.

= 5.43 June 22 2016 =
  * Added spam protection for registrations via 'Login with AJAX' plug-in.
  * Added a new counter to Admin bar that allows to count spam and approved submissions since last reset.
  * Update the code that tests a connection between a website and CleanTalk's servers. New version doesn't generate submissions with email good@cleantalk.org.
  * Fixed issue with spam protection for nested forms by Formidable plug-in.

= 5.42 2016-06-15 =
  * Added anti-spam protection for UserPro.
  * Improved protection for Formidable forms + Varnish.
  * Improved bulk search for spam accounts.
  * Fixed spam protection for pages that contain multiple Formidable forms with same HTML ID.
  * Optimized PHP code to be compatible with PHP 5.4 and above. The patch has been applied to Formidable forms spam protection.
  * Minor fixes in plugin backend.

= 5.41 2016-05-31 =
  * Added HTTP response in plugin response if an network issue was happend.
  * Optimized JavaScript anti-spam test for Formidable forms.
  * Re-stored the option to auto redirect to plugn settings after plugin activation.
  * Updated Spanish, Russian translations.
  * Fixed issue with nasted fields in Formidable forms.

= 5.40.3 2016-05-26 =
  * Added option to encrypt (SSL) connection to CleanTalk anti-spam servers.
  * Added JSON encoding for AJAX forms.
  * Obfuscated private data for Custom contact forms option.
  * Optimized bulk users check for spam over blacklists database.
  * Fixed issue with lost connection to servers and JavaScript anti-spam test.
  * Fixed issue with WordFence and collect_details.

= 5.40.2 2016-05-11 =
  * Improved account status check logic.
  * Fixed issue with double anti-spam tests for FastSecure contact forms.
  * Fixed issue with nulled JavaScript variables assigned from backend. This issue might me occurred on standart WordPress registration form and with failed JavaScript spam test.
  * Fixed issue with session_start() with PHP sessions stored in memcache.

= 5.40.1 2016-04-28 =
  * Fixed issue with Super Socializer.
  * Fixed issue with spam filtration for logged in users and Formidable forms.
  * Added logging of all submitted fields for FastSecure contact form.

= 5.40 2016-04-19 =
  * Added JSON encoding for posts that were protected via Custom contact forms option. It allows show anti-spam logs in the Dashboard in more comfortable view.
  * Minor fix in plugin settings.
  * Fixed pagination for bulk users spam test.
  * Fixed issue with unknown _SESSION.
  * Fixed issue with double Spam FireWall database upload.

= 5.39.1 2016-04-04 =
  * Improved AJAX based anti-spam test with HTTPS backends.
  * Added fix to avoid issue with empty ct_info_flag on JavaScript side.
  * Added logic to exclude caching for Spam FireWall.
  * Removed a condition to skip accounts with 127.0.0.1 IP in spam test for registered acconts.

= 5.38.1 2016-03-24 =
  * Fixed issue with PHP sessions and 'The session id is too long or contains illegal characters'.
  * Removed Spam FireWall protection on /feed page.
  * Disabled anti-spam tests for AJAX calls if the option 'Custom contact forms' is turned off.
  * Added reject notice for spam submissions on Gravity forms with AJAX calls.

= 5.37.3 2016-03-10 =
  * Fixed bug with broken MailPoet previews.
  * Fixed bug with broken Geo My WP pop-up windows.
  * Fixed issue with mb_convert_encoding() function.
  * Removed double JavaScript code in front-end.
  * Removed unused variables in anti spam logic.
  * Added option 'Set cookies' (turned on by default). If the option turned off, the plugin will not generate cookies, but in this case plugin will not protect some rarely used contact forms. Any way, turn this option off be compatible with Varnish in spam protection for WordPress core comments, registrations and most popular contact forms.
  * Added anti-spam protection for Gravity forms via option 'Contact forms' with hook gform_entry_is_spam().

= 5.36.1 2016-02-05 =
  * Fixed bug, when users receive error after logging in
  * Improve anti-spam filters for contact forms.

= 5.36 2016-02-04 =
  * Improved JavaScript anti spam protection
  * Improvements for avoiding blocking requests from payment systems

= 5.35 2016-01-14 =
  * Added support for IP licensing
  * Some anti-spam protection improvements
  * Small backend interface fixes

= 5.34.1 2015-12-17 =
  * Fixed trackback antispam protection: improved checking mechanism
  * Fixed problem with blocking MailPoet: added exclusions in spam checking algorithm

= 5.34 2015-12-10 =
  * Improved spam checking mechanism
  * Added "Collect browser details" option for better antispam protection
  * Fixed custom contact forms checking for AJAX requests
  * Minor translations fixes

= 5.33.1 2015-12-04 =
  * Fixed issue with BBPress: restored old user permission checking mechanism
  * Fixed anti-spam comments checking: sometimes get_comments returned wrong comments number
  * Fixed bulk checking: made numeric indexes in users and comments arrays
  * Fixed trackback and pingback checking: removed exception for checking

= 5.33 2015-12-01 =
  * Backend interface fixes
  * Improved Spam FireWall efficiency
  * Improved performance of anti spam checking

= 5.32 2015-11-26 =
  * Added improvements for manual spam detection
  * Fixed errors in backend
  * Fixed bulk users anti spam checking
  * Added indicator for bulk spam checking
  * Added "Get access key automatically" button

= 5.31 2015-11-11 =
  * Improved backend performance
  * Fixed counter of approved/blocked spam attacks
  * Fixed Spam FireWall logging

= 5.30 2015-11-05 =
  * Improved anti-spam checking
  * Optimized performance
  * Fixed blocking email preview in MailPoet
  * Interface fixes
  * WPMU interface fixes

= 5.29 2015-10-27 =
  * Optimized performance
  * Fixed bugs in custom contact forms spam checking

= 5.28.7 2015-10-23 =
  * Optimized PHP sessions creation algorithm. This fix should increase plugin perfomance on hostings without retenion of PHP sessions files.
  * Removed autoredirection to plugin settings after plugin activation.

= 5.28 2015-10-16 =
  * Fixed errors in anti-spam checking
  * Restored options for spam checking registrations and cpmmon contact forms
  * Improved spam protection
  * Fixed problems with AJAX functionality in MailPoet, WooCommerce and other AJAX plugins

= 5.27 2015-10-13 =
  * Improvements in SpamFireWall feature
  * Code optimization
  * Backend interface fixes

= 5.26 2015-10-05 =
  * Added WordPress Language Pack support
  * Removed spam checking for some autorisation plugins
  * New experimental feature: SpamFireWall

= 5.25.2 2015-09-28 =
  * Fixed backend bug

= 5.25.1 2015-09-28 =
  * Added widget with anti-spam stats
  * Added information about blocked spam attacks in admin dashboard and CleanTalk settings
  * Added ability not to check comments for users with 3 or above allowed comments
  * Added an option 'Help others known CleanTalk' to show information for site visitors, that your site is protected from spam by us
  * Some backend interface settings

= 5.24.1 2015-09-16 =
  * Fixed some errors in frontend
  * Fixed access key saving

= 5.24 2015-09-14 =
  * Backend interface fixes
  * Improvement for AJAX JavaScript spam checking

= 5.23 2015-09-01 =
  * Fixed BuddyPress profile search false positivities of anti-spam protection.
  * Some interface fixes of bulk users & comments spam checking

= 5.22 2015-08-26 =
  * Fixed possible XSS issue for anti-spam test on third-party forms.

= 5.21 2015-08-21 =
  * Fixed bug with skipping spam submissions
  * Fixed bug with receiving old user_token for viewing anti-spam stats
  * Small backend fixes

= 5.20 2015-08-15 =
  * Fixed anti-spam stats in admin bar - now stats updates every hour
  * Fixed issue with skipping spam submissions
  * Added some PHP-constants for advanced users - CLEANTALK_AJAX_USE_BUFFER and CLEANTALK_AJAX_USE_FOOTER_HEADER can be defined to true or false in wp-config.php to control method, which will be used for injection of AJAX script.

= 5.19 2015-08-11 =
  * New feature: anti-spam checking for registered users
  * Fixed issue with AJAX JavaScript anti-spam test.
  * Fixed issue with SEO Yoast xml sitemaps and JavaScript anti-spam test.

= 5.18 2015-08-04 =
  * Fixed issue with user_token
  * Added anti-spam API, see our FAQ

= 5.17 2015-07-23 =
  * Fixed infinite redirection after activation
  * Minor backend fixes

= 5.16 2015-07-22 =
  * Fixed external services checking
  * Fixed mass comments deletion
  * Fixed AJAX anti-spam protection

= 5.15 2015-07-16 =
  * New feature: anti-spam protection for forms, that uses external services

= 5.14 2015-07-03 =
  * Added anti-spam protection for some themes and plugins
  * Some backend fixes

= 5.13 2015-06-12 =
  * Closing notification for anti-spam renew
  * Fixed bulk anti spam comment checking

= 5.12 2015-06-01 =
  * Added option for checking all post data for spam
  * Some JavaScript protection improvements
  * Added option for old JavaScript check (without AJAX)

= 5.10 2015-05-25 =
  * Fixed Javascript error on some forms

= 5.9 2015-05-21 =
  * Fixed Javascript error on CF7 and JetPack
  * Some backend and frontent fixes

= 5.8 2015-05-18 =
  * Minor fixes

= 5.7 2015-05-18 =
  * Fixed French translation
  * Fixed protection algorithm

= 5.6 2015-05-11 =
  * Fixed translation
  * Fixed bulk comments anti-spam checking
  * Added option for disabling anti spam stats in adminbar
  * Some security fixes

= 5.5 2015-04-29 =
  * Fixed security issue
  * Some interface fixes

= 5.4 2015-04-27 =
  * Some interface and functionality changes in plugin settings page
  * Added counter for anti-spam stats in admin bar

= 5.3 2015-04-13 =
  * Added anti-spam protection for Divi theme contact forms
  * Added anti-spam protection for MyMail contact forms
  * Added anti-spam protection for MailPoet Newsletters
  * Some interface and functionality changes in backend

= 5.2 2015-04-01 =
  * Added link for anti-spam stats
  * Added WP User Frontend Pro registration form protection

= 5.1 2015-03-24 =
  * Fixed site crash after installing 5.0 on some websites

= 5.0 2015-03-24 =
  * Added bulk comments checking for spam via CleanTalk blacklists
  * Added anti-spam form protection for 'Ajax Login & Register'
  * Fixed JetPack form protection

= 4.24 2015-03-20 =
  * Added immediate spam protection activation.

= 4.22 2015-03-17 =
  * Added button for automatic spam protection key getting.

= 4.21 2015-03-11 =
  * Added license renew notification.

= 4.20 2015-03-03 =
  * Added German, Italian, Polish, Portuguese translations.
  * Minor code fixes.

= 4.19 2015-02-24 =
  * Increased keys lifetime for JS spam test.

= 4.18 2015-02-17 =
  * Fixed bug with comments approvement - moved ct_unmark_red() to cleantalk-admin.php
  * Added PayPal 'payment_status' in skip list.
  * Added Akismet 'spam' status processing.

= 4.17 2015-02-12 =
  * New base class.
  * Divided code to 3 separate files - common, public and admin.

= 4.16 2015-02-05 =
  * New base class.
  * Fixed JetPack spam filters logics.
  * Optimized Formidable, bbPress, BuddyPress spam filters.

= 4.15 2015-01-29 =
  * Support spam test for Contact Form 7 versions before 3.0.0.
  * Fixed global JS-vars for JS spam test.
  * Fixed online notice cookie logics.
  * Optimized spam filters for FSCF, WooCommerce, JetPack.
  * Optimized option getting.

= 4.14 2015-01-19 =
  * Removed deprecated option from comment approvement code.
  * New API key URL.
  * Trimmed API key in admin panel.
  * Added current options to array sended to CleanTalk servers.
= 4.13 2014-12-29 =
  * Fixed bug with autimatically aprovement not spam comments. Now this option disabled and do not override local WordPress policy.

= 4.12 2014-12-29 =
  * Fixed bug with 'Wrong Access key...' notice in WordPress dashboard.
  * Fixed filtration bug in WordPress dashboard login form.

= 4.11 2014-12-22 =
  * Improved anti-spam protection for custom contact/registration/subscribe forms.
  * Improved anti-spam protection for comments.
  * Accelerated plugin speed for comments, regirstrations and contacts.
  * Added translation to French.

= 4.10 2014-12-10 =
  * Improved anti-spam protection for custom contact/registration/subscribe forms.
  * Option 'Custom contact forms' enabled by default for new setups.
  * Removed settings "Publish relevant comments", "Use encrypted (SSL) connection".
  * Added translation to Danish (thank you for Mikkel at KreativJul.dk).

= 4.9 2014-11-24 =
  * Fixed spam test for Contact Form 7.

= 4.8 2014-11-19 =
  * Improved anti-spam protection for BuddyPress registrations and custom contact forms.

= 4.7 2014-11-16 =
  * Fixed JavaScript spam test for FastSecure contact form.

= 4.6 2014-11-11 =
  * Improved anti-spam protection on BuddyPress registrations.
  * Improved anti-spam protection on contact forms.
  * Removed plugin sign from pending, spam comments. To get details about a comment please use Dashboard at cleantalk.org.
  * Improved Access key validation function.
  * Added protection for bbPress comments via stop list. Stop list function is a list to reject comments by prefiled words. To fill the list please use Dashboard at cleantalk.org.

= 4.5 2014-11-04 =
  * Fixed CF7 JavaScript bug.
  * Fixed rejects in bbPress guests comments.

= 4.4 2014-10-29 =
  * Improved anti-spam JS test for CF7.
  * Fixed 'noscript' text in FaceBook Like preview in Valenti theme.

= 4.2 2014-10-20 =
  * Fixed double checks issue for BuddyPress registrations.
  * Increased timeout limits to find the work server.

= 4.1 2014-10-13 =
  * Optimized code for manual moderation feedback sending.
  * Optimized anti-spam algorithms for comments, contacts and signups.

= 4.0 2014-10-06 =
  * Improved anti-spam protection for custom contact forms.
  * Improved anti-spam protection for registration forms.

= 3.9 2014-10-01 =
  * Did exception to do not break to create new user in WordPress backend.

= 3.8 2014-09-19 =
  * Fixed json_encode() + malformed characters.
  * Fixed JavaScript issue with wpautop().

= 3.6 2014-09-15 =
  * Fixed preg_match() issue for Formidable forms and Custom contact forms.
  * Improved anti-spam protection for Custom contact forms.

= 3.4 2014-09-04 =
  * We've added anti-spam for themes contact forms and any untested contact forms plugins. To use this test enable option "Custom contact forms" in plugin settings.
  * We've added auto rotation for spam comments. Now the plugin removes comments in SPAM folder older then 15 days. This option is enabled by default.

= 3.2 2014-08-27 =
  * Fixed submit_time() logic for failed submits (comments/registrations). Now form fill time resets after every failed submit.

= 3.1 2014-08-19 =
  * Added anti-spam test over senders Cookies.
  * Improved form fill anti-spam test.
  * Improved speed selection of the nearest server to website.
  * Improved anti-spam speed for comments.
  * Relevance anti-spam test disabled by default. To enable test should be used option 'relevance_test'.

= 2.58 2014-08-06 =
  * Added anti-spam protection for signups posted via WooCommerce order form.
  * Improved anti-spam protection for Contact Form 7.
  * Improved anti-spam protection for registrations. Now the plugin looking for JavaScript anti spam test results not only in POST array, but in COOKIES array too. This improvement allows protect signup forms for any untested signups plugins and themes.
  * Updated PHP API. Now the plugin can resolve sender IP for websites behind proxy servers. If the proxy servers uses private IP address.

= 2.57 2014-07-29 =
  * Improved anti-spam protection for comments. The plugin now proccessing website url in the comments form.
  * Fixed sign remove logic for approved comments. Previous version doesn't cut sign for comments approved via AJAX call in WordPress backend.
  * Fixed switching to SSL for comments. Previous version doesn't use secured connection for comments.

= 2.56 2014-07-21 =
  * Fixed account status check logic. Previous version makes unnecessary test API calls when the plugin asks account status check.

= 2.55 2014-07-11 =
  * Fixed bug with account status function. In backend the plugin showed notice 'Please don't forget to disable CAPTCHA if you have it!' on every page.

= 2.54 2014-07-11 =
  * Fixed signup anti-spam protection logic for BuddyPress registrations.
  * Fixed anti-spam protection for JetPack contact form.
  * Changed account status check logic.

= 2.53 2014-06-27 =
  * Fixed anit-spam protection bug for signups.
  * Changed anti-spam functions (comments and signups) priority.

= 2.52 2014-06-25 =
  * Fixed 'Fatal error: Call to a member function get_error_code()' issue with signups via BuddyPress.

= 2.51 2014-06-23 =
  * Added spam protection for registrations via plugin New User Approve by Josh Harrison. If the CleanTalk matched signup as spam this signup will be denied to placing in pending queue.
  * Added option "Use secure (SSL) connection to CleanTalk cloud". If the option enabled plugin will communicate with CleanTalk severs via 128bit encrypted data channel. So, if you have SSL protected webforms on website you can use this option to be sure that visitors personal data safely transmits to CleanTalk servers.
  * Fixed minor bug with loading backend functions.

= 2.49 2014-06-10 =
  * Added spam protection for S2Member Auth.net forms.
  * Added spam protection for multisite signup form.
  * Optimized account status check function.

= 2.46 2014-05-19 =
  * Added: HTML notice about the need to enable JavaScript.
  * Fixed: Fixed pingbacks anti-spam test.

= 2.44 2014-05-12 =
  * Added: Anti-spam protection for S2Member framework.
  * Improved: JavaScript anti-spam test.
  * Improved: Plugin load time for backend and frontend.
  * Fixed: PHP warning mb_convert_encoding()

= 2.42 2014-04-29 =
  * Fixed: JavaScript anti-spam test for comments.

= 2.40 2014-04-25 =
  * New: Fast Secure Contact form support.
  * New: WordPress Landing Pages support

= 2.38 2014-03-27 =
  * Fixed: Registraion form submit time spam test.

= 2.36 2014-03-12 =
  * Reversed to patches from old revisions.

= 2.35 2014-03-12 =
  * New: Notifications about disabled account
  * New: Improved JavaScript spam test.
  * Fixed: Code optimization
  * Fixed: JavaScript test for signups.

= 2.33 2014-02-12 =
  * Fixed: CURLOPT_FOLLOWLOCATION bug at admin notice

= 2.32 2014-02-04 =
  * New: Added notice about automatically approved comment. The notice shows only for first approved comment and only for new commentators (without approved comments) of the blog.
  * New: At WordPress console added banner for notices.
  * Changed: Screenshots updated.

= 2.31 2014-01-24 =
  * New: Added spam protection for JetPack comments
  * Fixed: cURL connection issue "Expect: 100-continue"

= 2.30 2014-01-13 =
  * Changed: Improved servers connection logic.
  * Fixed: Antispam test for Fomidable forms.

= 2.28 2013-12-19 =
  * New: Added protection against spam bots for WooCommerce review form.
  * Fixed: JavaScript anti-spam logic for WooCommerce review form.

= 2.27 2013-12-06 =
  * New: Added protection against spam bots for JetPack Contact form.
  * Fixed: JavaScript anti-spam logic for registrations and Contact form 7.

= 2.25 2013-11-27 =
  * New: Added protection against spam bots for BuddyPress registrations.
  * New: Added protection against spam bots for Contact form 7.
  * New: Added Spanish (es_ES) translation.

= 2.23 2013-11-20 =
  * New: Added automatic training blacklists on spam bot account deletion.
  * New: Added URL to project homepage at plugin options.
  * Changed: Improved anti-spam logic.

= 2.21 2013-11-13 =
  * Changed: WordPress blacklists settings get priority over plugin's anti-spam settings
  * Changed: Disabled management approval comments for regular commentators of the blog. Automatically approved for publication only the comments of the new blog authors.
  * Changed: Removed form submit time test. Imporved JavaScript spam test.
  * Changed: PHP code optimizations

= 2.19 2013-11-08 =
  * New: Antispam protection from spam bots at the registration form
  * Changed: Russian localization for admin panel
  * Changed: PHP code optimizations

= 2.5.18 2013-11-01 =
  * Fixed: Bug with selection of the last comments for post
  * New: Antispam protection for Formidable feedback forms
  * New: Automatic deletion of outdated spam comments
  * New: On/Off option for comments spam filtration
  * Tested with WordPress 3.7.1

= 2.4.15 2013-09-26 =
  * Fixed: Bug with mass comments deletion
  * Changed: Russian localization for admin panel
  * Tested with mulitsite setup (WordPress network or WPMU)

= 2.4.14 2013-08-29 =
  * Changed: Removed feedback requests to the servers for banned (spam) comments.

= 2.4.13 2013-08-19 =
  * Changed: Switched HTTP requests from file_get_contents() to CURL. Added file_get_contens() as backup connection to the servers.
  * Changed: Removed feedback requests for comments moved to trash.
  * Fixed: "Fail connect to servers..." error on hostings with disabled 'allow_url_fopen' PHP option.

= 2.4.12 2013-08-12 =
  * Removed RPC::XML library from plugin.
  * Switched plugin to HTTP+JSON connection with servers.
  * Fixed bug with comments anti-spam tests with non UTF8 codepage.

= 2.4.11 2013-08-02 =
  * Removed spam tests for self-made pingbacks
  * Tested up to WP 3.6

= 2.4.10 2013-07-24 =
  * Fixed warning in PHP 5.4
  * Fixed bug with disabling comments test for Administrators, Authors and Editors
  * "Stop words" settings moved to <a href="http://cleantalk.org/my">Control panel</a> of the service
  * "Response language" settings moved <a href="http://cleantalk.org/my">Control panel</a> of the service

= 2.4.9 =
  * Fixed extra debugging in base class

= 2.4.8 =
  * Enabled convertion to UTF8 for comment and example text
  * Optimized PHP code

= 2.3.8 =
  * Enabled selection the fastest server in the pool
  * Fixed work server in plugin's config

= 2.2.3 =
  * Secured md5 string for JavaScript test
  * Added requests's timestamp to calculate request work time
  * Update base CleanTalk's PHP class

= 2.1.2 =
  * Improved perfomance for processing large comments (over 32kb size)
  * Improved perfomance for bulk operations with comments in Comments panel
  * Added feedback request with URL to approved comment

= 2.0.2 =
  * Fixed bug with JavaScript test and WordPress cache plugins

= 2.0.1 =
  * Added option "Publicate relevant comments" to plugin's options.
  * Added descriptions to plugin options

= 1.5.4 =
  * Fixed HTTP_REFERER transmission to the servers
  * Improved JavaScript spam test
  * Optimized PHP code

= 1.4.4 =
  * Pingback, trackback comments has moved to manual moderataion
  * Added transmission to the serves comment type and URL
  * Post title, body and comments separated into individual data elements
  * Added priority for matched words in the comment with post title
  * Enabled stop words filtration as default option

= 1.3.4 =
  * Removed PHP debugging.

= 1.3.3 =
  * Added notice at admin panel about empty Access key in plugin settings
  * Removed HTTP link to the site project from post page
  * Removed unused options from settings page
  * Tested up to WordPress 3.5

= 1.2.3 =
 * Fixed bug with session_start.

= 1.2.2 =
  * Plugin rename to CleanTalk. Spam prevent plugin
  * Integration Base Class version 0.7
  * Added fast submit check
  * Added check website in form
  * Added feedbacks for change comment status (Not spam, unapprove)
  * Added function move comment in spam folder if CleanTalk say is spam
  * Disable checking for user groups Administrator, Author, Editor
  * Marked red color bad words

= 1.1.2 =
  * Addition: Title of the post attached to the example text in auto publication tool.
  * Tested with WordPress 3.4.1.

= 1.1.1 =
  * HTTP_REFERER bug fixed

= 1.1.1 =
  * Added user locale support, tested up to WP 3.4

= 1.1.0 =
  * First version


== Upgrade Notice ==
= 5.130 November 14 2019 =
  * Fix: JetPack contact form JS check.
  * FIx: Iphorm AJAX form.
  * Fix: Paid Memberships Pro fix.
  * Fix: Divi theme contact form fix.
  * Integration: Paid Memberships Pro.
  * Integration: Elementor Pro page builder forms.
  * Improved: Compatibility with different server.

= 5.129.1 November 5 2019 =
  * Fix: WooCommerce order detecting.

= 5.129 October 30 2019 =
  * Upd: Localize updated.
  * Fix: Direct $_SERVER access replaced.
  * Integration: The 7 theme contact form.
  * Fix: Minor improvements and bug fixes.
  * Mod: Putting site in maintenance mode during plugin update.

= 5.128.1 October 23 2019 =
  * Fix: Fatal error when using buffer output.
  * Fix: Translate domain for errors.
  * Code: Fix spelling in function name.
  * Fix: JS disabled error.
  * Upd: Comment edit screen updated.
  * Fix: Cleantalk\Arr::search() fixed.

= 5.128 October 17 2019 =
  * Mod: Users check - functionality updated.
  * Fix: Users check - dates format updated.
  * Mod: Comments check - functionality updated.
  * Fix: Comments check - dates format updated.
  * Fix: Fields exclusion fixed.
  * Fix: Notice fixed.
  * Fix: Cleantalk/Antispam/API.
  * Fix: Minor improvements and bug fixes.

= 5.127.4 October 13 2019 =
  * Mod: Automatically decrease amount of checked users by one request if an error occurs.
  * Fix: Security issue.
  * Fix: Static JS key.

= 5.127.3 October 8 2019 =
  * Fix: Errors during registration.

= 5.127.2 October 8 2019 =
  * Integration: SeedProd Coming Soon Page Pro.
  * Fix: WooCommerce double reuqests.
  * Fix: Static JS key.

= 5.127.1 October 7 2019 =
  * Fix: WPMS settings logic.
  * Using default database storage engine for tables.

= 5.127 September 30 2019 =
  * Fix: Delete redirect notice on external forms
  * Fix: Storing spam for 15 days.
  * Fix: correct DiVi display message.
  * Integration: Ultimate Members.
  * Mod: Setting "Use static JS key" switched to "Auto" if it was "No". Default is "Auto".
  * Mod: Moving White Label option to main site settings.
  * New: Use static JS key if cache plugin detected.
  * New: Settings for URLs, fields, roles exclusions.
  * New: Regular Expressions support in URLs, fields exclusions.
  * New: Send validation errors on standard registration form.
  * Updater: Move exclusions from global variable to settings.
  * Deprecated: IP exclusions.

= 5.126 September 9 2019 =
  * Spam protection improved!
  * Integration: Option wheel.
  * Mod: Improved Email detection.
  * Mod: Improved IP detection.
  * Fix: Too large database table with alternative sessions.
  * Fix: Exception for WooCommerce AJAX.
  * Fix: API key validation.
  * Minor fixes.

= 5.125 August 26 2019 =
  * Fix: PHP Notices.
  * Fix: Auto update.
  * Fix: Displaying protection status for IP license.
  * Fix: prevent capturing buffer for XMLRPC requests (check_external functionality).
  * Fix: API key validating.
  * New: Complete deactivation setting.

= 5.124.1 August 8 2019 =
  * Fix: Error on PHP 5.3.

= 5.124 August 8 2019 =
  * Spam protection improved.
  * Fix: SpamFireWall local database counter on Multisite.
  * Fix: Caldera Forms integration.
  * Fix: Settings "Use AJAX for JS check" description.
  * Fix: Formidable integration.
  * New: External forms check now independed from JavaScript.
  * New: Setting Protect external - capture buffer.
  * New: QuForm integration.

= 5.123 July 25 2019 =
  * Fix: Plenty of minor fixes.
  * Fix: wpDiscuz integration.
  * Fix: Integration with bbPress.
  * Fix: New comment email notification.
  * New: Follow-Up Emails integration.
  * Fix: Woocommerce integration.
  * Fix: Spelling.

= 5.122 July 10 2019 =
  * Spam Protection improved.
  * Fix: Error while checking account status.
  * Fix: Conflict with Elementor Pro.
  * Fix: Integration with Ninja Forms.
  * Fix: Integration with Formidable.
  * New: Detecting mobile devices.
  * New: Integration for Easy Forms for Mailchimp.

= 5.121 June 26 2019 =
  * Fix: Translation typos.
  * Fix: Woocommerce integration.
  * Fix: Catching admin in AJAX queries.
  * Mod: Session table (cleantalk_sessions) issue.
  * Mod: Spam protection improved.
  * Integration: Wilcity theme custom registration validation enabled
  * New: Option "Use static JS key".

= 5.120.2 June 17 2019 =
  * Fix: WPForms integration.
  * Fix: Translation and spelling.
  * Fix: Minor PHP error

= 5.120.1 June 6 2019 =
  * Mod: Description for Search form protection.
  * Fix: CSS and JS attachment.
  * Fix: Undefined index error.

= 5.120 June 5 2019 =
  * Fix: bbPress false positives.
  * Fix: SpamFireWall check condition.
  * Fix: SpamFireWall block page.
  * Fix: Catch admin action via search form test.
  * Fix: Catch admin action (AJAX).
  * Mod: Using minified version of JS and CSS.
  * Mod: Date format in statistics.


= 5.119.1 May 30 2019 =
  * Fix: Helper class error.

= 5.119 May 30 2019 =
  * Fix: No more second request after registration.
  * Fix: Activation hook.
  * Fix: Alternative sessions. Clear table.
  * Fix: Stop capchuring AJAX requests in admin area.
  * Fix: Spelling.
  * Fix: Registration cookies set.
  * Mod: SFW exdtended die page when testing.
  * Mod: User-agent modified.
  * New: Test search queries for spam.
  * New: Gathering and output statistics.

= 5.118.4 May 13 2019 =
  * Fix: SFW cookie. Set correct domain for subdomains.
  * Fix: SFW update.
  * Fix: IP detection.
  * Fix: Triggering AJAX check in backend.
  * Fix: Zero submit time on few forms.

= 5.118.3 April 29 2019 =
  * Fix: Spam statistics in dashboard widget.
  * Fix: IP detection.
  * Fix: Double check AJAX integrated forms like Ninja Forms.
  * Fix: Use url exclusions for AJAX forms.

= 5.118.2 April 25 2019 =
  * Mod: Spam filtration quality improved.
  * Mod: Store SFW cookie for 30 days.
  * Mod: Server IP added to connection report.
  * Fix: spam_stat is not defined.

= 5.118.1 April 19 2019 =
  * Fix: Fatal error.
  * Mod: Spam protection improved on registrations.

= 5.118 April 19 2019 =
  * Fix: Cookies on registration page.
  * Fix: Update fix.
  * Fix: Wordpress built-in API.
  * Fix: WooCommerce checkout form.
  * Fix: UpdraftPlus. Saving settings.
  * Fix: Convert Pro saving settings.
  * Fix: UTF-8 Converting.
  * Fix: GDPR notice.
  * Fix: cleantalk_sessions table size reduced.
  * Mod: Localization.
  * Mod: Performance improved.
  * Mod: SpamFierWall improvments.
  * Mod: IP detection improved.
  * Mod: JavaScript check rewised.
  * New: Setting "Use alternative mechanism for cookies".

= 5.117.1 April 5 2019 =
  * Fix: GDPR notice.
  * Fix: noCacheJS localization.
  * Fix: Fatal error when updating.

= 5.117 March 27 2019 =
  * New: Update logic runs on all pages.
  * New: Integration for Ajax Contact Forms plugin.
  * New: Notification for users groups about new comments.
  * New: SFW die page. Show browser and page creation time.
  * Fix: Huge bug in Cleantalk.php connected with servers changing.
  * Fix: Check AJAX requests for logged in users.
  * Fix: Deleting debug in JS.
  * Fix: Validating settings before saving.

= 5.116.3 March 14 2019 =
  * Fix: "Headers already sent" error.
  * Fix: Images paths.
  * Fix: IP detection.
  * Fix: Skip lost password form check
  * Fix: Skip mobile requests (push settings)
  * Fix: PHP notice when detecting BuddyPress template.

= 5.116.2 March 7 2019 =
  * Fix: Creating tables in MariaDB.

= 5.116.1 March 6 2019 =
  * Fix: Creating tables in DB.
  * Fix: PHP Warning in spam statistics widget.

= 5.116 March 6 2019 =
  * Spam filtration quality improved.
  * New: Storing visited URLs.
  * New: Check before validation Contact Form 7, Comments, Jetpack comments.
  * New: Get validation result for Contact Form 7, Comments, Jetpack comments.
  * Fix: ES add subscriber.
  * Fix: IP detection.

= 5.115.2 February 27 2019 =
  * Fix: False positives spam detection in WP Forms and Contact Form 7.

= 5.115.1 February 16 2019 =
  * Fix: SpamFireWall's false positives.

= 5.115 February 14 2019 =
  * Fix: Http_only flag for backend cookies.
  * Fix: Spam filtration improved.
  * New: IP detection improved.
  * Fix: SpamFirewall update speeded up.
  * New: False positives with caching solutions decreased.
  * New: Opportunity to use Wordpress HTTP API to connect with Cloud.

= 5.114 January 31 2019 =
  * New: Setting "Use Wordpress HTTP API" as alternative to CURL. Disabled by default.
  * Fix: Formidable: Adding small JS check when adding JS_key.
  * Mod: layout of settings page.
  * Mod: Banner logic altered.

= 5.113.2 January 18 2019 =
  * Fix: "Settings" link returns to plugin page.

= 5.113.1 January 17 2019 =
  * Fix: Conflict with CityTours theme.
  * Fix: Error for Wordperss lower 4.7.
  * Add: Spam protection: "Validate email for existance".

= 5.113 January 16 2019 =
  * Fix: Fast and Simple Contact Form.
  * Fix: Settings layout.
  * Fix: Error with WooCommerce Quickview.
  * Fix: Bitrix24 contact form.
  * Fix: Request time decreased.
  * Fix: Requesting account status when activating for IP licenses.
  * Add: Precise AJAX request detection.
  * Spam protection improved.

= 5.112 December 21 2018 =
  * Fix: Woocommerce AJAX checkout form.
  * Fix: Profile Builder Pro.
  * Fix: DB structure improvements for WPMS.
  * Spam filtering quality improved.
  * Minor fixes.

= 5.111 December 13 2018 =
  * Fix: Double request in JetPack contact form.
  * Fix: Email notification about spam registration.
  * Fix: Links button for feedback comments.
  * Fix: Mail notification about plugin error.
  * Fix: Key field output.
  * Minor fixes.

= 5.110 November 29 2018 =
  * Integration: BuddyPress ActivityWall spam protection.
  * Add: Support different BuddyPress templates on activity wall.
  * Fix: Admin/moderator checking for validate post data.
  * Add: GDPR setting for shortcode.
  * Fix: Increase timeout for spam_check_cms to 15.

= 5.109 November 15 2018 =
  * Fix: Added URL and IP exclusions to Contact Form 7.
  * Fix: js error when responseText is not exists
  * Fix: Sitename when getting key automatically under WPMS.
  * Mod: SpamFireWall is now fully compatible with WPMS.
  * Mod: Setting 'Tell others about CleanTalk' was deleted.
  * Mod: Protection from spam improved.

= 5.108.1 November 8 2018 =
  * Fix: Errors with integration class.

= 5.108 November 7 2018 =
  * Fix: White label mode.
  * Fix: SpamFireWall now can be disabled.
  * Fix: Layout.
  * Integration: WPForms.
  * Add: Message about block for all no integrated AJAX forms.
  * Add: Displaying account name near api key.

= 5.107 October 29 2018 =
  * Fix: Ninja Forms integration.
  * Fix: Cookie usage.
  * Add: Capturing AJAX responses from non integrated forms.
  * Spam protection improved.
  * Minor fixes.

= 5.106 October 11 2018 =
  * Spam filtration improved.
  * New: White Label mode.
  * Modification: Warning message about test on SpamFireWall die page.
  * Integration: WP Maintenance Mode.
  * Fix: S2Member.
  * Fix: JavaScript attachments reconsidered.
  * Fix: Admin banners layout.
  * Fix: Minor layout fixes.

= 5.105 September 26 2018 =
  * Integration: Now bloking spam for QAEngine questions.
  * Fix: Async http__request call.
  * Fix: Unnecessary get_antispam_report_breif method call.
  * Layout: Hide "Do you like Cleantlak?" when key is not ok.
  * Layout: Minor fixes.

= 5.104 September 18 2018 =
  * Fix: Error when saving settings.
  * Fix: Trying update plugin plugin for the first installation.
  * Fix: Update system.
  * Fix: Errors output.
  * Fix: Plugin's settings under WPMS.
  * Fix: SpamFireWall update.
  * Fix: The server change system repaired.
  * Mod: Cron saving tasks improved.

= 5.103.1 September 14 2018 =
  * Fix: Error when saving settings.
  * Fix: Error when getting key automatically.

= 5.103 September 13 2018 =
  * Fix: Gravity Forms response message.
  * Fix: SpamFireWall redirect to 404 page.
  * Major anti-spam plugin improvement.
  * Recombined setting page.
  * Added error notification.
  * Mod: S2 Members integration.
  * Mod: Improved remote calls.

= 5.102 August 29 2018 =
  * Fix: Users and comments check.
  * Fix: Update from 5.70 or previous versions.
  * Fix: GDPR public JS-script.
  * Fix: Dashboard widget JS scripts attachment.
  * Fix: WooCommerce "Place order" action.
  * Mod: Notification logic altered.
  * Mod: Users check table now has 'Signed up' column.
  * Minor fixes.

= 5.101 August 10 2018 =
  * Fix: Set cookie only for non-dashboard pages.
  * Fix: Dashboard widget JS error.
  * Fix: JavaScript error for some environment.
  * Mod: Antispam protection accelerated for some pages.

= 5.100 July 30 2018 =
  * Fix: JavaScript dependencies.

= 5.99.1 July 17 2018 =
  * IP detection fixed and improved.

= 5.99 July 10 2018 =
  * Fix: WooCommerce false positives.
  * Fix: SpamFireWall IP detection.
  * Minor fixes.

= 5.98 June 27 2018 =
  * Fix: WooCommerce: Exclusion.
  * Fix: Public GDPR JS code.
  * Minor fixes.

= 5.97 June 7 2018 =
  * Fix: Update system.
  * Fix: Feedback from public page (admin only).
  * Fix: Users and comment check: API error.
  * Fix: Too many negative reports. (Too big ct_data option)
  * Fix: SpamFireWall: Infinite redirection on the blocking page.
  * Minor fixes.

= 5.96 May 22 2018 =
  * Fix: Update system.
  * Mod: Reset all counters button in admin bar.
  * Mod: GDPR compliance.
  * Minor fixes.

= 5.95.1 May 3 2018 =
  * Fix: "Get key automatically" button display logic.
  * Fix: PHP notices.

= 5.95 May 2 2018 =
  * Spam filtration improved.
  * Fix: Public widget layout.
  * Fix: Connection reports output.
  * Minor fixes.

= 5.94 April 23 2018 =
  * Mod: Async load option for JS.
  * Mod: JS scripts loading is conditional.
  * Fix: IP detection.
  * Fix: IP detection.
  * Fix: Javascript error.

= 5.93.1 April 9 2018 =
  * Fix: Fatal error on PHP 5.5 or lower.

= 5.93 April 9 2018 =
  * Fix: SpamFirewall IP detection.
  * Fix: Contact Form 7. False positives.
  * Mod: Autoupdate function improved.
  * Minor fixes.

= 5.92.2 March 23 2018 =
  * Fix: Error if cURL extension is disabled.

= 5.92.1 March 23 2018 =
  * Fix: Spelling
  * Fix: Fatal error if cURL extension is disabled.

= 5.92 March 22 2018 =
  * IP detection improved.
  * Fix: SSL connection.
  * Fix: False positives spam detection in Contact Form 7.
  * Minor fixes.

= 5.91 March 15 2018 =
  * Fix: Errors for PHP compiled without XML support.
  * Fix: Spelling and translation.
  * Stability increased.
  * Minor fixes.

= 5.90 March 7 2018 =
  * Improvement: Better IP recognition in Spam FireWall.
  * Fix: Gravity Froms blocking message.
  * Security improvments.
  * Minor fixes.

= 5.89 February 21 2018 =
  * Improved spam filtration quality.
  * Improved compatibility.
  * Public widget: Styles and referral link added.
  * Dashboard widget: revised and fixed.
  * Minor fixes.

= 5.88 February 12 2018 =
  * Integration: ConvertPro.
  * Improvement: Search for visitor's names in request.
  * Fix: Contact Form 7 message recognition.
  * Preparation for the remote plugin update.
  * Minor fixes.

= 5.87 February 2 2018 =
  * Filtration quality improved.
  * Fix: WP Foto Vote downloading images.
  * Fix: Fatal error for unsupported PHP 5.2.
  * Fix: Formidable Forms improved spam filtration.

= 5.86 January 25 2018 =
  * Fix: High CPU load with wp-ajax.php.
  * Fix: Mailpoet: Newsletter.
  * Fix: Gravity: Forms standardization for input fields.
  * Fix: ajax hook checks data for contact form.
  * Fix: UTF8 character in requests.

= 5.85 January 11 2018 =
  * Fix: Fast Secure contact form spam block message.
  * Fix: IP license status.
  * Layout: Dashboard widget description altered.

= 5.84 December 26 2017 =
  * Integration: PeepSo contact form
  * Repared: Feedback from comments page.
  * Fix: mb_* functions used only if exists.
  * Fix: Gravity forms: Multi-page form logic repared.
  * Fix: Gravity forms: AJAX form logic repared.
  * Minor fixes.

= 5.83.2 December 19 2017 =
  * Fix: Error in base class.

= 5.83.1 December 19 2017 =
  * Fix: CDN IP detection.

= 5.83 December 19 2017 =
  * Improving: Stability and compatibility.
  * Improving: Spam protection.
  * Fix: Comments logic filtration.
  * Fix: Admin bar counter.
  * Minor errors fixes.

= 5.82.1 December 7 2017 =
  * Fixed minor error with attaching JS and CSS files.

= 5.82 December 4 2017 =
  * Plugin doesn't use PHP sessions anymore.
  * Bug fixes.
  * Improved update logic.

= 5.81 November 22 2017 =
  * Fixed error with "Show/Hide key" button.
  * Slightly improved spam protection for all forms.
  * Small errors fixes.

= 5.80 November 3 2017 =
  * Spam protection improved.
  * Improved filtration quality for WooCommerce checkout.
  * Minor fixes for Spam FireWall.

= 5.79 October 26 2017 =
  * Spam protection improved.
  * Fixed issue with existing spam comments check.
  * Added posibility to exclude IP from check.
  * Minor fixes.

= 5.78 October 16 2017 =
  * Improved compatibility with themes. Changed core functions prefix.
  * Fixed issue with WooCommerce checkout.
  * Spam protection improved.
  * Minor fixes.

= 5.77 October 2 2017 =
  * Connection report's system.
  * Integration for CouponXXL Theme.
  * Fixed issue with mb_* functions.
  * Banners logic updated.

= 5.76 September 20 2017 =
  * Fixed issue with Spam FireWall and caching plugins.
  * Banners logic updated.

= 5.75 September 15 2017 =
  * Pause feature for users/comments spam check.
  * Improved protection from spam.
  * Small fixes.

= 5.74.2 September 2 2017 =
  * Fix for users spam check for PHP 5.3 and lower.

= 5.74.1 September 2 2017 =
  * Fix for the update system and cloud communication.
  * Added possibility to check users and comments for spam with a specific date range.

= 5.74 August 31 2017 =
  * Users and comments spam check: Two check types (fast and accurate).
  * Fix for WooCommerce checkout test.
  * Minor fixes.

= 5.73 August 11 2017 =
  * Fix for spam check for already existed users and comments.
  * Spam FireWall updated.
  * Layout fix for BT Comments.
  * Minor fixes.

= 5.72 July 27 2017 =
  * Improved spam check for existed users and comments.
  * Minor fixes.

= 5.71 July 20 2017 =
  * Improved spam protection for external forms.
  * Optimization.
  * Minor fixes.

= 5.70.2 July 17 2017 =
  * Fix for Spam FireWall for Multisite.

= 5.70.1 July 17 2017 =
  * Fix for Spam FireWall.
  * Spam detection improved.

= 5.70 July 13 2017 =
  * New updater logic.
  * Self cron system.
  * Improved AMP compatibility.
  * Optimization.
  * Fixed users and comments spam check.
  * Fixed layout for Comment's feedback from public page.
  * Updated Spam FireWall.
  * SFW: Spam FireWall counter now work in real-time.
  * SFW: Improved compatibility with different Data Bases.

= 5.69 July 3 2017 =
  * Reviewer - integration.
  * Optimization for Users and Comments check for big databases.
  * Errors fixes.
  * Improved protection from spam.

= 5.68 June 22 2017 =
  * Contact Form for WordPress - Ultimate Form Builder Lite - integration.
  * Contact Bank - Contact Forms Builder - integration.
  * Smart Forms - integration.
  * cformsII - integration.
  * Contact Form by Web-Settler - integration.
  * Error fixes.

= 5.67.3 June 9 2017 =
  * Fixed JS attachment error.

= 5.67.2 June 5 2017 =
  * Fixed error with IP determination.

= 5.67.1 June 4 2017 =
  * Fixed JS error in 5.67 version.
  * Integrations: Enfold theme, Convertplug.
  * Links to check for Emails/IP for spam.
  * Control comments and feedback about them from public post's page.
  * Improved connection stability with cloud service.
  * Spam protection improved.
  * Other small fixes.

= 5.67 June 1 2017 =
  * Integrations: Enfold theme, Convertplug.
  * Links to check for Emails/IP for spam.
  * Control comments and feedback about them from public post's page.
  * Improved connection stability with cloud service.
  * Spam protection improved.
  * Other small fixes.

= 5.66 May 23 2017 =
  * Spam protection improved.
  * Major fixes for users and comments spam check.
  * Added feedback from Wordpress comments list.
  * Fix for "internal forms check" option.
  * Fixed issue with caching Spam FireWall die page.
  * Other small fixes.

= 5.65 May 16 2017 =
  * Fix for PayPal redirecton.
  * Fixed issue with empty query for bulk comments test.
  * Added protection for Enfold contact form.
  * Ninja forms integration.

= 5.64 April 26 2017 =
  * Integration for Facebook registrations.
  * Small fixes for WPMS.
  * Fix for Activecampaign service.
  * Fix for check spam users.
  * Fixed rare notice Notice: Undefined index: REQUEST_URI

= 5.63 April 20 2017 =
  * Fix for the dashboard spam stat widget.
  * Added translation posibility for all text.

= 5.62 April 17 2017 =
  * Fix for the dashboard spam statistics widget.
  * Fix for users spam check.
  * Small appearance changes.

= 5.61 April 6 2017 =
  * Improved filtration.
  * Additional logic for the form recognizing.
  * Integration: Divi Theme Contact Form.
  * Fix: Gravity Forms multipages forms.
  * Stat Widget: Minor fixes.
  * Added possibility to download results of the users check in CSV format.
  * Alteration for settings page (footer).

= 5.60.1 March 29 2017 =
  * Fixed error function 'locale_get_display_region' no exists.

= 5.60 March 29 2017 =
  * Added main dashboard widget with spam sctivity stats.
  * Mailster - integration.
  * Base class updated.

= 5.59 March 24 2017 =
  * Users/comments check fix.
  * Plugin's name changed to Anti-Spam by CleanTalk.
  * Trial banner is dismissable. Disapear for 24h or till logout.
  * Settings modified (Auto testing failed warning).
  * Mailing(inactive key) interval increased to 6 hours.

= 5.58.6 March 16 2017 =
  * Fix for Ninja forms (protection updated).
  * Fix for QA Theme.
  * Fix for RSVP form.
  * Setting changes (Spam FireWall).
  * Improved debug section.
  * Improved gathering data function.
  * Minor fixes.

= 5.58.5 March 6 2017 =
  * Minor backend fix.

= 5.58.4 March 6 2017 =
  * Users check fix (redirect after the check).
  * Fixed PHP Notice "HTTP_REFERER" is unset.
  * Updated Notice logic.

= 5.58.3 February 28 2017 =
  * Bitrix24 Contact form integration.
  * Users/comments check fix.
  * Spam sorting updated.
  * Banner showing logic.

= 5.58.2 February 17 2017 =
  * Cron fix for daily report.

= 5.58.1 February 16 2017 =
  * Minor fixes.

= 5.58 February 15 2017 =
  * Work without access key
  * Bitrix24 contact integration
  * Issues fixes

= 5.57.1 February 8 2017 =
  * Fix for notice logic.

= 5.57 February 8 2017 =
  * Setting page changes.
  * Bug fixes for WooCommerce.
  * Spam FireWall filters only GET requests.
  * Optimization.
  * Minor and major fixes.

= 5.56.1 January 25 2017 =
  * Minor fixes

= 5.56 January 19 2017 =
  * Integrations: MailChimp Premium, Profile Press.
  * Changes comments flow.
  * FireWall updater fix.
  * Users check optimization.

= 5.55 December 23 2016 =
  * Integrations: Caldera Forms, Visual Form Builder.
  * Fix for different 'cookies' header names.
  * Fixed user deletion.

= 5.54 December 12 2016 =
  * Integrations: AmoForms, Contact Form Clean and Simple.
  * Comments check logic refreshed.
  * Registration JS error fix.
  * Users check fix.
  * Fix for translation system.
  * Minor fixes.

= 5.53.1 December 9 2016 =
  * Minor layout fixes.

= 5.53 November 28 2016 =
  * Addition warning before deleting users.
  * Spam FireWall is enabled by default.
  * Usernoise modal feedback / contact form : integration.
  * Translations.
  * Optimization.
  * Fixes.

= 5.52.1 November 14 2016 =
  * Users and comments check: Using new API method.
  * Quick Contact From: Integration via "Custom Contact Forms" setting.
  * JavaScript filtration improved.
  * Translation changes.
  * Optimized JavaScript code.

= 5.51 November 2 2016 =
  * Added protection for internal forms
  * Immediate spam check for comments and users from WP dashboard
  * Optimized code

= 5.50.1 October 24 2016 =
  * Improved filtration in contact forms.
  * Spam FireWall: Fixed issue with SFW logs
  * Skipping service fields: Fast Secure Contact Froms, QU Forms, Custom Contact Forms

= 5.50 October 20 2016 =
  * Custom contact forms: integration.
  * Pirate Forms: integration.
  * PHP 7 compatibility: Deleted third-party JSON library and dependences.
  * PHP 7 compatibility: Fixed end of lines.
  * YOAST Seo: Fixed PHP warnings.
  * Spam FireWall: Minor fix for Spam FireWall counter.
  * Only admin could access to CleanTalk dashboard (exclude Authors an Editors).
  * Improved filtration in contact forms.

= 5.49.2 October 5 2016 =
  * Second Fix for database error. Stable version.

= 5.49.1 October 5 2016 =
  * Fixed database error.

= 5.49 October 3 2016 =
  * Spam FireWall feature: Class upgraded.
  * New feature: Delete links from approved comments.
  * Settings: Grouped.
  * Settings: Altered description fixed spelling mistakes.
  * Settings: Added indicator for Spam FireWall.
  * Admin bar: Added Spam FireWall counter
  * Clean and Simple Contact Form: Direct integration.
  * WooCommerce: Don't check password recovery form.
  * WooCommerce Wishlists: Issue with check for Google bots.
  * JetPack: contact form fix.
  * Fixed and created the defaults for all CleanTalk options.
  * Fixed spelling mistakes.

= 5.48 September 15 2016 =
  * buddyPress: Added private messages filtering. Doesn't check user if he has 3 or more messages in the "sentbox" and "inbox" folders.
  * buddyPress: Added option in settings for private messages check.
  * WooCommerce Wishlist: Added check for wishlists.
  * Fixed issue with "check all post data" option.
  * Improved filtering for Gravity Forms
  * Mobile Assistant Connector fix
  * Minor fixes.

= 5.47 September 5 2016 =
  * WooCommerce: direct integration for checkout form.
  * WooCommerce Sensei: login form fix.
  * bbPress: Added the check for topics and comments with stop_words
  * bbPress: Skip check for admin in comments and topics
  * UserPro: fixes. Request without field "shortcode"
  * Contact Form 7: Bug fix.
  * Spam FireWall: Optimized logs rotation.
  * Updated inner functions (compatibility fix for PHP 5.4+)
  * Fixed output of counters (without spamfirewall stats)
  * Fixed spelling in settings
  * Added "Delete from the list" button in comments spam check page
  * Minor fixes.

= 5.46 August 17 2016 =
  * Fixed issue with admin bar links in WP Multi Network mode.
  * Added "All time counter" and "Daily counter" into admin bar.
  * Added settings to disable counters in admin bar.
  * New style for "Get access key manually" button.

= 5.45.2 August 4 2016 =
  * Added Anti-Spam protection for Quick Event Manager.
  * Improved bulk spam test for users. Now the plugin does not mark as Spam user, if the user IP address has spam activity more then 30 days ago.
  * Fixed bulk spam test for comments. Previous version had a conflict between spam history for IP and Email.
  * Minor fix function to get the API key.

= 5.45.1 July 26 2016 =
  * Fixed issue with missed spam messages, subscriptions.
  * Improved bulk spam test for comments. Now the plugin will not mark as Spam comments, if a comment sender (IP address) has spam activity more then 30 days ago.

= 5.45 July 21 2016 =
  * Optimized bulk spam comments deletion.
  * Turned off JavaScript anti-spam cookies if the option 'Set cookies' is turned off. It helps to avoid issues with Varnish.
  * Added links to bulk spam comments&users removal tool.

= 5.44.1 July 13 2016 =
  * Optimized options getting code.
  * Added the option 'Protect Logged in users' to do anti-spam tests for submissions by logged in users.

= 5.43.2 June 30 2016 =
  * Optimized anti-spam code for AJAX based contact forms.
  * Fixed CSS layout of counters in Admin bar (issue with layout in IE11).

= 5.43.1 June 23 2016 =
  * Added agent version in requests to test a connection between the website and servers.
  * Fixed issue with PHP notices in cleantalk-admin.php.

= 5.43 June 22 2016 =
  * Added spam protection for registrations via 'Login with AJAX' plug-in.
  * Added a new counter to Admin bar that allows to count spam and approved submissions since last reset.
  * Update the code that tests a connection between a website and CleanTalk's servers. New version doesn't generate submissions with email good@cleantalk.org.
  * Fixed issue with spam protection for nested forms by Formidable plug-in.

= 5.42 2016-06-15 =
  * Added anti-spam protection for UserPro.
  * Improved protection for Formidable forms + Varnish.
  * Improved bulk search for spam accounts.
  * Fixed spam protection for pages that contain multiple Formidable forms with same HTML ID.
  * Optimized PHP code to be compatible with PHP 5.4 and above. The patch has been applied to Formidable forms spam protection.
  * Minor fixes in plugin backend.

= 5.41 2016-05-31 =
  * Added HTTP response in plugin response if an network issue was happend.
  * Optimized JavaScript anti-spam test for Formidable forms.
  * Re-stored the option to auto redirect to plugn settings after plugin activation.
  * Fixed issue with nasted fields in Formidable forms.

= 5.40.3 2016-05-26 =
  * Added option to encrypt (SSL) connection to CleanTalk anti-spam servers.
  * Added JSON encoding for AJAX forms.
  * Obfuscated private data for Custom contact forms option.
  * Optimized bulk users check for spam over blacklists database.
  * Fixed issue with lost connection to servers and JavaScript anti-spam test.
  * Fixed issue with WordFence and collect_details.

= 5.40.2 2016-05-11 =
  * Improved account status check logic.
  * Fixed issue with double anti-spam tests for FastSecure contact forms.
  * Fixed issue with nulled JavaScript variables assigned from backend. This issue might me occurred on standart WordPress registration form and with failed JavaScript spam test.
  * Fixed issue with session_start() with PHP sessions stored in memcache.

= 5.40.1 2016-04-28 =
  * Fixed issue with Super Socializer.
  * Fixed issue with spam filtration for logged in users and Formidable forms.
  * Added logging of all submitted fields for FastSecure contact form.

= 5.40 2016-04-19 =
  * Added JSON encoding for posts that were protected via Custom contact forms option. It allows show anti-spam logs in the Dashboard in more comfortable view.
  * Minor fix in plugin settings.
  * Fixed pagination for bulk users spam test.
  * Fixed issue with unknown _SESSION.
  * Fixed issue with double Spam FireWall database upload.

= 5.39.1 2016-04-04 =
  * Improved AJAX based anti-spam test with HTTPS backends.
  * Added fix to avoid issue with empty ct_info_flag on JavaScript side.
  * Added logic to exclude caching for Spam FireWall.
  * Removed a condition to skip accounts with 127.0.0.1 IP in spam test for registered acconts.

= 5.38.1 2016-03-24 =
  * Fixed issue with PHP sessions and 'The session id is too long or contains illegal characters'.
  * Removed Spam FireWall protection on /feed page.
  * Disabled anti-spam tests for AJAX calls if the option 'Custom contact forms' is turned off.
  * Added reject notice for spam submissions on Gravity forms with AJAX calls.

= 5.37.3 2016-03-10 =
  * Minor bug fixes. Added an option to support Varnish cache.

= 5.36.1 2016-02-05 =
  * Fixed bug, when users receive error after logging in

= 5.36 2016-02-04 =
  * Improved JavaScript anti spam protection
  * Improvements for avoiding blocking requests from payment systems

= 5.35 2016-01-14 =
  * Added support for IP licensing
  * Some anti-spam protection improvements
  * Small backend interface fixes

= 5.34.1 2015-12-17 =
  * Fixed trackback antispam protection: improved checking mechanism
  * Fixed problem with blocking MailPoet: added exclusions in spam checking algorithm

= 5.34 2015-12-10 =
  * Improved spam checking mechanism
  * Added "Collect browser details" option for better antispam protection
  * Fixed custom contact forms checking
  * Minor translations fixes

= 5.33.1 2015-12-04 =
  * Fixed issue with BBPress
  * Fixed anti-spam comments checking
  * Fixed bulk checking
  * Fixed trackback and pingback checking

= 5.33 2015-12-01 =
  * Backend interface fixes
  * Improved Spam FireWall efficiency
  * Improved performance of anti spam checking

= 5.32 2015-11-26 =
  * Added improvements for manual spam detection
  * Fixed errors in backend
  * Fixed bulk users anti spam checking
  * Added indicator for bulk spam checking
  * Added "Get access key automatically" feature

= 5.31 2015-11-11 =
  * Improved backend performance
  * Fixed counter of approved/blocked spam attacks
  * Fixed Spam Firewall logging

= 5.30 2015-11-05 =
  * Improved anti-spam checking
  * Optimized performance
  * Fixed blocking email preview in MailPoet
  * Interface fixes
  * WPMU interface fixes

= 5.29 2015-10-27 =
  * Optimized performance
  * Fixed bugs in custom contact forms spam checking

= 5.28.7 2015-10-23 =
  * Major backend peromance fix.

= 5.28 2015-10-16 =
  * Fixed errors in anti-spam checking
  * Restored options for spam checking registrations and cpmmon contact forms
  * Improved anti spam defence
  * Fixed problems with AJAX functionality in MailPoet, WooCommerce and other AJAX plugins

= 5.27 2015-10-13 =
  * Improvements in Spam FireWall feature
  * Code optimization
  * Backend interface fixes

= 5.26 2015-10-05 =
  * Added WordPress Language Pack support
  * Removed spam checking for some autorisation plugins
  * New experimental feature: Spam FireWall

= 5.25.2 2015-09-28 =
  * Fixed backend bug

= 5.25.1 2015-09-28 =
  * Added widget with anti-spam stats
  * Added information about blocked spam attacks in admin dashboard and CleanTalk settings
  * Added ability not to check comments for users with 3 or above allowed comments
  * Added an option 'Help others known CleanTalk' to show information for site visitors, that your site is protected from spam by us
  * Some backend interface settings
  * Removed "CleanTalk connection test" query

= 5.24.1 2015-09-16 =
  * Fixed some errors in frontend
  * Fixed access key saving

= 5.24 2015-09-14 =
  * Backend interface fixes
  * Improvement for AJAX JavaScript spam checking

= 5.23 2015-09-01 =
  * Fixed BuddyPress profile search false positivities of anti-spam protection.
  * Some interface fixes of bulk users & comments spam checking

= 5.22 2015-08-26 =
  * Fixed possible XSS issue for anti-spam test on third-party forms.

= 5.21 2015-08-21 =
  * Fixed bug with skipping spam submissions
  * Fixed bug with receiving old user_token for viewing anti-spam stats
  * Small backend fixes

= 5.20 2015-08-15 =
  * Fixed anti-spam stats in admin bar
  * Fixed issue with skipping spam submissions
  * Added some PHP-constants for advanced users

= 5.19 2015-08-11 =
  * New feature: anti-spam checking for registered users
  * Fixed issue with AJAX JavaScript checking
  * Fixed issue with SEO Yoast xml sitemaps.

= 5.18 2015-08-04 =
  * Fixed issue with user_token
  * Added anti-spam API, see our FAQ

= 5.17 2015-07-23 =
  * Fixed infinite redirection after activation
  * Minor backend fixes

= 5.16 2015-07-22 =
  * Fixed external services checking
  * Fixed mass comments deletion
  * Fixed AJAX anti-spam protection

= 5.15 2015-07-16 =
  * New feature: anti-spam protection for forms, that uses external services

= 5.14 2015-07-03 =
  * Added anti-spam protection for some themes and plugins
  * Some backend fixes

= 5.13 2015-06-12 =
  * Closing notification for anti-spam renew
  * Fixed bulk anti spam comment checking

= 5.12 2015-06-01 =
  * Added option for checking all post data for spam
  * Some JavaScript protection improvements
  * Added option for old JavaScript check (without AJAX)

= 5.10 2015-05-25 =
  * Fixed Javascript error on some forms

= 5.9 2015-05-21 =
  * Fixed Javascript error on CF7 and JetPack
  * Some backend and frontent fixes

= 5.8 2015-05-18 =
  * Minor fixes

= 5.7 2015-05-18 =
  * Fixed French translation
  * Fixed protection algorithm

= 5.6 2015-05-11 =
  * Fixed translation
  * Fixed bulk comments anti-spam checking
  * Added option for disabling anti spam stats in adminbar
  * Some security fixes

= 5.5 2015-04-29
  * Fixed security issue

= 5.4 2015-04-27 =
  * Some interface and functionality changes in plugin settings page
  * Added counter for anti-spam stats in admin bar

= 5.3 2015-04-13 =
  * Added anti-spam protection for Divi theme contact forms
  * Added anti-spam protection for MyMail contact forms
  * Added anti-spam protection for MailPoet Newsletters
  * Some interface and functionality changes in backend

= 5.2 2015-04-01 =
  * Added link for anti-spam stats
  * Added WP User Frontend Pro registration form protection

= 5.10 2015-03-24 =
  * Fixed site crash after installing 5.0 on some websites

= 5.00 2015-03-24 =
  * Added bulk comments checking for spam via CleanTalk blacklists
  * Added anti-spam form protection for 'Ajax Login & Register'
  * Fixed JetPack form protection

= 4.24 2015-03-20 =
Added immediate spam protection activation.

= 4.22 2015-03-17 =
  * Added button for automatic spam protection key getting.

= 4.21 2015-03-11 =
  * Added license renew notification.

= 4.20 2015-03-03 =
  * German, Italian, Polish, Portuguese translations, minor code fixes.

= 4.19 2015-02-24 =
  * Increased JS keys lifetime.

= 4.18 2015-02-17 =
  * Bugfix - fixed bug with comments approvement, PayPal 'payment_status' and Akismet 'spam' status processing.

= 4.17 2015-02-12 =
  * New base class, divided code to 3 separate files - common, public and admin.

= 4.16 2015-02-05 =
  * New base class, fixed JetPack filters logics, optimized Formidable, bbPress, BuddyPress filters.

= 4.15 2015-01-29 =
  * Support of Contact Form 7 versions before 3.0.0, fixed global JS-vars and online notice cookie logics.

= 4.14 2015-01-19 =
  * Removed deprecated option from comment approvement code.

= 4.13 2014-12-29 =
  * Not spam comments auto approvement bug fix.

= 4.12 2014-12-29 =
  * Plugin backend minfor bug fixes.

= 4.11 2014-12-22 =
  * Major changes in spam protection algorithms.

= 4.10 2014-12-10 =
  * Minor improvements for custom contact/registration/subscribe forms.

= 4.9 2014-11-24 =
  * Minor bug fix for Contact form 7.

= 4.8 2014-11-19 =
  * Improved anti-spam protection for BuddyPress registrations and custom contact forms.

= 4.7 2014-11-16 =
  * Fixed JavaScript antispam test for FastSecure contact form.

= 4.6 2014-11-11 =
  * Minor changes in anti-spam logic for BuddyPress registrations, contact forms and bbPress guest posting.

= 4.5 2014-11-04 =
  * Bug fixes for Contact form 7 and bbPress guests posting.

= 4.4 2014-10-29 =
  * Improved JS checking for CF7.

= 4.2 2014-10-20 =
  * Increased plugin perfomance for BuddyPress registrations.

= 4.1 2014-10-13 =
  * Minor anti-spam improvements for contacts, registration and contact forms.

= 4.0 2014-10-06 =
  * Major anti-spam improvements for registration and contact forms.

= 3.9 2014-10-01 =
  * Did exception to do not break to create new user in WordPress backend.

= 3.8 2014-09-19 =
  * Bug fix release. Minor fixes in API class and JavaScript anti-spam test.

= 3.6 2014-09-15 =
  * Minor fixes in anti-spam protection for Formidable and custom contact forms.

= 3.4 2014-09-04 =
  * Spam comments rotation. Custom (themes) contact forms support.

= 3.2 2014-08-27 =
  * Minor changes in spam filtration logic.

= 3.1 2014-08-19 =
  * Major changes for comments antispam logic. Improved plugin speed.

= 2.59 2014-08-14 =
  * Antispam protection for bbPress guests posts. Improvement for JetPack comments and PHP API update.

= 2.58 2014-08-06 =
  * Added anti-spam protection for signups posted via WooCommerce order form.
  * Improved anti-spam protection for Contact Form 7.
  * Improved anti-spam protection for registrations. Now the plugin looking for JavaScript antispam test results not only in POST array, but in COOKIES array too. This improvement allows protect signup forms for any untested signups plugins and themes.
  * Updated PHP API. No the plugin can resolve sender IP for websites behind proxy servers. If the proxy servers uses private IP address.

= 2.57 2014-07-29 =
  * Improved anti-spam protection for comments. The plugin now proccessing website url in the comments form.
  * Fixed sign remove logic for approved comments. Previous version doesn't cut sign for comments approved via AJAX call in WordPress backend.
  * Fixed switching to SSL for comments. Previous version doesn't use secured connection for comments.

= 2.56 2014-07-21 =
  * Fixed account status check logic. Previous version makes unnecessary test API calls when the plugin asks account status check.

= 2.55 2014-07-11 =
  * Fixed bug with account status function. In backend the plugin showed notice 'Please don't forget to disable CAPTCHA if you have it on every page.

= 2.54 2014-07-11 =
  * Fixed signup anti-spam protection logic for BuddyPress registrations.
  * Fixed anti-spam protection for JetPack contact form.
  * Changed account status check logic.

= 2.53 2014-06-27 =
  * Fixed anit-spam protection bug for signups.
  * Changed anti-spam functions (comments and signups) priority.

= 2.52 2014-06-25 =
  * Fixed 'Fatal error: Call to a member function get_error_code()' issue with signups via BuddyPress.

= 2.51 2014-06-23 =
  * Added spam protection for registrations via plugin New User Approve by Josh Harrison. If the CleanTalk matched signup as spam this signup will be denied to placing in pending queue.
  * Added option "Use secure (SSL) connection to CleanTalk cloud". If the option enabled plugin will communicate with CleanTalk severs via 128bit encrypted data channel. So, if you have SSL protected webforms on website you can use this option to be sure that visitors personal data safely transmits to CleanTalk servers.
  * Fixed minor bug with loading backend functions.

= 2.49 2014-06-10 =
  * Added spam protection for S2Member Auth.net forms.
  * Added spam protection for multisite signup form.
  * Optimized account status check function.

= 2.46 2014-05-19 =
  * Added: HTML notice about the need to enable JavaScript.
  * Fixed: Fixed pingbacks anti-spam test.

= 2.44 2014-05-12 =
  * Added: Anti-spam protection for S2Member framework.
  * Improved: Plugin load time for backend and frontend.
  * Improved: JavaScript anti-spam test.
  * Fixed: PHP warning mb_convert_encoding()

= 2.42 2014-04-29 =
  * Fixed: JavaScript anti-spam test for comments.

= 2.38 2014-03-27 =
  * Fixed: Registraion form submit time spam test.

= 2.36 2014-03-12 =
  * Reversed to patches from old revisions.

= 2.35 2014-03-12 =
  * New: Notifications about disabled account
  * New: Improved JavaScript spam test.
  * Fixed: Code optimization
  * Fixed: JavaScript test for signups.

= 2.33 2014-02-12 =
  * Fixed: CURLOPT_FOLLOWLOCATION bug at admin notice

= 2.32 2014-02-04 =
  * New: Added notice about automatically approved comment. The notice shows only for first approved comment and only for new commentators (without approved comments) of the blog.
  * New: At WordPress console added banner for notices.
  * Changed: Screenshots updated.
